/*
ionic auto update 2.0.0

update the ionic app bypass app store

require an interface from server to get manifest
require a www/manifest.json when publish the app
manifest:{
  "path to some file":"MD5 of some file"
}
*/

angular
  .module('bootstrap', ['ngCordova'])
  .run(function($cordovaFile, $cordovaFileTransfer, $cordovaNetwork, $timeout, $http, $q, $cordovaDevice, $cordovaDialogs, $cordovaProgress) {
    document.addEventListener('deviceready', function() {
      var app_version = '3.4.0', //current app version for controling removement of Documents/www/
        localStorageAppVersion = 'bj12351.app_version', //the key of localStorage for app version
        /**正式**/
        download_url = 'http://appdl.bjzgh12351.org/download/app_3.4/', //where is the Documents downloaded from
        check_url = 'http://app.bjzgh12351.org/mobile_3.4/api/system/check-update.jsp',
        // check_url = 'http://app.bjzgh12351.org/mobile_3.4/api/system/get-manifest.jsp', //获取mainfest.json的内容，每次更新界面文件都需重新获取

        /**培训**/
        // download_url = 'http://apppx.bjzgh12351.org/mobile/app/', //where is the Documents downloaded from
        // check_url = 'http://apppx.bjzgh12351.org/mobile/api/system/get-manifest.jsp', //调试时使用
        // check_url = 'http://apppx.bjzgh12351.org/mobile/api/system/check-update.jsp', //发布时使用，需同步服务器端filemd5.txt文件

        localStorageManifest = 'bj12351.manifest', //the key of localStorage for manifest
        localStorageTemplatesUrl = 'bj12351.filepath', //the key of localStorage for templates

        documentsDirectory = ($cordovaDevice.getPlatform() === 'iOS' ? (cordova.file.documentsDirectory + 'NoCloud/') : cordova.file.dataDirectory), //the Documents directory

        fileTotal = 0, //需要下载的文件总数
        fileDowned = 0, //已下载的文件总数
        //android的进度条插件 cordova plugin add https://github.com/SidneyS/cordova-plugin-progressview.git
        ProgressView = window.plugins.ProgressView,
        //app的自动退出插件 lbywer
        app = window.plugins.app;

      /**退出app**/
      function exitApp() {
        app.exit({
          "platform": $cordovaDevice.getPlatform()
        });
      }

      /**加载js文件**/
      function loadJS(url) {
        var q = $q.defer();
        var head = document.getElementsByTagName('head')[0];
        var domScript = document.createElement('script');
        domScript.src = url;
        domScript.onload = domScript.onreadystatechange = function() {
          if (!this.readyState || 'loaded' === this.readyState || 'complete' === this.readyState) {
            q.resolve();
            this.onload = this.onreadystatechange = null;
            //this.parentNode.removeChild(this);
          }
        };
        head.appendChild(domScript);
        return q.promise;
      }

      /**同步加载**/
      function syncload(path, data) {
        var head = document.getElementsByTagName('head')[0];
        var el, src;
        var promise_list = [];
        var files_list = [];
        for (src in data) {
          if (!src) return;
          if (src.substr(-3) === ".js" && src.indexOf('.module.js') < 0) {
            files_list.push(src);
            continue;
          }
          // Ensure the 'src' has no '/' (it's in the root already)
          if (src[0] === '/') src = src.substr(1);
          // Load javascript
          if (src.substr(-3) === ".js") {
            promise_list.push(loadJS(path + src));
          } else if (src.substr(-4) === ".css") {
            el = document.createElement('link');
            el.rel = "stylesheet";
            el.href = path + src;
            el.type = "text/css";

            head.appendChild(el);
          }
        }

        files_list.forEach(function(src) {
          // Ensure the 'src' has no '/' (it's in the root already)
          if (src[0] === '/') src = src.substr(1);
          promise_list.push(loadJS(path + src));
        });
        return $q.all(promise_list);
      }

      /**加载文件**/
      function loadScripts(path, data) {
        syncload(path, data).then(function() {
          angular.bootstrap(document.body, ['bj12351']);
        }, function(err) {
          console.log("err", err);
        });
      }

      /**检查文件**/
      function checkFile(path) {
        var q = $q.defer();
        $cordovaProgress.showSimpleWithLabel(false, "加载中...");
        localStorage.setItem(localStorageTemplatesUrl, path);
        $cordovaFile.checkDir(documentsDirectory, 'www').then(function(success) {
          if (localStorage.getItem(localStorageAppVersion) != app_version) {
            $cordovaFile.removeRecursively(documentsDirectory, 'www').then(function(success) {
              localStorage.removeItem('bj12351.token');
              $cordovaFile.copyDir(cordova.file.applicationDirectory, 'www', documentsDirectory, 'www').then(function(success) {
                q.resolve(success);
              }, function(err) {
                q.reject(err);
              });
            }, function(err) {
              q.reject(err);
            });
          } else {
            q.resolve(success);
          }
          localStorage.setItem(localStorageAppVersion, app_version);
        }, function(error) {
          $cordovaFile.copyDir(cordova.file.applicationDirectory, 'www', documentsDirectory).then(function(success) {
            localStorage.setItem(localStorageAppVersion, app_version);
            q.resolve(success);
          }, function(err) {
            q.reject(err);
          });
        });
        return q.promise;
      }

      /**获取更新列表**/
      function getUpdateList(remote_manifest, path) {
        var q = $q.defer();
        var promise_list = [];
        var manifest = {};
        var update_size = 0;
        $http.get('manifest.json').success(function(data) {
          if (localStorage.getItem(localStorageManifest)) {
            manifest = JSON.parse(localStorage.getItem(localStorageManifest));
          } else {
            manifest = data.manifest;
          }
        }).error(function(err) {
          if (localStorage.getItem(localStorageManifest)) {
            manifest = JSON.parse(localStorage.getItem(localStorageManifest));
          }
        }).finally(function() {
          for (var key in remote_manifest) {
            if (!(key in manifest) || manifest[key].md5 !== remote_manifest[key].md5) {
              update_size += remote_manifest[key].size;
              promise_list.push(key);
            }
          }
          q.resolve({
            size: update_size,
            list: promise_list,
            path: path,
            remote_manifest: JSON.stringify(remote_manifest)
          });
        });
        return q.promise;
      }

      /**下载**/
      function update(data) {
        if ($cordovaDevice.getPlatform() === 'Android') {
          ProgressView.show("下载中", "HORIZONTAL");
        }
        var promise_list = [];
        for (var key = 0; key < data.list.length; key++) {
          promise_list.push($cordovaFileTransfer.download(download_url + data.list[key], data.path + data.list[key]).then(function(su) {
            fileDowned++;
            if ($cordovaDevice.getPlatform() === 'iOS') {
              $cordovaProgress.hide(); //隐藏上一个进度
              $cordovaProgress.showSimpleWithLabel(false, parseInt((fileDowned / fileTotal) * 100) + '%');
            } else {
              ProgressView.setProgress((fileDowned / fileTotal).toFixed(2));
            }
          }));
        }
        return $q.all(promise_list);
      }

      if ($cordovaNetwork.getNetwork() != 'none') {
        if (app_version != localStorage.getItem(localStorageAppVersion)) {
          localStorage.removeItem(localStorageManifest);
        }

        /**启动app**/
        $cordovaProgress.showSimpleWithLabel(false, "启动中...");

        $http.get(check_url, {
            timeout: 10000
          }).then(function(success) {
            $cordovaProgress.hide(); //隐藏启动中
            var manifest = success.data.manifest;
            var path = documentsDirectory + 'www/';
            checkFile(path).then(function(success) {
              getUpdateList(manifest, path).then(function(data) {
                if (data.list.length > 0) {
                  fileTotal = data.list.length;
                  fileDowned = 0;
                  var size = (data.size / 1024 / 1024 < 1) ? (data.size / 1024).toFixed(2) + 'KB' : (data.size / 1024 / 1024).toFixed(2) + 'MB';
                  $cordovaDialogs.alert('软件有更新(' + size + ')，需要联网下载', '更新提示', '好的').then(function() {
                    $cordovaProgress.showSimpleWithLabel(false, "下载中...");
                    update(data).then(function(success) {
                        $cordovaProgress.hide();
                        if ($cordovaDevice.getPlatform() === 'Android') {
                          ProgressView.hide();
                        }
                        localStorage.setItem(localStorageManifest, data.remote_manifest);
                        $cordovaDialogs.alert('更新完成', '更新提示', '好的').then(function() {
                          localStorage.setItem('bj12351.need_reload', true);
                          loadScripts(path, manifest);
                        });
                      }, function(err) {
                        $cordovaDialogs.alert('更新下载失败，请换个网络环境重新更新', '更新提示', '好的').then(function() {
                          exitApp();
                        });
                      })
                      .finally(function() {
                        $cordovaProgress.hide();
                        if ($cordovaDevice.getPlatform() === 'Android') {
                          ProgressView.hide();
                        }
                      });
                  });
                } else {
                  if (localStorage.getItem(localStorageManifest)) {
                    loadScripts(path, JSON.parse(localStorage.getItem(localStorageManifest)));
                  } else {
                    $http.get('manifest.json').success(function(data) {
                      loadScripts(path, data.manifest);
                    });
                  }
                }
              }, function(err) {
                $cordovaDialogs.alert('现在参与活动人数较多，请耐心等候或稍后再试', '更新提示', '好的').then(function() {
                  exitApp();
                });
              });
            }, function(err) {
              $cordovaDialogs.alert('现在参与活动人数较多，请耐心等候或稍后再试', '更新提示', '好的').then(function() {
                exitApp();
              });
            });
          }, function(err) {
            $cordovaDialogs.alert('现在参与活动人数较多，请耐心等候或稍后再试', '更新提示', '好的').then(function() {
              exitApp();
            });
          })
          .finally(function() {
            $cordovaProgress.hide();
          });
      } else {
        $cordovaDialogs.alert('检测到手机尚未联网，app不能正常使用，请您打开网络连接', '更新提示', '好的').then(function() {
          exitApp();
        });
      }

    }, false);
  });
angular.bootstrap(document.head, ['bootstrap']);
