(function() {
  'use strict';

  angular
    .module('ads')
    .controller('AdsCtrl', AdsCtrl);

  AdsCtrl.$inject = ['$scope', '$state', '$interval', '$location', '$ionicLoading', '$cordovaInAppBrowser', '$cordovaDialogs', 'adsService'];

  function AdsCtrl($scope, $state, $interval, $location, $ionicLoading, $cordovaInAppBrowser, $cordovaDialogs, adsService) {
    //广告打开链接
    $scope.open = function(url) {
      $cordovaInAppBrowser.open(url, '_blank');
    };
    $scope.srcset = '';
    $scope.ads = {};
    $scope.ads_time = {};
    $scope.ads_time.i = 5;
    var interval = $interval(function() {
      if ($scope.ads_time.i - 1 > 0) {
        $scope.ads_time.i--;
        return $scope.ads_time.i;
      } else {
        $interval.cancel(interval);
        $location.path('/tab/home');
      }
    }, 1000);

    $scope.toHome = function() {
      $interval.cancel(interval);
      $location.path('/tab/home');
    };

    // function getSrcset(url) {
    //   if (url === undefined || url === "") {
    //     return "";
    //   }
    //   var name = url.substring(0, url.length - 4);
    //   var extension = url.substr(-4, 4);
    //   var result = url + ' 320w,' + name + '@2x' + extension + ' 640w';
    //   return result;
    // }


    $scope.ads = adsService.getAds(); //获取缓冲区的广告
    $scope.refresh = function() {
      adsService.refreshAds().then(function(data) {
          if (data.errcode !== undefined && data.errcode !== 0) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            return;
          }
          $scope.ads = data;
          //  $scope.srcset = getSrcset($scope.ads[0].img);

        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };
    $scope.refresh();
  }
})();
