(function() {
  'use strict';

  angular
    .module('ads')
    .factory('adsService', adsService);

  adsService.$inject = ['$http', 'API', '$q', '$ionicLoading'];

  function adsService($http, API, $q, $ionicLoading) {
    var ads = JSON.parse(localStorage.getItem('bj12351.ads')) || [];
    return {
      getAds: function() {
        return ads;
      },
      refreshAds: function() {
        var q = $q.defer();
        $http.get(API.getPortalBjzghHost() + '/ads/ads.jsp', {
            timeout: 10000
          })
          .success(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '目前没有图片',
                  duration: 1000
                });
              }
              ads = data;
              localStorage.setItem('bj12351.ads', JSON.stringify(data));
            }
            q.resolve(data);
          })
          .error(function(error) {
            q.reject(error);
          });
        return q.promise;
      }
    };
  }
})();
