(function() {
  'use strict';

  angular
    .module('bj12351')
    .config(function($urlRouterProvider, $ionicConfigProvider, $cordovaInAppBrowserProvider) {
      $ionicConfigProvider.views.maxCache(5).forwardCache(true);
      $ionicConfigProvider.backButton.text("").previousTitleText(false);
      $ionicConfigProvider.platform.android.scrolling.jsScrolling(false);
      $ionicConfigProvider.platform.android.tabs.style('ios').position('bottom');
      $ionicConfigProvider.navBar.alignTitle('center');
      $ionicConfigProvider.backButton.icon('ion-android-arrow-back');
      $ionicConfigProvider.views.swipeBackEnabled(false);
      $ionicConfigProvider.scrolling.jsScrolling(true); //允许缩放

      var defaultOptions = {
        location: 'no',
        clearcache: 'no',
        toolbar: 'yes',
        closebuttoncaption: '关闭',
        hardwareback: 'yes',
        toolbarposition: 'bottom'
      };
      $cordovaInAppBrowserProvider.setDefaultOptions(defaultOptions);
      var token = localStorage.getItem("bj12351.token");
      if(localStorage.getItem("bj12351.platform") == 'android'){
        if (localStorage.getItem('bj12351.third') == 'true') {
          if (token != null && token != "") {
            $urlRouterProvider.otherwise('/tab/oauth');
          } else {
            $urlRouterProvider.otherwise('/tab/oauthLogin');
          }
        } else {
          if (localStorage.getItem('bj12351.need_ads') == 'true') {
            $urlRouterProvider.otherwise('/ads'); //跳转到广告页
          } else {
            $urlRouterProvider.otherwise('/tab/home'); //跳转到home页
          }
        }
      }else{
        if (localStorage.getItem('bj12351.need_ads') == 'true') {
          $urlRouterProvider.otherwise('/ads'); //跳转到广告页
        } else {
          $urlRouterProvider.otherwise('/tab/home'); //跳转到home页
        }
      }
      
    })

    .config(function httpConfig($httpProvider) {
      $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
      var param = function(obj) {
        var query = '',
          name, value, fullSubName, subName, subValue, innerObj, i;

        for (name in obj) {
          value = obj[name];

          if (value instanceof Array) {
            for (i = 0; i < value.length; i++) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          } else if (value !== undefined && value !== null)
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }

        return query.length ? query.substr(0, query.length - 1) : query;
      };

      $httpProvider.defaults.transformRequest = [function(data) {
        return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
      }];

      $httpProvider.interceptors.push(function($q) {
        return {
          // optional method
          'request': function(config) {
            // do something on success
            return config;
          },

          // optional method
          'requestError': function(rejection) {
            // do something on error
            console.log(rejection);
            return $q.reject(rejection);
          },

          // optional method
          'response': function(response) {
            // do something on success
            return response;
          },

          // optional method
          'responseError': function(rejection) {
            // do something on error
            return $q.reject(rejection);
          }
        };
      });
    });

})();
