// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular
  .module('bj12351')
  .run(function($rootScope, $ionicPlatform, $state, $cordovaDialogs, $cordovaSplashscreen, $location, $ionicHistory, $ionicScrollDelegate, $cordovaDevice) {
    $ionicPlatform.ready(function() {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false); //iOS-select显示确定按钮
        cordova.plugins.Keyboard.disableScroll(true);
      }

      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        // StatusBar.styleDefault();
        StatusBar.backgroundColorByHexString("#ef473a");

        if (window.cordova && ionic.Platform.isIOS()) {
          window.addEventListener("statusTap", function() {
            $ionicScrollDelegate.scrollTop(true);
          });
        }
      }

      //S lbywer 20190308 oncreate
      document.addEventListener('deviceready', function() {
        if ($cordovaDevice.getPlatform() === 'iOS') {
          setTimeout(function() {
            var url = localStorage.getItem('bj12351.third_url');
            if (url != null && url != "" && url.indexOf("&secret=") > -1) {
              var token = localStorage.getItem('bj12351.token');
              var appId = url.substring(url.indexOf("=") + 1, url.indexOf("&"));
              var secret = url.substring(url.lastIndexOf("=") + 1, url.length);

              localStorage.setItem("bj12351.third_appId", appId);
              localStorage.setItem("bj12351.third_secret", secret);
              if (url != "" && url != null && url.indexOf("&secret=") > -1) {
                if (token != null && token != "") {
                  $state.go('tab.oauth');
                } else {
                  $state.go('tab.oauthLogin');
                }
              }
              localStorage.removeItem('bj12351.third_url');
            }
          }, 50);
        }
      }, false);
      //E lbywer 20190308 oncreate

      //S lbywer 20190308 resume
      document.addEventListener("resume", function() {
        if ($cordovaDevice.getPlatform() === 'iOS') {
          var url = localStorage.getItem('bj12351.third_url');
          if (url != null && url != "" && url.indexOf("&secret=") > -1) {
            setTimeout(function() {
              var token = localStorage.getItem('bj12351.token');
              var appId = url.substring(url.indexOf("=") + 1, url.indexOf("&"));
              var secret = url.substring(url.lastIndexOf("=") + 1, url.length);

              localStorage.setItem("bj12351.third_appId", appId);
              localStorage.setItem("bj12351.third_secret", secret);

              if (url != "" && url != null && url.indexOf("&secret=") > -1) {
                if (token != null && token != "") {
                  $state.go('tab.oauth');
                } else {
                  $state.go('tab.oauthLogin');
                }
              }
              localStorage.removeItem('bj12351.third_url');
            }, 0);
          }
        }
      }, false);
      //E lbywer 20190308 resume


      /**极光推送**/
      if (window.plugins && window.plugins.jPushPlugin) {
        var JPush = window.plugins.jPushPlugin;
        JPush.resetBadge(); //清除角标

        //iOS退出应用时清除角标
        document.addEventListener('resign', function() {
          JPush.setApplicationIconBadgeNumber(0);
          JPush.resetBadge(); //清除角标
        });

        //获取注册id
        var getRegistrationID = function() {
          JPush.getRegistrationID(onGetRegistrationID);
        };

        //监听获取注册id事件
        var onGetRegistrationID = function(data) {
          try {
            localStorage.setItem('bj12351.jpush_id', data);
          } catch (exception) {
            console.log(exception);
          }
        };

        //添加首次接收到注册id监听
        document.addEventListener("jpush.receiveRegistrationId", function(event) {
          var jpushId = event.registrationId;
          if (jpushId) {
            localStorage.setItem('bj12351.jpush_id', jpushId);
          }
        }, false);

        try {
          JPush.init(); //初始化jpush
          JPush.setDebugMode(false); //设置为调试模式
          window.setTimeout(getRegistrationID, 1000); //开始获取注册id

          if (device.platform != "Android") { //清空角标
            JPush.setApplicationIconBadgeNumber(0);
          }
        } catch (exception) {
          console.log(exception);
        }
      }

      $rootScope.$on('$stateChangeStart', function(evt, toState, toParams, fromState, fromParams) {
        if (toState.name === 'tab.my') {
          if (!localStorage.getItem('bj12351.token')) {
            evt.preventDefault();
            $cordovaDialogs.confirm('您还没有登录，是否现在登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              } else if (fromState.name == 'tab.login' || fromState.name == 'tab.login-other') {
                $state.go('tab.home');
              } else {
                $ionicHistory.goBack();
              }
            });
          }
        }
      });

      $ionicPlatform.registerBackButtonAction(function(e) {
        //确定退出？
        function showConfirm() {
          $cordovaDialogs.confirm('你确定要退出应用吗？', '温馨提示', ['取消', '退出']).then(function(buttonIndex) {
            if (buttonIndex == 2) {
              ionic.Platform.exitApp();
            } else {
              return;
            }
          });
        }

        //判断页面
        if ($location.path() == '/tab/home') {
          showConfirm();
        } else if ($ionicHistory.backView()) {
          $ionicHistory.goBack();
        }

        e.preventDefault();
        return false;
      }, 101);

      if (window.cordova) {
        $cordovaSplashscreen.hide();
      }

    });
  })

  .run(function($ionicPlatform, $cordovaDialogs, $ionicLoading, $cordovaDevice, $cordovaInAppBrowser, analysisSer, codelistSer, versionSer, adsService) {
    $ionicPlatform.ready(function() {
      /**检查版本**/
      if (window.cordova) {
        versionSer.checkUpdate().then(function(needUpdate) {
          if (needUpdate) {
            $cordovaDialogs.confirm('app有新版本', '更新提示', ['现在下载']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                var url = '';
                if ($cordovaDevice.getPlatform() === 'iOS') {
                  url = 'https://itunes.apple.com/cn/app/北京工会12351/id1053336869?mt=8';
                } else {
                  url = 'http://a.app.qq.com/o/simple.jsp?pkgname=com.longser.bj12351app';
                }
                $cordovaInAppBrowser.open(url, '_system');
              }
            });
          }
        }, function(err) {});
      }

      /**同步信息**/
      analysisSer.login();

      adsService.refreshAds().then(function(data) {
          if (data.errcode === undefined && data.length > 0) {
            localStorage.setItem('bj12351.need_ads', 'true');
          } else {
            localStorage.setItem('bj12351.need_ads', 'false');
          }
        },
        function(error) {
          localStorage.setItem('bj12351.need_ads', 'false');
        });

      /**判断是否需要重获代码表**/
      if (localStorage.getItem('bj12351.need_reload') == 'true') {
        var total = localStorage.length;
        var refreshList = [];
        for (var i = 0; i < total; i++) {
          var storageName = localStorage.key(i);
          if (storageName.indexOf('bj12351.ct_') >= 0) {
            refreshList.push(storageName);
          }
        }
        for (var item in refreshList) {
          localStorage.removeItem(refreshList[item]);
        }
        localStorage.setItem('bj12351.need_reload', false);
      }

      /**获取居住类型**/
      if (!localStorage.getItem('bj12351.ct_resident_type')) {
        codelistSer.codelist('ct_resident_type').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_resident_type', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取学历**/
      if (!localStorage.getItem('bj12351.ct_education')) {
        codelistSer.codelist('ct_education').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_education', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取是否农民工**/
      if (!localStorage.getItem('bj12351.ct_migrant')) {
        codelistSer.codelist('ct_migrant').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_migrant', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取代码表失败，请稍后重试', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取就业状态**/
      if (!localStorage.getItem('bj12351.ct_work_status')) {
        codelistSer.codelist('ct_work_status').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_work_status', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取北京行政区划**/
      if (!localStorage.getItem('bj12351.ct_area_beijing')) {
        codelistSer.codelist('ct_area_beijing').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_area_beijing', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取技能等级**/
      if (!localStorage.getItem('bj12351.ct_skill')) {
        codelistSer.codelist('ct_skill').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_skill', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取活动类别**/
      if (!localStorage.getItem('bj12351.ct_project_category')) {
        codelistSer.codelist('ct_project_category').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_project_category', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取全国行政区划**/
      if (!localStorage.getItem('bj12351.ct_area')) { //weblingwu模式下的ct_area
        codelistSer.codelist('ct_area').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_area', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**获取职工之家的服务功能**/
      if (!localStorage.getItem('bj12351.ct_service_type')) {
        codelistSer.codeUnionList('ct_service_type').then(function(data) {
          if (data.errcode === undefined) {
            localStorage.setItem('bj12351.ct_service_type', JSON.stringify(data));
          } else {
            $cordovaDialogs.alert('获取数据失败，请稍后重试。', '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

    });
  });
