(function() {
  'use strict';

  angular
    .module('wydgs')
    .factory('wydgsSer', function($http, $q, API, $ionicLoading, $cordovaFileTransfer) {
      var wydgs_check = JSON.parse(localStorage.getItem('bj12351.wydgs_check')) || [];
      return {
        flfw_verify_token: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/user/verify-token.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        getWydgs: function() {
          return wydgs_check;
        },
        refreshWydgs: function(case_type2, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/flfw_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.status === 2) {
                wydgs_check = data;

                localStorage.setItem('bj12351.wydgs_check', JSON.stringify(data));
              }

              q.resolve(data);
            })
            .error(function(error) {

              q.reject(error);
            });
          return q.promise;
        },
        more: function(case_type2, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/flfw_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        //提交我要咨询页面获取数据
        wydgsdata: function(case_type2, title, ismember, name, gender, phone, address, work_ent, company_person, company_phone, work_address, content, url1, url2, url3, url4, url5) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/brands/flfw/universal/add_case.jsp', {
              token: localStorage.getItem('bj12351.token'),
              case_type2: case_type2,
              title: title,
              ismember: ismember,
              name: name,
              gender: gender,
              phone: phone,
              address: address,
              work_ent: work_ent,
              company_person: company_person,
              company_phone: company_phone,
              work_address: work_address,
              content: content,
              url_1: url1,
              url_2: url2,
              url_3: url3,
              url_4: url4,
              url_5: url5
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        wydgsdetaildata: function(case_type2, case_code) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/show_case.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&case_code=' + case_code, {
              timeout: 10000
            })
            .success(function(data) {
              // if (data.status === 2) {
              //   wydgs_check = data;

              //   localStorage.setItem('bj12351.wydgs_check', JSON.stringify(data));
              // }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        uploadPhoto: function(imageURI) {
          var q = $q.defer();
          var server = API.getHost() + '/brands/flfw/universal/upload_photo.jsp?token=' + localStorage.getItem('bj12351.token');
          var options = {
            "encodeURI": true,
            "fileKey": "file",
            "chunkedMode": false,
            "fileName": imageURI.substr(imageURI.lastIndexOf('/') + 1),
            "mimeType": "image/jpeg"
          };
          $cordovaFileTransfer.upload(server, imageURI, options).then(function(data) {
            $ionicLoading.hide();
            q.resolve(JSON.parse(data.response));
          }, function(err) {
            $ionicLoading.hide();
            q.reject();
          }, function(progress) {
            var loaded = Math.floor(parseInt((progress.loaded / progress.total) * 100));
            $ionicLoading.show({
              template: '正在上传：' + loaded + '%'
            });
          });
          return q.promise;
        }
      };

    });
})();
