(function() {
  'use strict';

  angular
    .module('wysf')
    .controller('wysfCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $stateParams, $ionicHistory, $state, $location, $cordovaCamera, templateUrlPath, wysfSer) {
      $scope.colId = $stateParams.colId;
      var page = 1,
        page_size = 10;
      $scope.hasMore = false;

      $scope.sfsearch_ipt = { //关键字搜索框
        sfsh_ipt: ''
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-right'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();

        });
      };
      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(search_sf) {
        wysfSer.wysf_getsubmit($scope.sfsearch_ipt.sfsh_ipt);
        $scope.modal[search_sf].remove();

        $state.go('tab.wysf_result');
      };



      $scope.refresh = function() {
        if ($scope.colId == undefined || $scope.colId == '') {
          return;
        }
        //if (localStorage.getItem('bj12351.token')) {
        wysfSer.refreshWysf($scope.colId, 1, page_size, $scope.sfsearch_ipt.sfsh_ipt).then(function(data) {

            if (data.status == 2) {
              if (data.json.length == undefined) {
                $ionicLoading.show({
                  template: '暂无服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.json.length < page_size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;


              $scope.wysf_col = data.json;
              $scope.wysf_col_size = data.size;
            } else if (data.status == -21) {
              $ionicLoading.show({
                //template: '暂无服务。',
                duration: 1000
              });
            } else if (data.status == -31) {
              $scope.hasMore = false;
              $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {

              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {

            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
        //  }
        // else {
        //   $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
        //     if (buttonIndex == 1) {
        //       if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
        //         $state.go('tab.login');
        //       } else {
        //         $state.go('tab.login-other');
        //       }
        //     } else {
        //       $ionicHistory.goBack();
        //     }
        //   });
        // }
      };

      $scope.refresh();

      //获取服务列表
      $scope.doRefresh = function() {
        $scope.refresh();
      };



      $scope.more = function() {

        wysfSer.more($scope.colId, page, page_size, $scope.sfsearch_ipt.sfsh_ipt).then(function(data) {
            if (data.status == 2) {
              if (data.json.length == 0) {
                $ionicLoading.show({
                  template: '无更多服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.json.length < page_size) {
                $scope.hasMore = false;
              }
              page++;

              $scope.wysf_col = $scope.wysf_col.concat(data.json);
              $scope.wysf_col_size = data.size;

            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };


      $scope.getidTit = function(wysfcon) {

        wysfSer.wysf_getIdtit(wysfcon);
        $state.go('tab.wysf_art');

      };




    });
})();
