(function() {
  'use strict';

  angular
    .module('wysf')
    .factory('wysfSer', function($http, $q, API, $ionicLoading) {
      var wysf_col_list = JSON.parse(localStorage.getItem('bj12351.wysf_col_list')) || {};
      var wysf_condata = {},
        wysf_submit = {};
      return {
        refreshWysf: function(parent, page, page_size, keyword) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/brands/flfw/wysf/knowledge_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&parent=' + parent + '&page=' + page + '&page_size=' + page_size + '&keyword=' + keyword, {
              timeout: 10000
            })
            .success(function(data) {

              if (data.status === 2) {
                wysf_col_list = data;
                localStorage.setItem('bj12351.wysf_col_list', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {

              q.reject(error);

            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        more: function(parent, page, page_size, keyword) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/wysf/knowledge_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&parent=' + parent + '&page=' + page + '&page_size=' + page_size + '&keyword=' + keyword, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        Wysf_artdetail: function(parent, title) { //获得文章内容
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/wysf/knowledge_show.jsp?token=' + localStorage.getItem('bj12351.token') + '&parent=' + parent + '&title=' + title, {
              timeout: 10000
            })
            .success(function(data) {

              q.resolve(data);
            })
            .error(function(error) {

              q.reject(error);
            });
          return q.promise;
        },
        wysf_getIdtit: function(wysfcon) { //向文章内容页面传id,title，label;
          if (wysfcon == undefined || wysfcon == null) {
            return wysf_condata;
          } else {
            wysf_condata.parent = wysfcon.parent;
            wysf_condata.title = wysfcon.title;
            wysf_condata.label = wysfcon.label;

            return null;
          }
        },
        wysf_getsubmit: function(wysfsub) { //搜索框的数据

          if (wysfsub == undefined || wysfsub == null) {
            return wysf_submit;
          } else {
            wysf_submit.sfcon = wysfsub;
            return null;
          }



        }
      };
    });
})();
