(function() {
  'use strict';

  angular
    .module('wyzx')
    .factory('wyzxSer', function($http, $q, API, $ionicLoading) {
      var wyzx_check = JSON.parse(localStorage.getItem('bj12351.wyzx_check')) || [];

      return {
        getWyzx: function() {
          return wyzx_check;
        },
        refreshWyzx: function(case_type2, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/flfw_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {

              if (data.status == 2) {

                wyzx_check = data;
                localStorage.setItem('bj12351.wyzx_check', JSON.stringify(data));
              }

              q.resolve(data);
            })
            .error(function(error) {

              q.reject(error);
            });
          return q.promise;
        },
        more: function(case_type2, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/flfw_list_data.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        wyzxdetaildata: function(case_type2, case_code) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/flfw/universal/show_case.jsp?token=' + localStorage.getItem('bj12351.token') + '&case_type2=' + case_type2 + '&case_code=' + case_code, {
              timeout: 10000
            })
            .success(function(data) {
              // if (data.status === 2) {
              //   wydgs_check = data;

              //   localStorage.setItem('bj12351.wydgs_check', JSON.stringify(data));
              // }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        //提交我要咨询页面获取数据
        wyzxdata: function(case_type2, title, phone, address, work_ent, company_person, company_phone, work_address, content, ismember, name, gender) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/brands/flfw/universal/add_case.jsp?token=' + localStorage.getItem('bj12351.token'), {
              token: localStorage.getItem('bj12351.token'),
              case_type2: case_type2,
              title: title,
              phone: phone,
              address: address,
              work_ent: work_ent,
              company_person: company_person,
              company_phone: company_phone,
              work_address: work_address,
              content: content,
              ismember: ismember,
              name: name,
              gender: gender
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };

    });
})();
