(function() {
  'use strict';

  angular
    .module('jnzt_ztjh_detail')
    .factory('jnzt_ztjh_detailSer', function($http, API, $q, $ionicLoading) {

      return {
        codelist: function(list_name) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/codelist.jsp?list_name=' + list_name)
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        jnzt_ztjh_detaildata: function(gender, birthday, nationality, education, mobile, email, political, post_code, address, company_name, award_experience, technical_expertise, is_attend, qq_num, salary, model) { //基本信息的提交
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/brands/jnzt/add-person.jsp', {
              token: localStorage.getItem('bj12351.token'),
              gender: gender,
              birthday: birthday,
              nationality: nationality,
              education: education,
              mobile: mobile,
              email: email,
              political: political,
              post_code: post_code,
              address: address,
              company_name: company_name,
              award_experience: award_experience,
              technical_expertise: technical_expertise,
              is_attend: is_attend,
              qq_num: qq_num,
              salary: salary,
              model: model
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        choose_work_type: function(page, size, choose_year, choose_job) { //获取工种列表
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/choose-project.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size + '&choose_year=' + choose_year + '&choose_job=' + choose_job, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        choose_work_typemore: function(page, size, choose_year, choose_job) {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/choose-project.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size + '&choose_year=' + choose_year + '&choose_job=' + choose_job, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        jnzt_ztjh_workdata: function(person_id, project_id, cert_code, cert_date, train_organ_name, train_organ_address, train_hours, train_fee, identify_organ_address, identify_type, identify_fee, identify_organ_name) { //选择工种后申请表提交
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/brands/jnzt/add-job.jsp', {
              token: localStorage.getItem('bj12351.token'),
              person_id: person_id,
              project_id: project_id,
              cert_code: cert_code,
              cert_date: cert_date,
              train_organ_name: train_organ_name,
              train_organ_address: train_organ_address,
              train_hours: train_hours,
              train_fee: train_fee,
              identify_organ_address: identify_organ_address,
              identify_type: identify_type,
              identify_fee: identify_fee,
              identify_organ_name: identify_organ_name
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        choose_work_typedate: function() { //获取职工列表的所属年份
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/year-list.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        choose_work_typedatedetail: function(choose_year) { //model里面选择日期
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/brands/jnzt/choose-project.jsp?token=' + localStorage.getItem('bj12351.token') + '&choose_year=' + choose_year, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        choose_work_typekeyword: function(choose_job) { //model里面搜索工种的关键字
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/brands/jnzt/choose-project.jsp?token=' + localStorage.getItem('bj12351.token') + '&choose_job=' + choose_job, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        check_work_typekeyword: function(person_apply_id) { //查看页面的请求数据
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/edit-job-info.jsp?token=' + localStorage.getItem('bj12351.token') + '&person_apply_id=' + person_apply_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        edit_work_typedta: function(person_apply_id) { //修改页面的请求数据
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/edit-job-info.jsp?token=' + localStorage.getItem('bj12351.token') + '&person_apply_id=' + person_apply_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        jnzt_ztjh_workEditdata: function(person_apply_id, project_id, cert_code, cert_date, train_organ_name, train_organ_address, train_hours, train_fee, identify_organ_address, identify_type, identify_fee, identify_organ_name) { //修改选择工种后申请表提交
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/brands/jnzt/edit-job.jsp', {
              token: localStorage.getItem('bj12351.token'),
              person_apply_id: person_apply_id,
              project_id: project_id,
              cert_code: cert_code,
              cert_date: cert_date,
              train_organ_name: train_organ_name,
              train_organ_address: train_organ_address,
              train_hours: train_hours,
              train_fee: train_fee,
              identify_organ_address: identify_organ_address,
              identify_type: identify_type,
              identify_fee: identify_fee,
              identify_organ_name: identify_organ_name
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        jnzt_getperson_info: function() {
          var q = $q.defer();
          $http.get(API.getHost() + '/brands/jnzt/person-info.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }
      };

    });
})();
