(function() {
  'use strict';
  angular
    .module('jnzt_zwh')
    .controller('jnzt_zwhCtrl', function($scope, $state, $ionicHistory, $ionicModal, templateUrlPath, $ionicLoading, $cordovaDialogs, API, jnztZwhSer) {

      var page = 1;
      var size = 10;
      $scope.search = {};
      $scope.search.name = '';
      $scope.jnzt_zwh_list = [];
      $scope.hasMore = false;

      $scope.refresh = function() {
        jnztZwhSer.getPlanList($scope.search.name, 1, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '暂未发布。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.jnzt_zwh_list = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      $scope.more = function() {
        jnztZwhSer.getPlanList($scope.search.name, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.jnzt_zwh_list = $scope.jnzt_zwh_list.concat(data);
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };
    });
})();
