(function() {
  'use strict';

  angular
    .module('boost_plan_all')
    .controller('boostPlanAllCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $stateParams, $state, templateUrlPath, API, boostPlanAllSer) {

      var page = 1;
      var size = 10;
      $scope.search = {};
      $scope.search.name = '';
      $scope.services = [];
      $scope.title_name = '动态列表';
      var has_more = false;
      $scope.hasMore = function() {
        return has_more;
      };

      $scope.refresh = function() {
        boostPlanAllSer.getBoostPlanListAll($stateParams.columnId, $scope.search.name, 1, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.article_list.length === 0) {
                $ionicLoading.show({
                  template: '暂未发布服务动态。',
                  duration: 1000
                });
                has_more = false;
              } else if (data.article_list.length < size) {
                has_more = false;
              } else {
                has_more = true;
              }
              page = 2;

            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
            $scope.services = data.article_list;
            $scope.title_name = data.col_title;
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      $scope.more = function() {
        boostPlanAllSer.getBoostPlanListAll($stateParams.columnId, $scope.search.name, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.article_list.length === 0) {
                $ionicLoading.show({
                  template: '无更多子项目。',
                  duration: 1000
                });
                has_more = false;
              } else if (data.article_list.length < size) {
                has_more = false;
              }
              page++;
              $scope.services = $scope.services.concat(data.article_list);
              $scope.title_name = data.col_title;
            } else {
              has_more = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });

})();
