(function() {
  'use strict';

  angular
    .module('my_course')
    .controller('myCourseCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, templateUrlPath, API, myCourseSer) {
      var page = 1;
      var size = 10;
      $scope.search = {};
      $scope.search.name = '';
      $scope.myCourseList = [];
      $scope.hasMore = false;
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          myCourseSer.getMyCourseList($scope.search.name, 1, size).then(function(data) {
              if (data.errcode === undefined) {
                if (data.length === 0) {
                  $ionicLoading.show({
                    template: '暂未申请课程。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.myCourseList = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      $scope.more = function() {
        myCourseSer.getMyCourseList($scope.search.name, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多课程。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.myCourseList = $scope.myCourseList.concat(data);
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };


      function stopDefault(e) {
        if (e && e.preventDefault)
          e.preventDefault();
        else
          window.event.returnValue = false;
      }
      /**切换详情显示状态**/
      $scope.hideCourse = function(index, e) {
        stopDefault(e);
        $scope.myCourseList[index].hideDetail = !$scope.myCourseList[index].hideDetail;
      };

      /*取消报名*/
      $scope.cancel_course = function(id, e) {
        if (localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您要取消报名吗？', '温馨提示', ['取消报名', '不取消']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              myCourseSer.cancel(id).then(function(data) {
                if (data.errcode === 0) {
                  $ionicLoading.show({
                    template: '取消成功。',
                    duration: 1000
                  });
                  $scope.refresh();
                  // $ionicHistory.goBack();
                } else if (data.errcode == -1) {
                  $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                    if (buttonIndex == 1) {
                      if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                        $state.go('tab.login');
                      } else {
                        $state.go('tab.login-other');
                      }
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              });
            }
          });
        } else {
          $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };

      /*查看报名信息*/
      $scope.course = {};
      $scope.show_course = function(id) {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          //  $scope.sign_up = $scope.myCourseList[index];
          myCourseSer.show_info(id).then(function(data) {
            if (data.errcode === undefined) {
              $scope.course = data;
              $scope.openModal('xlga/sign_up_show');
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          });

        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      /*修改报名信息*/
      $scope.sign_up = {};
      $scope.edit_course = function(id) {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          //  $scope.sign_up = $scope.myCourseList[index];
          myCourseSer.show_info(id).then(function(data) {
            if (data.errcode === undefined) {
              $scope.sign_up = data;
              $scope.openModal('xlga/sign_up_edit');
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          });

        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      /*提交修改*/
      $scope.edit_course_save = function(apply_id) {
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
        if ($scope.is_submit === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.is_submit = true;
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.sign_up.phone === undefined || $scope.sign_up.phone === '') {
            $cordovaDialogs.alert('手机号不能为空！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          if ($scope.sign_up.phone !== '' && (!/^1\d{10}$/.test($scope.sign_up.phone))) {
            $cordovaDialogs.alert('请输入正确的手机号！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          // if ($scope.sign_up.email === undefined || $scope.sign_up.email === '') {
          //   $cordovaDialogs.alert('请输入合法的电子邮箱！', '温馨提示', '好的');
          //   return;
          // }
          if ($scope.sign_up.company === undefined || $scope.sign_up.company === '') {
            $cordovaDialogs.alert('单位名称不能为空！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          if ($scope.sign_up.company !== undefined && $scope.sign_up.company !== '' && $scope.sign_up.company.length > 64) {
            $cordovaDialogs.alert('单位名称字数不能超过64个字！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          myCourseSer.edit_info(apply_id, $scope.sign_up.phone, $scope.sign_up.company, $scope.sign_up.is_stay, $scope.sign_up.is_drive).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功修改培训课程申请！', '温馨提示', '好的').then(function() {
                $scope.is_submit = false;
                $scope.closeModal('xlga/sign_up_edit');
              });
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                $scope.closeModal('xlga/sign_up_edit');
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
              $scope.is_submit = false;
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              $scope.is_submit = false;
            }
          }, function() {
            $scope.is_submit = false;
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });

        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.closeModal('xlga/sign_up');
            // $location.path("/tab/login");
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      /*审批情况audit_status*/
      $scope.audit_status = {};
      $scope.show_audit_status = function(id) {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          //  $scope.sign_up = $scope.myCourseList[index];
          myCourseSer.show_audit_status(id).then(function(data) {
            if (data.errcode === undefined) {
              $scope.audit_status = data;
              $scope.openModal('xlga/audit_status');
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          });

        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };


    });
})();
