(function() {
  'use strict';
  angular
    .module('my_course')
    .factory('myCourseSer', function($http, API, $q, $ionicLoading) {
      return {
        getMyCourseList: function(course_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/course/my-course-list.jsp?course_name=' + course_name + '&page=' + page + '&size=' + size + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        //取消报名
        cancel: function(apply_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/course/cancel.jsp', {
              apply_id: apply_id,
              token: localStorage.getItem('bj12351.token')
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        show_info: function(apply_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/course/show-info.jsp?token=' + localStorage.getItem('bj12351.token') + '&apply_id=' + apply_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        edit_info: function(apply_id, phone, company, is_stay, is_drive) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/course/edit-info.jsp', {
              apply_id: apply_id,
              token: localStorage.getItem('bj12351.token'),
              phone: phone,
              company: company,
              is_stay: is_stay,
              is_drive: is_drive
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        show_audit_status: function(apply_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/course/show-audit-status.jsp?token=' + localStorage.getItem('bj12351.token') + '&apply_id=' + apply_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };
    });
})();
