(function() {
  'use strict';

  angular
    .module('training_course')
    .controller('trainingCourseCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, $cordovaInAppBrowser, templateUrlPath, API, trainingCourseSer) {
      $scope.current_tab = 1;

      var page = 1;
      var size = 10;
      $scope.search = {};
      $scope.search.name = '';
      $scope.offlineCourseList = [];
      $scope.offlineHasMore = false;
      $scope.onlineCourseList = [];
      $scope.onlineHasMore = false;

      /*线下课程*/
      $scope.offlineRefresh = function() {
        trainingCourseSer.getOfflineCourse($scope.search.name, 1, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '暂未发布课程。',
                  duration: 1000
                });
                $scope.offlineHasMore = false;
              } else if (data.length < size) {
                $scope.offlineHasMore = false;
              } else {
                $scope.offlineHasMore = true;
              }
              page = 2;
              $scope.offlineCourseList = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.offlineRefresh();

      //手动刷新
      $scope.offlineCourseRefresh = function() {
        $scope.search.name = '';
        $scope.offlineRefresh();
      };

      $scope.offLineCourseMore = function() {
        trainingCourseSer.getOfflineCourse($scope.search.name, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多课程。',
                  duration: 1000
                });
                $scope.offlineHasMore = false;
              } else if (data.length < size) {
                $scope.offlineHasMore = false;
              }
              page++;
              $scope.offlineCourseList = $scope.offlineCourseList.concat(data);
            } else {
              $scope.offlineHasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /*线上课程*/
      $scope.onlineRefresh = function() {
        trainingCourseSer.getOnlineCourse($scope.search.name, 1, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '暂未发布课程。',
                  duration: 1000
                });
                $scope.onlineHasMore = false;
              } else if (data.length < size) {
                $scope.onlineHasMore = false;
              } else {
                $scope.onlineHasMore = true;
              }
              page = 2;
              $scope.onlineCourseList = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.onlineRefresh();

      //手动刷新
      $scope.onlineCourseRefresh = function() {
        $scope.search.name = '';
        $scope.onlineRefresh();
      };

      $scope.onLineCourseMore = function() {
        trainingCourseSer.getOnlineCourse($scope.search.name, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多课程。',
                  duration: 1000
                });
                $scope.onlineHasMore = false;
              } else if (data.length < size) {
                $scope.onlineHasMore = false;
              }
              page++;
              $scope.onlineCourseList = $scope.onlineCourseList.concat(data);
            } else {
              $scope.onlineHasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };


      $scope.search_offline_course = function() {
        $scope.offlineRefresh();
      };
      $scope.search_online_course = function() {
        $scope.onlineRefresh();
      };

      function stopDefault(e) {
        if (e && e.preventDefault)
          e.preventDefault();
        else
          window.event.returnValue = false;
      }


      /**切换详情显示状态**/
      $scope.hideOnlineCourse = function(index, e) {
        stopDefault(e);
        $scope.onlineCourseList[index].hideDetail = !$scope.onlineCourseList[index].hideDetail;
      };
      $scope.hideOfflineCourse = function(index, e) {
        stopDefault(e);
        $scope.offlineCourseList[index].hideDetail = !$scope.offlineCourseList[index].hideDetail;
      };
      //打开第三方链接
      $scope.open = function(url) {
        $cordovaInAppBrowser.open(url, '_blank');
      };

      /*报名*/
      //报名前验证
      $scope.course = {};

      $scope.sign = {};
      $scope.sign.is_stay = false;
      $scope.sign.is_drive = false;

      $scope.sigh_up_verify = function(id) {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          trainingCourseSer.verify(id).then(function(data) {
            if (data.errcode === 0) {
              $scope.course = data;
              $scope.sign.phone = $scope.user.phone;
              $scope.sign.company = $scope.user.company;
              $scope.openModal('xlga/sign_up');
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦。', '温馨提示：', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      /*提交报名信息*/
      $scope.course_sign = function(course_id) {
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
        if ($scope.is_submit === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.is_submit = true;
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.sign.phone === undefined || $scope.sign.phone === '') {
            $cordovaDialogs.alert('手机号不能为空！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          if ($scope.sign.phone !== '' && (!/^1\d{10}$/.test($scope.sign.phone))) {
            $cordovaDialogs.alert('请输入正确的手机号！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          // if ($scope.sign_up.email === undefined || $scope.sign_up.email === '') {
          //   $cordovaDialogs.alert('请输入合法的电子邮箱！', '温馨提示', '好的');
          //   return;
          // }
          if ($scope.sign.company === undefined || $scope.sign.company === '') {
            $cordovaDialogs.alert('单位名称不能为空！', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }
          trainingCourseSer.reserve(course_id, $scope.sign.phone, $scope.sign.company, $scope.sign.is_stay, $scope.sign.is_drive).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功提交培训课程申请！', '温馨提示', '好的').then(function() {
                $scope.is_submit = false;
                $scope.closeModal('xlga/sign_up');
              });
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                $scope.closeModal('xlga/sign_up');
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
              $scope.is_submit = false;
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              $scope.is_submit = false;
            }
          }, function() {
            $scope.is_submit = false;
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.closeModal('xlga/sign_up');
            // $location.path("/tab/login");
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title' || modal_name == 'search_title_online') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        if (modal_name == 'search_title') {
          $scope.offlineRefresh();
        } else if (modal_name == 'search_title_online') {
          $scope.onlineRefresh();
        }
        $scope.modal[modal_name].remove();
      };


    });
})();
