(function() {
  'use strict';
  angular
    .module('training_course')
    .factory('trainingCourseSer', function($http, API, $q, $ionicLoading) {
      return {
        getOfflineCourse: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/course/offline-course-list.jsp?service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        getOnlineCourse: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/course/online-course-list.jsp?service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        verify: function(course_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.get(API.getHost() + '/course/verify.jsp?course_id=' + course_id + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        reserve: function(course_id, phone, company, is_stay, is_drive) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/course/reserve.jsp', {
              course_id: course_id,
              token: localStorage.getItem('bj12351.token'),
              phone: phone,
              company: company,
              is_stay: is_stay,
              is_drive: is_drive
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };
    });
})();
