(function() {
  'use strict';

  angular
    .module('ylhzPayment')
    .controller('ylhzPaymentCtrl', function($scope, $state, $location, $ionicLoading, $cordovaDialogs, ylhzPaymentSer) {
      $scope.user = ylhzPaymentSer.getUser();
      $scope.payments = undefined;//给付列表 默认值设为"undefined"是为了默认显示空而不是显示“未参加XXX”文字

      /**刷新**/
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          ylhzPaymentSer.refreshUser().then(function(data) {
            if (data.errcode == undefined) {
              $scope.user = data;
            }
          });
          ylhzPaymentSer.refreshPayments().then(function(data) {
              if (data.errcode == undefined) {
                $scope.payments = data;
              } else if (data.errcode == -1) {
                $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };
      $scope.refresh();

      /**地址切换**/
      $scope.toPath = function(path) {
        if (localStorage.getItem('bj12351.token')) {
          $location.path(path);
        } else {
          $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

    });
})();
