 (function() {
   'use strict';

   angular
     .module('ylhzPayment')
     .factory('ylhzPaymentSer', function($http, $q, API, $ionicLoading) {
       var hzbz_user = JSON.parse(localStorage.getItem('bj12351.hzbz_user')) || {};

       return {
         getUser: function() {
           return hzbz_user;
         },

         refreshUser: function() {
           var q = $q.defer();
           $http.get(API.getHost() + '/insurance/info.jsp' +
               '?token=' + localStorage.getItem('bj12351.token'), {
                 timeout: 10000
               })
             .success(function(data) {
               if (data.errcode == undefined) {
                 hzbz_user = data;
                 localStorage.setItem('bj12351.hzbz_user', JSON.stringify(data));
               }
               q.resolve(data);
             })
             .error(function(error) {
               q.reject(error);
             });
           return q.promise;
         },

         refreshPayments: function() {
           var q = $q.defer();
           $ionicLoading.show({
             template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
           });
           $http.get(API.getHost() + '/insurance/ylhz_payment.jsp' +
               '?token=' + localStorage.getItem('bj12351.token'), {
                 timeout: 10000
               })
             .success(function(data) {
               q.resolve(data);
             })
             .error(function(error) {
               q.reject(error);
             })
             .finally(function() {
               $ionicLoading.hide();
             });
           return q.promise;
         }
       };
     });
 })();
