(function() {
  'use strict';

  angular
    .module('ylhzPaymentDetail')
    .controller('ylhzPaymentDetailCtrl', function($scope, $ionicLoading, $stateParams, $cordovaDialogs, $ionicModal, templateUrlPath, ylhzPaymentSer, ylhzPaymentDetailSer) {
      $scope.user = ylhzPaymentSer.getUser();
      $scope.inspects = undefined; //默认值设为"undefined"是为了默认显示空而不是显示“未参加XXX”文字
      var year = $stateParams.year;

      /**刷新**/
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          ylhzPaymentDetailSer.refreshIns(year).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂无记录',
                    duration: 1000
                  });
                }
                $scope.inspects = data;
              } else if (data.errcode == -1) {
                $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };
      $scope.refresh();
      
    });
})();
