(function() {
  'use strict';

  angular
    .module('exam_price')
    .controller('examPriceCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, $stateParams, templateUrlPath, API) {
      $scope.exam_price_list = [{
        id: 1,
        category: "血常规（18项）",
        content: "有无贫血、验证、血液病等",
        price: '20.00'
      }, {
        id: 2,
        category: "尿常规",
        content: "有无泌尿系统疾病、糖尿病等",
        price: '6.00'
      }, {
        id: 3,
        category: "血糖",
        content: "血糖GLU:有否糖尿病及糖耐量改变",
        price: '4.00'
      }, {
        id: 4,
        category: "肺功能",
        content: "可早期发现肺功能损伤",
        price: '135.00'
      }, {
        id: 5,
        category: "腰椎CT",
        content: "腰椎盘病变（脱出、突出和肿瘤等）",
        price: '286.00'
      }, {
        id: 6,
        category: "头颅CT",
        content: "可出外脑瘤、脑梗塞等",
        price: '162.00'
      }];
      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        // $scope.refresh();
        $scope.modal[modal_name].remove();
      };


    });
})();
