(function() {
  'use strict';

  angular
    .module('examination_booking')
    .controller('examinationBookingCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, templateUrlPath, API) {
      $scope.medical_notice = '<p>体检前 </p> <p> 1、 请您体检前电话预约（ 北京地区预约电话010－ 67766888， 其它地区预约电话详见ciming.com及慈铭各分公司网站）， 已签约网上预约服务的单位， 请登录book.ciming.com进行网上预约。 </p> <p> 2、 到达体检中心时间： 08: 00--10: 30， 体检当日请携带本人身份证原件（ 仅限身份证、 护照、 军官证、 士官证、 驾驶证）。 </p> <p> 3、 体检前一天， 请您清淡饮食、 勿饮酒、 勿劳累。 体检当天请空腹、 禁食、 禁水、 勿服药（ 降糖、 降压药除外）。 </p> <p> 4、 体检当天请不要佩戴金属饰物， 勿携带贵重物品。 </p> <p> 5、 体检当日清晨可提前留置尿、 便标本， 也可体检结束后留置。 </p> <p> 6、 女性客人请避开月经期， 体检当日请勿穿着连体类衣物及长筒靴。 </p> <p> 7、 胃镜检查必须安排在上腹部CT检查前完成。 非接触眼压检查时勿戴隐形眼镜。 </p> <p> 8、 特别提醒： 未婚女性不做妇科和阴道超声检查。 若本人有性生活史、 自愿申请上述两项检查， 请本人签署知情同意书。 </p> <p> 9、 为保障您和他人健康， 当您患有上呼吸道传染性的疾病， 请痊愈后择期参检。 </p>';

      $scope.booking = {};
      $scope.exam_booking_verify = function() {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.openModal('exam_booking');
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      $scope.exam_booking = function() {
        if ($scope.booking.booking_date === '' || $scope.booking.booking_date === undefined) {
          $cordovaDialogs.alert('请填写预约时间！', '温馨提示', '好的');
          return;
        }
        if ($scope.booking.booking_hospital === '' || $scope.booking.booking_hospital === undefined) {
          $cordovaDialogs.alert('请填写预约分院！', '温馨提示', '好的');
          return;
        }
        $cordovaDialogs.alert('预约成功，请您准时到达相应分院进行体检！', '温馨提示', '好的').then(function() {
          $scope.submitModal('exam_booking');
        });
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        // $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
