(function() {
  'use strict';

  angular
    .module('medicine_price')
    .controller('medicinePriceCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, $stateParams, templateUrlPath, API) {
      $scope.medicine_price_list = [{
        id: 1,
        category: "999牌感冒灵颗粒",
        name: "感冒灵颗粒",
        number: "国药准字Z44021940",
        company: "华润三九医药股份有限公司",
        effect: "解热镇痛。用于感冒引起的头痛，发热，鼻塞，流涕，咽痛。",
        norms: "10g*9袋/盒",
        price: '20.00'
      }, {
        id: 2,
        category: "开瑞坦(氯雷他定片)",
        name: "	开瑞坦(氯雷他定片)",
        number: "国药准字H10970410",
        company: "上海先灵葆雅制药有限公司",
        effect: "	用于缓解过敏性鼻炎有关的症状，如喷嚏、流涕、鼻痒、鼻塞以及眼部痒及烧灼感。",
        norms: "10g*6片/盒",
        price: '19.36'
      }, {
        id: 3,
        category: "抗病毒口服液",
        name: "抗病毒口服液",
        number: "国药准字Z14021194",
        company: "山西太行药业股份有限公司",
        effect: "清热祛湿，凉血解毒。用于风热感冒，流感。",
        norms: "10ml*10支",
        price: '20.00'
      }, {
        id: 4,
        category: "健胃消食片",
        name: "健胃消食片",
        number: "国药准字Z36021464",
        company: "江中药业股份有限公司",
        effect: "健胃消食。用于脾胃虚弱所致的食积，症见不思饮食、嗳腐酸臭、脘腹胀满；消化不良见上述证候者。",
        norms: "0.5g*36片/盒",
        price: '8.50'
      }];
      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_title') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        // $scope.refresh();
        $scope.modal[modal_name].remove();
      };


    });
})();
