(function() {
  'use strict';

  angular
    .module('home')
    .controller('homeCtrl', function($scope, $state, $cordovaDialogs, $cordovaInAppBrowser, $ionicLoading, $ionicModal, $location, $ionicPopup, $cordovaDevice, homeSer, scanBarcodeSer, templateUrlPath, serviceSer, myServiceSer, geoLocationSer) {
      $scope.token = localStorage.getItem('bj12351.token');
      $scope.bannerList = homeSer.getBannerList();
      $scope.services = homeSer.getCrossList();

      /**
       * 进入121网页版
       */
      $scope.toOpen121 = function() {
        if (!localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        } else {
          var url = "http://120.131.4.28:8080/jianbu/console/regeistinfo.do?idcard=" + localStorage.getItem("bj12351.id_card");
          if ($cordovaDevice.getPlatform() === 'iOS') {
            $cordovaInAppBrowser.open(url, '_blank');
          } else {
            cordova.ThemeableBrowser.open(url, '_blank', {
              statusbar: {
                color: 'white'
              },
              toolbar: {
                height: 44,
                color: '#f0f0f0ff'
              },
              title: {
                color: '#003264ff',
                showPageTitle: false
              },
              closeButton: {
                image: 'close_pressed',
                imagePressed: 'close_pressed',
                align: 'left',
                event: 'closePressed'
              },
              menu: {
                image: 'menu_pressed',
                imagePressed: 'menu_pressed',
                title: 'Test',
                cancel: 'Cancel',
                align: 'right',
                items: [{
                  event: 'downloadPressed',
                  label: '下载健步121'
                }]
              },
              backButtonCanClose: true
            }).addEventListener('downloadPressed', function(e) {
              window.open("https://a.app.qq.com/o/simple.jsp?pkgname=com.bjzgh.jb121", "_system");
            }).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function(e) {
              console.error(e.message);
            }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function(e) {
              console.log(e.message);
            });
          }
        }
      }

      /**轮播图**/
      homeSer.refreshBanner().then(function(data) {
        if (data.errcode == 0 || data.errcode == undefined) {
          $scope.bannerList = data;
        }
      });

      /**轮播图设置**/
      $scope.banner = {
        options: {
          autoplay: 3000,
          loop: true,
          speed: 700,
          autoplayDisableOnInteraction: false
        }
      };

      /**查看banner详情**/
      $scope.toService = function(obj, type) {
        if (obj.is_special !== null && obj.is_special == 2) {
          if (!localStorage.getItem('bj12351.token')) {
            $cordovaDialogs.confirm('您还没有登录，是否现在登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else {
            $scope.toStateService(obj, type);
          }
        } else {
          $scope.toStateService(obj, type);
        }
      };

      $scope.toStateService = function(obj, type) {
        if (type == 'banner') {
          if (obj.service_id != undefined) {
            $location.path('/tab/service/' + obj.service_id + '/detail');
          } else if (obj.project_id != undefined) {
            $location.path('/tab/service/' + obj.project_id + "/0/batch");
          }
        } else if (type == 'service') {
          if (obj.is_project) {
            $location.path('/tab/service/' + obj.id + "/0/batch");
          } else {
            $location.path('/tab/service/' + obj.id + '/detail');
          }
        }
      };

      /**首页通知**/
      var page = 1;
      var size = 10;
      var orgId = 0;
      var fillAry = [{
        title: '系统消息',
        content: '欢迎使用北京工会12351手机APP',
        publish_time: ''
      }, {
        title: '系统消息',
        content: '暂无消息',
        publish_time: ''
      }];

      $scope.hasMore = false;
      $scope.notices = homeSer.getNoticeList();

      /**刷新通知列表**/
      $scope.refreshNoticeList = function(backdrop) {
        homeSer.refreshNoticeList(1, size, orgId, backdrop).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length < 2) {
                $scope.hasMore = false;
                $scope.notices = data.concat(fillAry);
                return;
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.notices = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };

      /**手动刷新通知列表**/
      $scope.doRefreshNoticeList = function() {
        $scope.refreshNoticeList(false);
      };

      /**更多通知列表**/
      $scope.moreNoticeList = function(backdrop) {
        homeSer.refreshNoticeList(page, size, orgId, backdrop).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.notices = $scope.notices.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**打开第三方链接**/
      $scope.open = function(url) {
        console.log(url);
        $cordovaInAppBrowser.open(url, '_blank');
      };

      /**首页搜索框**/
      $scope.search = {};
      $scope.search.name = '';
      var oldSearch = ''; //上一次搜索内容

      /**搜索服务项目**/
      $scope.doSearch = function() {
        serviceSer.setSearchName($scope.search.name);
        var needRefresh = 0;
        if (oldSearch != $scope.search.name) {
          oldSearch = $scope.search.name;
          needRefresh = 1;
        }
        $location.path('/tab/service/' + needRefresh);
      };

      /**跳转路由**/
      $scope.toState = function(state) {
        if (state == 'tab.third_service') {
          if (!localStorage.getItem('bj12351.token')) {
            $cordovaDialogs.confirm('您还没有登录，是否现在登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else {
            $state.go(state);
          }
        } else if (state == 'tab.map') { //职工之家跳转路由之前先重定位获取当前定位
          geoLocationSer.reLocated();
          $state.go(state);
        } else {
          $state.go(state);
        }
      };

      /**我要入会**/
      $scope.joinUnion = function() {
        if (!!localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您已是会员，此功能主要为非会员提供，是否继续？', '温馨提示', ['是', '否'])
            .then(function(buttonIndex) {
              if (buttonIndex == 1) {
                $state.go('tab.joinUnion');
              }
            });
        } else {
          $state.go('tab.joinUnion');
        }
      };

      /**扫一扫**/
      $scope.scanBarcode = function() {
        scanBarcodeSer.scan();
      };

      /**显示我的二维码**/
      $scope.showMyQR = function() {
        if (!localStorage.getItem('bj12351.token')) {
          if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
            $state.go('tab.login');
          } else {
            $state.go('tab.login-other');
          }
          return;
        } else {
          console.log(111);
          $scope.openModal('show_qrcode');
        }
      };

      /**服务项目点赞**/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];
        if ($scope.service_likes.has_likes === true) { //取消点赞
          //$scope.show_likes = false;
        } else if ($scope.service_likes.has_likes === undefined || $scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else if (data.errcode == -1) {
                  $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            });
          }
        }
      };

      /**绑定设备**/
      var ignore = localStorage.getItem('bj12351.ignore') == 'true' ? true : false; //是否不再提示

      //点击不再提示
      $scope.doIgnore = function() {
        ignore = !ignore;
        localStorage.setItem('bj12351.ignore', ignore);
      };

      //初始化极光
      $scope.initJpush = function() {
        if (window.plugins && window.plugins.jPushPlugin) {
          var JPush = window.plugins.jPushPlugin;

          if ($cordovaDevice.getPlatform() === 'iOS') {
            JPush.resumePush();
          } else {
            JPush.init();
          }

          JPush.getRegistrationID(function(data) {
            try {
              if (data) {
                localStorage.setItem('bj12351.jpush_id', data); //jpushId
                $scope.bindJpush();
              }
            } catch (exception) {
              console.log(exception);
            }
          });
        }
        $scope.myPopup.close();
      };

      //绑定极光
      $scope.bindJpush = function() {
        homeSer.bindJpush().then(function(rst) {
          if (rst.errcode == 0) {
            localStorage.setItem('bj12351.ignore', true); //是否不再提示
            localStorage.setItem('bj12351.binded', true); //是否已绑定
          }
        });
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        console.log(1);
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        console.log(2);
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'notice') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          if (modal_name == 'modify_pwd') {
            $scope.modify.oldpwd = '';
            $scope.modify.newpwd = '';
            $scope.modify.cfmpwd = '';
          } else if (modal_name == 'notice') {
            $scope.refreshNoticeList(true);
          }
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };





      /**
       * 用户协议
       */
      $scope.userProtocol = function() {
        // $state.go('tab.protocol_user');
        $location.path('/tab/protocol/21805/detail');
        $scope.myPopup1.close();
      };

      /**
       * 隐私协议
       */
      $scope.privacyProtocol = function() {
        $location.path('/tab/protocol/21803/detail');
        // $state.go('tab.protocol_user');
        $scope.myPopup1.close();
      };

      /**退出app**/
      $scope.exitApp = function() {
        var app = window.plugins.app;
        app.exit({
          "platform": $cordovaDevice.getPlatform()
        });
      };

      /*检查是否同意过隐私协议和用户协议 */
      $scope.checkIsAgree = function() {
        var u = navigator.userAgent;
        var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
        var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端

        isAndroid = true;
        if (isAndroid == true) {
          var is_agree = localStorage.getItem('bj12351.is_agree'); //是否同意隐私政策和用户协议
          if (is_agree != null && is_agree != "" && is_agree != true) {
            return;
          } else {
            $scope.myPopup1 = $ionicPopup.show({
              template: '<div style="font-size: 15px; margin: 0 0 10px 0;">请你务必审慎阅读、理解“服务协议”和“隐私协议”的各条款。你可点击<span style="color:blue;text-decoration:underline;" ng-click="userProtocol()">《用户协议》</span>和<span style="color:blue;text-decoration:underline;" ng-click="privacyProtocol()">《隐私协议》</span>按钮了解详细信息。如你同意，请点击“同意”开始接受我们的服务。</div>',
              title: '<span style="font-size:17px;">服务协议与隐私协议</span>',
              scope: $scope,
              buttons: [{
                text: '暂不使用',
                onTap: function() {
                  ionic.Platform.exitApp();
                }
              }, {
                text: '同意',
                type: 'button-assertive',
                onTap: function(e) {
                  e.preventDefault();
                  localStorage.setItem('bj12351.is_agree', true);
                  $scope.myPopup1.close();
                }
              }]
            });
          }
        }
      };



      /**界面监听方法**/
      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.checkIsAgree();

        $scope.token = localStorage.getItem('bj12351.token'); //解决token不同步问题
        if ($scope.token) {
          orgId = JSON.parse(localStorage.getItem('bj12351.user')).org_id;
        }

        $scope.search.name = ""; //清除历史关键字

        homeSer.refreshBanner().then(function(data) { //刷新banner
          if (data.errcode == undefined) {
            $scope.bannerList = data;
          }
        });

        homeSer.refreshCrossList().then(function(data) { //刷新横滚项目
          if (data.errcode == undefined) {
            $scope.services = data;
          }
        });

        $scope.notices = homeSer.getNoticeList(); //获取通知列表
        homeSer.refreshNoticeList(1, size, orgId, false).then(function(data) {
          if (data.errcode == undefined) {
            $scope.notices = data.concat(fillAry);
          }
        });
      });

      $scope.$on('$ionicView.loaded', function() {
        var jpushId = localStorage.getItem('bj12351.jpush_id'); //jpushId
        var binded = localStorage.getItem('bj12351.binded'); //是否已绑定

        if (binded) { //已绑定
          return;
        }

        if (jpushId) { //已获取到jpush_id但未绑定
          $scope.bindJpush(); //绑定jpush
          return;
        } else if (ignore) { //未获取到jpush_id、未绑定但不再提示
          return;
        }

        /**未获取到jpush_id、未绑定、未点击不再提示**/
        $scope.myPopup = $ionicPopup.show({
          template: '<div style="font-size: 15px; margin: 0 0 10px 0;">请在系统设置中打开通知权限，并成功绑定设备后，才可接收推送消息。是否绑定？</div> <div> <input type="checkbox" style="display: inline-block; width: 16px; height: 16px; margin: 2px; vertical-align: middle;" ng-click="doIgnore()">不再提示 <div>',
          title: '<span style="font-size:17px;">温馨提示</span>',
          scope: $scope,
          buttons: [{
            text: '取消'
          }, {
            text: '绑定',
            type: 'button-assertive',
            onTap: function(e) {
              e.preventDefault();
              $scope.initJpush();
            }
          }]
        });
      });

    });
})();
