(function() {
  'use strict';

  angular
    .module('home')
    .factory('homeSer', function($http, API, $q, $ionicLoading) {
      var bannerList = JSON.parse(localStorage.getItem('bj12351.banner')) || [];
      var crossList = JSON.parse(localStorage.getItem('bj12351.cross')) || [];
      var noticeList = JSON.parse(localStorage.getItem('bj12351.notice')) || [];

      return {
        getBannerList: function() {
          return bannerList;
        },

        getCrossList: function() {
          return crossList;
        },

        getNoticeList: function() {
          return noticeList;
        },

        refreshBanner: function() {
          var q = $q.defer();
          $http.get(API.getHost() + '/banner/list.jsp')
            .success(function(data) {
              if (data.errcode === undefined) {
                bannerList = data;
                localStorage.setItem('bj12351.banner', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        refreshCrossList: function() {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/slide-list.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&page=1' +
              '&size=10')
            .success(function(data) {
              if (data.errcode === undefined) {
                crossList = data;
                localStorage.setItem('bj12351.cross', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        refreshNoticeList: function(page, size, orgId, backdrop) {
          var q = $q.defer();
          if (backdrop) {
            $ionicLoading.show({
              template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
            });
          }
          $http.get(API.getHost() + '/user/announcement.jsp' +
              '?page=' + page +
              '&size=' + size)
            .success(function(data) {
              if (data.errcode === undefined) {
                noticeList = data;
                localStorage.setItem('bj12351.notice', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //绑定极光
        bindJpush: function() {
          var q = $q.defer();

          $http.get(API.getHost() + '/user/bind-jpush.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&jpush_id=' + localStorage.getItem('bj12351.jpush_id'))
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
