(function() {
  'use strict';

  angular
    .module('joinUnion')
    .factory('joinUnionSer', function($http, $q, API, $ionicLoading) {
      return {
        /**申请加入**/
        applyJoin: function(name, id_card, phone, company, company_address) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/hotline/apply-join.jsp', {
              name: name,
              id_card: id_card,
              phone: phone,
              company: company,
              company_address: company_address
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }, //获取工作单位列表
        companyList: function(name) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.get(API.getHost() + '/hotline/company-list.jsp?name=' + name, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '没有信息',
                  duration: 1000
                });
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
