(function() {
  'use strict';
  angular
    .module('login')
    .controller('loginCtrl', function($scope, $ionicHistory, $location, $state, $cordovaDialogs, $ionicLoading, $ionicModal, $interval, loginSer, md5Ser, templateUrlPath) {
      $scope.login = {};
      $scope.login.login_name = ""; //用户名
      $scope.login.pw = ""; //密码

      $scope.forget = {};

      /**清空输入框**/
      $scope.clear = function(val) {
        $scope.login[val] = "";
      };

      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.id_card = localStorage.getItem('bj12351.id_card');
        $scope.is_gesture_pwd = localStorage.getItem('bj12351.is_gesture_pwd');
        if ($scope.is_gesture_pwd == 'true') {
          $scope.loginType = 'gesture';
          localStorage.setItem('bj12351.login_type', 'gesture');
        }

        var userRemPwd2 = $scope.getCookieValue("rem_pwd");
        if (userRemPwd2 != "true") {
          // $scope.login.pw = "";
          $scope.clearPwdClick();
        }

      });


      // $scope.loginType = 'gesture';
      $scope.loginType = localStorage.getItem('bj12351.login_type') || 'gesture';
      /**切换登录方式**/
      // /**切换登录方式**/
      $scope.changeLoginType = function(type) {
        $scope.loginType = type;
        localStorage.setItem('bj12351.login_type', type);
      };

      /**登录**/
      $scope.doLogin = function() {
        loginSer.login($scope.login.login_name.toUpperCase(), md5Ser.md5($scope.login.pw), 2).then(function(data) {
          if (data.errcode === 0) {
            loginSer.info(localStorage.getItem('bj12351.token')).then(function(data) {
              if (data.errcode === undefined) {
                $scope.login = {};
                if (data.is_gesture_pwd) {
                  localStorage.setItem('bj12351.is_gesture_pwd', true);
                } else {
                  localStorage.removeItem('bj12351.is_gesture_pwd');
                }
                if ($ionicHistory.backView()) {
                  $ionicHistory.goBack();
                } else {
                  $state.go('tab.home');
                }
              } else if (data.errcode == -2) {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                  localStorage.removeItem('bj12351.token');
                  localStorage.removeItem('bj12351.user');
                  // $state.go('tab.login');
                  $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                  if ($scope.is_gesture === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**倒计时**/
      function countDown() {
        $scope.forget.gain_code = '发送中' + '(' + 90 + 's)';
        var wait = 90;
        if (count !== undefined) {
          $interval.cancel(count);
        }
        var count = $interval(function() {
          $scope.forget.gain_code = '发送中' + '(' + wait + 's)';
          wait--;
          if (wait === 0) {
            $interval.cancel(count);
            $scope.forget.gain_code = '发送验证码';
            $scope.forget.checked = false;
          }
        }, 1000);
      }

      /**发送验证码**/
      $scope.sendCode = function() {
        loginSer.getValidCode($scope.forget.phone.toUpperCase()).then(function(data) {
          $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          if (data.errcode === 0) {
            $scope.forget.checked = true;
            countDown();
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**忘记密码**/
      $scope.forgetPwd = function() {
        loginSer.forgetPwd($scope.forget.valid_code, $scope.forget.phone, md5Ser.md5($scope.forget.pw)).then(function(data) {
          $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          if (data.errcode == 0) {
            $scope.forget = {};
            $scope.closeModal('forget_pwd');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          if (modal_name == 'forget_pwd') {
            $scope.forget.phone = '';
            $scope.forget.verification_code = '';
            $scope.forget.gain_code = '发送验证码';
            $scope.forget.checked = false;
          }
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });

      /*=================是否显示密码部分相关js开始================*/
      $scope.show_pwd = false;
      $scope.changeImg = function() {
        if ($scope.show_pwd === true) { //密码明文转密文
          angular.element(document.querySelector("#change_pwd")).attr('type', 'password');
          $scope.show_pwd = false;
        } else if ($scope.show_pwd === false) { //密码密文转明文
          angular.element(document.querySelector("#change_pwd")).attr('type', 'text');
          $scope.show_pwd = true;
        }
      };
      /*=================是否显示密码部分相关js结束================*/

      /*=================记住密码部分相关js开始================*/
      $scope.login.chk = true;
      $scope.addCookie = function(name, value, days, path) {
        name = escape(name);
        value = escape(value);
        var expires = new Date();
        expires.setTime(expires.getTime() + days * 3600000 * 24);
        path = path === "" ? "" : ";path=" + path;
        var _expires = (typeof days) == "string" ? "" : ";expires=" + expires.toUTCString();
        document.cookie = name + "=" + value + _expires + path;
      };

      $scope.getCookieValue = function(name) {
        name = escape(name);
        var allcookies = document.cookie;
        name += "=";
        var pos = allcookies.indexOf(name);
        if (pos != -1) {
          var start = pos + name.length;
          var end = allcookies.indexOf(";", start);
          if (end == -1) end = allcookies.length;
          var value = allcookies.substring(start, end);
          return (decodeURIComponent(value));
        } else {
          return "";
        }
      };

      $scope.deleteCookie = function(name, path) {
        name = escape(name);
        var expires = new Date(0);
        path = path === "" ? "" : ";path=" + path;
        document.cookie = name + "=" + ";expires=" + expires.toUTCString() + path;
      };

      $scope.loginOnload = function() {
        var userNameValue = $scope.getCookieValue("userName");
        $scope.login.login_name = userNameValue;
        // var userPassValue = $scope.getCookieValue("userPass");
        // $scope.login.pw = userPassValue;
        var userRemPwd = $scope.getCookieValue("rem_pwd");
        $scope.login.chk = (userRemPwd == "true");
        // var $chk=$("input[name=chk]");
        // $chk.attr("checked",false);
      };

      $scope.loginOnload();

      $scope.clearPwdClick = function() {
        $scope.deleteCookie("userPass");
        $scope.login.pw = "";
      };

      $scope.backTestConfigSaveClick = function(user_name, user_pwd, rem_pwd) {
        //$('#loginModal').modal('hide');
        var userName = $scope.login.login_name;
        // rem_pwd = $scope.login.chk;
        if (userName === '') {
          $cordovaDialogs.alert('请输入用户名', '温馨提示', '好的');
          return;
        }
        var userPass = $scope.login.pw;
        if (userPass === '') {
          $cordovaDialogs.alert('请输入密码', '温馨提示', '好的');
          return;
        }
        if (rem_pwd) {
          //添加cookie
          $scope.addCookie("userName", userName, 7, "/"); //7天过期
          // $scope.addCookie("userPass", userPass, 7, "/");
          $scope.addCookie("rem_pwd", rem_pwd, 7, "/");
        } else {
          $scope.deleteCookie("userName");
          $scope.addCookie("rem_pwd", rem_pwd, 7, "/");
        }
        $scope.doLogin();

      };
      /*=================忘记密码部分相关js结束================*/


      /*=================手势密码部分相关js开始================*/

      /* 手势*/
      $("#gesturepwd").GesturePasswd({
        backgroundColor: "#fff", //背景色
        color: "#ccc", //主要的控件颜色
        roundRadii: 30, //大圆点的半径
        pointRadii: 6, //大圆点被选中时显示的圆心的半径
        space: 30, //大圆点之间的间隙
        width: 270, //整个组件的宽度
        height: 270, //整个组件的高度
        lineColor: "#33cc33", //用户划出线条的颜色
        zindex: 100 //整个组件的css z-index属性
      });

      $("#gesturepwd").on("hasPasswd", function(e, passwd) {
        if (passwd === null || passwd === '') {
          return;
        }
        if (passwd !== null && passwd.length < 5) {
          $("#gesturepwd").trigger("passwdWrong");
          setTimeout(function() {
            $cordovaDialogs.alert('手势密码至少连接5个点。', '温馨提示', '好的');
          }, 500); //延迟半秒以照顾视觉效果
          //密码验证错误后的其他操作。。。
          return;
        }

        if ($("#gesturepwd")) {
          $scope.gesture_login(passwd);
        }
      });

      //  $scope.user = userService.getUserInfo();
      $scope.gesture_login = function(passwd) {
        if (!localStorage.getItem('bj12351.id_card')) {
          $cordovaDialogs.alert('您还没有设置手势密码，请用其他方式登录!', '温馨提示', '好的');
          return;
        }
        loginSer.gestureLogin(localStorage.getItem('bj12351.id_card').toUpperCase(), md5Ser.md5(passwd)).then(function(data) {
          if (data.errcode === 0) {
            localStorage.setItem('bj12351.token', data.token);
            $("#gesturepwd").trigger("clearPasswd");
            loginSer.info(localStorage.getItem('bj12351.token')).then(function(data) {
              if (data.errcode === undefined) {
                $scope.login = {};
                // if (localStorage.getItem('bj12351.is_gesture_pwd') == 'true') { //只能和字符串型'true'作比较，因为取出的localStorage值为字符串
                //   localStorage.setItem('bj12351.login_type', 'gesture');
                // }
                if ($ionicHistory.backView()) {
                  $ionicHistory.goBack();
                } else {
                  $state.go('tab.home');
                }
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $("#gesturepwd").trigger("clearPasswd");
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

    });
})();
