(function() {
  'use strict';
  angular
    .module('manageOrg')
    .controller('manageOrgCtrl', function($scope, $stateParams, $ionicHistory, $ionicLoading, $location, $cordovaDialogs, $ionicModal, manageOrgSer, templateUrlPath) {
      $scope.manage = {};
      $scope.manageType = $stateParams.type;
      $scope.btnName = "";
      $scope.doSubmit = "";
      var user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.title = "";

      if ($scope.manageType == 1) {
        $scope.btnName = "转出";
        $scope.doSubmit = outroll;
        $scope.title = "转出申请";
      } else {
        $scope.btnName = "迁入";
        $scope.doSubmit = enroll;
        $scope.title = "迁入申请";
      }

      if (user) {
        $scope.manage.name = user.name;
        $scope.manage.certNum = user.id_card;
        if (user.org_parent_list) {
          var orgListArr = user.org_parent_list.split(',');
          orgListArr.pop();
          orgListArr.reverse();
          $scope.manage.crtOrg = orgListArr.toString().replace(/,/g, '>');
        } else {
          $scope.manage.crtOrg = '暂无';
        }
        $scope.manage.crtEnter = user.company || '暂无';
      }

      /**会籍转入转出**/
      $scope.search = {};
      $scope.select = {};
      $scope.orgList = [];
      $scope.entList = [];

      /**搜索工会**/
      $scope.searchOrg = function() {
        if ($scope.search.name == '' || $scope.search.name == undefined) {
          $cordovaDialogs.alert('请您输入工会名称进行搜索', '温馨提示', '好的');
          return;
        }
        manageOrgSer.searchOrg($scope.search.name).then(function(data) {
          if (data.errcode == undefined) {
            $scope.orgList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**选择工会**/
      $scope.selectOrg = function(entList, targetOrg) {
        $scope.entList = entList;
        $scope.select.org = targetOrg;
        $scope.select.ent = "";
        $scope.openModal('select_ent');
      };

      /**无覆盖单位**/
      $scope.selectOrgNone = function() {
        $cordovaDialogs.alert('该工会下没有覆盖单位，暂时无法转入。', '温馨提示', '好的');
      };

      /**选择单位**/
      $scope.selectEnt = function() {
        if (!$scope.select.ent) {
          $cordovaDialogs.alert("请选择单位", '温馨提示', '好的');
          return;
        }
        $scope.manage.enrollOrgName = $scope.select.org.orgName;
        $scope.manage.enrollEnterName = $scope.select.ent.enterName;
        $scope.closeModal('select_ent');
        $scope.closeModal('select_org');
      };

      /**转入**/
      function enroll() {
        if (!$scope.manage.enrollOrgName || !$scope.manage.enrollEnterName) {
          $cordovaDialogs.alert("请重新选择工会", '温馨提示', '好的');
          return;
        }
        $cordovaDialogs.confirm('您确定要提交工会迁入申请吗', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            manageOrgSer.manageOrg(1, $scope.select.org.orgId, $scope.select.ent.enterId, user.hy_id).then(function(data) {
              if (data.errcode === 0) {
                $cordovaDialogs.alert("迁入申请提交成功", '温馨提示', '好的');
                $ionicHistory.goBack();
              } else if (data.errcode == -1) {
                $cordovaDialogs.alert("登录已失效，请重新登录", '温馨提示', '好的');
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          }
        });
      }

      /**转出**/
      function outroll() {
        $cordovaDialogs.confirm('您确定要提交工会转出申请吗', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            manageOrgSer.manageOrg(2, 0, 0, user.hy_id).then(function(data) {
              if (data.errcode === 0) {
                $cordovaDialogs.alert("转出申请提交成功", '温馨提示', '好的');
              } else if (data.errcode == -1) {
                $cordovaDialogs.alert("登录已失效，请重新登录", '温馨提示', '好的');
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            });
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      }

      /**地址跳转**/
      $scope.toPath = function(path) {
        $location.path(path);
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'select_org') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
