(function() {
  'use strict';

  angular
    .module('manageOrg')
    .factory('manageOrgSer', function($http, API, $q, $ionicLoading) {
      var user = JSON.parse(localStorage.getItem('bj12351.user')) || {};

      return {
        manageOrg: function(type, target_org, target_enter, hy_member_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/manage-org.jsp', {
              token: localStorage.getItem('bj12351.token'),
              type: type,
              target_org: target_org,
              target_enter: target_enter,
              hy_member_id: hy_member_id,
              source: 1
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //搜索工会
        searchOrg: function(name) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/user/search-org-ent.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&name=' + name, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
