(function() {
  'use strict';
  angular
    .module('map')
    .controller('mapCtrl', function($scope, $cordovaDialogs, templateUrlPath, $ionicModal, $ionicLoading, $ionicHistory, $cordovaLaunchNavigator, $cordovaInAppBrowser, $cordovaDevice, mapSer, geoLocationSer, faqDetailSer, $sce) {
      $scope.map_level = 14;
      $scope.flag = 0;
      $scope.back = false;
      $scope.type = 0;
      $scope.marker = [];

      $scope.search = {};
      $scope.search.ent_name = '';
      $scope.search.service = '';

      // $scope.content = '';
      // $scope.getNotice = function() {
      //   faqDetailSer.detail(22048).then(function(data) {
      //     if (data.errcode === undefined) {
      //       $scope.content = $sce.trustAsHtml(data.content);
      //     }
      //   });
      // };
      // $scope.$on('$ionicView.beforeEnter', function() {
      //   $scope.getNotice();
      // });

      $scope.employee_types = [{
        code: 1,
        name: '职工之家'
      }, {
        code: 2,
        name: '职工小家'
      }, {
        code: 3,
        name: '暖心驿站'
      }];
      $scope.search.employee_type = $scope.employee_types[0];

      $scope.employee_services = JSON.parse(localStorage.getItem('bj12351.ct_service_type'));
      // $scope.employee_services.unshift({
      //   code: 0,
      //   name: '全部'
      // });
      // $scope.search.employee_service = $scope.employee_services[0];

      var latitude = geoLocationSer.getLatitude();
      var longitude = geoLocationSer.getLongitude();

      /*重定位 */
      function reLocated() {
        geoLocationSer.reLocated();
        latitude = geoLocationSer.getLatitude();
        longitude = geoLocationSer.getLongitude();
      }
      reLocated();


      //获取屏幕内的职工之家数据
      $scope.getStationList = function(map) {
        var cp = map.getBounds(); //返回map可视区域
        var pt = map.getCenter();
        var sw = cp.getSouthWest();
        var ne = cp.getNorthEast();
        $scope.sw_lng = sw.lng;
        $scope.sw_lat = sw.lat;
        $scope.ne_lng = ne.lng;
        $scope.ne_lat = ne.lat;
        $scope.employeeList = JSON.parse(localStorage.getItem('bj12351.employeeList')) || [];
        mapSer.refresh($scope.search.employee_type.code, $scope.sw_lng, $scope.sw_lat, $scope.ne_lng, $scope.ne_lat, $scope.search.ent_name, $scope.search.service).then(function(data) {
            if (data.errcode == undefined) {
              $scope.employeeList = data;
              $scope.forEachStation(map, $scope.search.employee_type.code);
            } else if (data.errcode == -3) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });

      };

      // 遍历数据添加属性
      $scope.forEachStation = function(map, emp_type) {
        if ($scope.employeeList.length == 0 && $scope.type == 0) {
          $scope.msg = "职工之家";
          if (emp_type == 2) {
            $scope.msg = "职工小家";
          } else if (emp_type == 3) {
            $scope.msg = "暖心驿站";
          }
          $ionicLoading.show({
            template: '当前范围内没有' + $scope.msg + '信息！',
            duration: 1000
          });
          return;
        }
        for (var i = 0; i < $scope.employeeList.length; i++) {
          if (($scope.employeeList[i].latitude != null && $scope.employeeList[i].latitude != 0.0) || ($scope.longitude != null && $scope.longitude != 0.0)) {

            var point = new BMap.Point($scope.employeeList[i].longitude, $scope.employeeList[i].latitude);
            var content = '<div style="margin:0;line-height:20px;padding:2px;">' + '地址：' + $scope.employeeList[i].address + '<br/>' +
              // '<a class="button button-small button-assertive" style="float:right;" href="#/tab/map/' + $scope.employeeList[i].id + '/detail">详情查看</a>' +
              '</div>';
            //创建检索信息窗口对象
            var searchInfoWindow = new BMapLib.SearchInfoWindow(map, content, {
              title: $scope.employeeList[i].name, //标题
              width: '80%', //宽度
              height: 60, //高度
              enableSendToPhone: false,
              searchTypes: []
            });
            $scope.addMarker(map, point, searchInfoWindow, $scope.employeeList[i].name, $scope.employeeList[i].address, $scope.employeeList[i].id);
          }
        }
      };

      //------添加拖拽事件----
      $scope.addDragend = function(map) {
        //拖拽开始事件
        map.addEventListener("dragstart", function() {
          console.log("dragstart");
          $scope.show_id = 0;
          map.clearOverlays();
        });

        //拖拽结束事件
        map.addEventListener("dragend", function() {
          console.log("dragend");
          $scope.toMap(map);
        });
      };

      //刷新展示标注点
      $scope.toMap = function(map) {
        var pt = map.getCenter();
        var cp = map.getBounds(); //返回map可视区域
        var sw = cp.getSouthWest();
        var ne = cp.getNorthEast();
        var level = $scope.getZoom(ne.lng, sw.lng, ne.lat, sw.lat);
        // console.log("level_zoom:" + level);
        $scope.map_level = level;
        // if (level <= 10) {
        //   //myObj.appService.alert("请精确所选范围");
        //   myObj.toastCtrl.create({
        //     message: '当前范围较大，请您精确范围！',
        //     duration: 2000,
        //     position: 'bottom'
        //   }).present();
        // } else {
        $scope.addMap(pt.lng, pt.lat, $scope.map_level);
        // }
      };

      // 添加标注点
      $scope.addMarker = function(map, point, searchInfoWindow, name, address, id) {
        // var myIcon = new BMap.Icon("img/mark.png", new BMap.Size(30, 35), {
        var myIcon = new BMap.Icon("img/mark1.png", new BMap.Size(30, 30), {
          // anchor: new BMap.Size(10, 10),
          imageSize: new BMap.Size(30, 30)
        });
        if ($scope.search.employee_type.code == 2 || $scope.search.employee_type.code == 3) {
          myIcon = new BMap.Icon("img/mark2.png", new BMap.Size(30, 30), {
            // anchor: new BMap.Size(10, 10),
            imageSize: new BMap.Size(30, 30)
          });
        }


        var marker = new BMap.Marker(point, {
          icon: myIcon
        });
        $scope.marker.concat(marker);
        map.addOverlay(marker);
        //添加点击事件
        marker.addEventListener("click", function(e) {
          $('#employee_' + id).show();
          $scope.show_id = id;
          searchInfoWindow.open(marker);
        });

        searchInfoWindow.addEventListener("close", function(e) {
          $('#employee_' + id).hide();
        });
      };


      $scope.getZoom = function(maxLng, minLng, maxLat, minLat) {
        var zoom = ["20", "50", "100", "200", "500", "1000", "2000", "5000", "10000", "20000", "25000", "50000", "100000", "200000", "500000", "1000000", "2000000", "5000000", "10000000"]; //级别18到3。
        var pointA = new BMap.Point(maxLng, maxLat); // 创建点坐标A
        var pointB = new BMap.Point(minLng, minLat); // 创建点坐标B
        var distance = $scope.map1.getDistance(pointA, pointB).toFixed(2); //获取两点距离,保留小数点后两位
        console.log("distance:" + distance);
        for (var i = 0, zoomLen = zoom.length; i < zoomLen; i++) {
          if (zoom[i] - distance > 0) {
            var level = 20 - i + 3;
            console.log(level >= 14 ? level - 1 : level);
            if (level >= 14 && level < 19)
              return level - 1;
            else
              return level;
            //return level >= 14 ? level - 1 : level;//之所以会多3，是因为地图范围常常是比例尺距离的10倍以上。所以级别会增加3。
          }
        }
      };

      //------地图添加标注点----
      $scope.addMap = function(longitude, latitude, level) {
        if ($scope.map1 == undefined) {
          $scope.map1 = new BMap.Map("allmap"); // 创建地图实例
          $scope.addDragend($scope.map1); //添加拖拽事件
        }
        var map = $scope.map1;
        map.centerAndZoom(new BMap.Point(longitude, latitude), level); // 设初始化地图,创建点坐标
        map.enableDragging(); //启用地图拖拽，默认启用
        if ($scope.flag == 0) {
          $scope.flag = 1;
          map.addEventListener("tilesloaded", function() { //tilesloaded事件:当地图所有图块完成加载时触发此事件
            var pt = map.getCenter(); //返回地图当前中心点
            var cp = map.getBounds(); //返回地图可视区域，以地理坐标表示
            var sw = cp.getSouthWest(); //返回矩形区域的西南角
            var ne = cp.getNorthEast(); //返回矩形区域的东北角

            var level = $scope.getZoom(ne.lng, sw.lng, ne.lat, sw.lat);
            $scope.map_level = level;

            if (!$scope.back) {
              if ($scope.map_level <= 10) {
                $ionicLoading.show({
                  template: '当前范围较大，请您精确范围！',
                  duration: 1000
                });

              } else {
                var flag = false;
                if ($scope.show_id != 0 && $scope.show_id != undefined) {
                  flag = true;
                }
                if (!flag) {
                  $scope.getStationList(map);
                }
              }
            }
          });
        }

      };


      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.back = false;
        reLocated();
        longitude = geoLocationSer.getLongitude() || "116.39098";
        latitude = geoLocationSer.getLatitude() || "39.891935";
        $scope.addMap(longitude, latitude, $scope.map_level);


        // $scope.addMap("116.414867", "40.161169", $scope.map_level); //暖
      });

      //准备离开时触发
      $scope.$on('$ionicView.beforeLeave', function() {
        $scope.type = 1;
        $scope.back = true;
      });



      /*=================开始================*/
      //选择按钮
      $scope.multiple = function(id, event) {
        event.preventDefault();
        for (var i = 0; i < $scope.employee_services.length; i++) {
          if (id == $scope.employee_services[i].id) {
            if (!$scope.employee_services[i].is_checked) {
              angular.element(document.querySelector("#employeeli" + $scope.employee_services[i].id)).prop("checked", "checked").parent().removeClass("btn-weak");
              $scope.employee_services[i].is_checked = true;
            } else {
              angular.element(document.querySelector("#employeeli" + $scope.employee_services[i].id)).prop("checked", "checked").parent().addClass("btn-weak");
              $scope.employee_services[i].is_checked = false;
            }
          }
        }

      };

      $scope.change = function() {
        // $scope.addMap("116.419502", "39.996738", $scope.map_level);
        if ($scope.map1 !== undefined) {
          $scope.map1.clearOverlays();
          $scope.toMap($scope.map1);
        }
      };


      /**重置筛选**/
      $scope.reset = function() {
        angular.element(document.querySelectorAll(".redioarea_employee label")).addClass("btn-weak");
        // $scope.search.employee_service = $scope.employee_services[0];
        for (var i = 0; i < $scope.employee_services.length; i++) {
          $scope.employee_services[i].is_checked = false;
        }
        $scope.search.service = '';
        $scope.search.ent_name = '';
      };


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_employee') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          // if (modal_name == 'search_employee_ser') {
          //   console.log("----------------------");
          //   $scope.reset();
          // }
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
        // $scope.change();

        $scope.search.ent_name = '';
        $scope.search.service = '';
      };

      $scope.submitModal = function(modal_name) {

        if (modal_name == 'search_employee_ser') {
          $scope.search.service = '';
          for (var i = 0; i < $scope.employee_services.length; i++) {
            if ($scope.employee_services[i].is_checked == true) {
              $scope.search.service += $scope.employee_services[i].id + ',';
            }
          }
        }
        $scope.change();
        // $scope.search.ent_name = '';
        // $scope.search.service = '';
        $scope.modal[modal_name].remove();
      };

      /**打开筛选模板**/
      $scope.openFilterModal = function() {
        $scope.openModal('search_employee_ser');
      };
      /**取消筛选**/
      $scope.returnCancel = function() {
        $scope.closeModal('search_employee_ser');
      };
    });
})();
