(function() {
  'use strict';
  angular
    .module('mapDetail')
    .controller('mapDetailCtrl', function($scope, $state, $cordovaDialogs, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, templateUrlPath, mapDetailSer, geoLocationSer, $cordovaLaunchNavigator, $cordovaInAppBrowser, $cordovaDevice) {
      var page = 1;
      var size = 10;
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user')) || {};
      $scope.user.hy_id = 0;

      $scope.merchant = {}; //服务单位

      /**刷新**/
      $scope.refresh = function() {
        geoLocationSer.reLocated();
        mapDetailSer.detail($stateParams.mapId).then(function(data) {
            if (data.errcode === undefined) {
              $scope.merchant = data;
              //加载地理编码插件
              AMap.plugin(["AMap.Geocoder"], function() {
                var myGeo = new AMap.Geocoder({
                  city: "北京"
                });
                myGeo.getLocation($scope.merchant.Address, function(status, result) {
                  if (status === 'complete' && result.info === 'OK') {
                    // console.log(result.geocodes[0].location);
                    $scope.desLat = result.geocodes[0].location.lat;
                    $scope.desLng = result.geocodes[0].location.lng;
                  }
                });
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      $scope.launchNavigatorForIos = function() {
        $cordovaLaunchNavigator.navigate($scope.merchant.Address).then(function() {
          // console.log("Navigator launched");
        }, function(err) {
          console.error(err);
        });
      };
      $scope.launchNavigator = function() {
        if ($cordovaDevice.getPlatform() === 'iOS') {
          $scope.launchNavigatorForIos();
        } else if ($cordovaDevice.getPlatform() === 'Android') {
          appAvailability.check('com.baidu.BaiduMap',
            function() { // Success start Bmap
              var targetSrc = 'http://api.map.baidu.com/direction?origin=latlng:' + geoLocationSer.getLatitude() + ',' + geoLocationSer.getLongitude() + '|name:您所在位置&destination=' + $scope.merchant.Address + '&mode=driving&region=北京&output=html&src=测试北京12351app';
              $cordovaInAppBrowser.open(targetSrc, '_system', {
                clearcache: 'yes',
                clearsessioncache: 'yes',
                keyboardDisplayRequiresUserAction: 'no'
              });
            },
            function() { // Fail start Amap
              var targetSrc = 'http://uri.amap.com/navigation?from=&to=' + $scope.desLng + ',' + $scope.desLat + ',' + $scope.merchant.Address + '&mode=car&policy=1&src=mypage&coordinate=gaode&callnative=1';
              $cordovaInAppBrowser.open(targetSrc, '_system', {
                clearcache: 'yes',
                clearsessioncache: 'yes',
                keyboardDisplayRequiresUserAction: 'no'
              });
            });
        }
      };


      /**显示图片**/
      $scope.showImg = function(url) {
        $scope.openModal('show_img');
      };


      $scope.reserve_emp = {};
      $scope.reserve_emp.book_time = "";
      $scope.verify_emp = function() {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.openModal('reserve_employee');
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      }

      $scope.submit_emp = function() {
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.reserve_emp.book_time === undefined || $scope.reserve_emp.book_time.length === 0) {
            $cordovaDialogs.alert('请填写预约时间', '温馨提示', '好的');
            return;
          }

          if ($scope.reserve_emp.book_content == undefined || $scope.reserve_emp.book_content == '') {
            $cordovaDialogs.alert('请填写预约服务内容', '温馨提示', '好的');
            return;
          }
          if ($scope.reserve_emp.book_content.length > 64) {
            $cordovaDialogs.alert('预约服务内容不能超过64个字', '温馨提示', '好的');
            return;
          }
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.reserve_emp.hy_id = $scope.user.hy_id || 0;
          mapDetailSer.reserve($stateParams.mapId, $scope.reserve_emp.hy_id, $scope.reserve_emp.book_time, $scope.reserve_emp.book_content).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功预约服务内容,可以在我的预约轨迹中随时查看', '温馨提示', '好的').then(function() {
                $scope.closeModal('reserve_employee');
              });
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                $scope.closeModal('reserve_employee');
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            $scope.closeModal('reserve_employe');
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };


      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var option = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        // if (modal_name == 'show_img') {
        //   option.animation = 'slide-in-up';
        // }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', option).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };
      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });

    });
})();
