(function() {
  'use strict';
  angular
    .module('merchant')
    .factory('merchantSer', function($http, $q, API, $ionicLoading) {
      var merchants = JSON.parse(localStorage.getItem('bj12351.merchants')) || [];

      return {
        getMerchants: function() {
          return merchants;
        },

        refresh: function(longitude, latitude, merchant_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/merchant/list.jsp?longitude=' + longitude + '&latitude=' + latitude + '&page=' + page + '&size=' + size + '&merchant_name=' + merchant_name + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                merchants = data;
                localStorage.setItem('bj12351.merchants', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        more: function(longitude, latitude, merchant_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/merchant/list.jsp?longitude=' + longitude + '&latitude=' + latitude + '&page=' + page + '&size=' + size + '&merchant_name=' + merchant_name + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        postMerchantLikes: function(token, firm_id, is_likes) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/merchant/merchant-likes.jsp', {
              token: token,
              firm_id: firm_id,
              is_likes: is_likes
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
