(function() {
  'use strict';
  angular
    .module('merchantDetail')
    .factory('merchantDetailSer', function($http, $q, API, $ionicLoading) {
      return {
        detail: function(merchant_id) {
          var q = $q.defer();
          // $ionicLoading.show({
          //   template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          // });
          $http.get(API.getHost() + '/merchant/info.jsp?merchant_id=' + merchant_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              // $ionicLoading.hide();
            });
          return q.promise;
        },

        getComments: function(merchant_id, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/merchant/comment-list.jsp?merchant_id=' + merchant_id + '&page=' + page + '&size=' + size)
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        isTaked: function(merchant_id) {
          var q = $q.defer();
          $http.get(API.getHost() + '/merchant/is-taked.jsp?token=' + localStorage.getItem('bj12351.token') + '&merchant_id=' + merchant_id)
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        submitComment: function(merchant_id, content, star, is_anonymity) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/merchant/comment.jsp', {
              token: localStorage.getItem('bj12351.token'),
              merchant_id: merchant_id,
              content: content,
              star: star,
              is_anonymity: is_anonymity
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
