(function() {
  'use strict';
  angular
    .module('merchantService')
    .controller('merchantServiceCtrl', function($scope, $state, $stateParams, $ionicLoading, $cordovaDialogs, $ionicModal, merchantServiceSer, myServiceSer, templateUrlPath) {
      $scope.search = {};
      $scope.search.name = '';
      $scope.hasMore = false;
      $scope.services = [];

      var page = 1;
      var size = 10;

      $scope.user = JSON.parse(localStorage.getItem('bj12351.user')) || {};

      $scope.gender = 0;
      switch ($scope.user.gender) {
        case "男":
          $scope.gender = 1;
          break;
        case "女":
          $scope.gender = 2;
          break;
      }

      $scope.search_types = [{
        code: 0,
        name: '当前活动'
      }, {
        code: 1,
        name: '我能参与'
      }, {
        code: 2,
        name: '历史活动'
      }];
      $scope.search.search_type = $scope.search_types[0];

      /**刷新**/
      function refresh() {
        merchantServiceSer.serviceList($stateParams.merchantId, $scope.user.m_id, $scope.search.name, $scope.search.search_type.code, $scope.gender, $scope.user.degree, $scope.user.work_status, $scope.user.residence, $scope.user.model_worker, 1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '该服务单位暂时没有活动。',
                  duration: 1000
                });
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.services = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 2000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      }
      refresh();

      /**手动刷新**/
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.change();
      };

      /**监听服务类别**/
      $scope.change = function() {
        if ($scope.search.search_type.code === 1 && !localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您的登录已失效，是否现在登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() { //解决未登录情况下 我能参与下拉刷新导致的刷新旋转动画不自动关闭问题
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          refresh();
        }
      };

      /**更多**/
      $scope.more = function() {
        merchantServiceSer.serviceList($stateParams.merchantId, $scope.user.m_id, $scope.search.name, $scope.search.search_type.code, $scope.gender, $scope.user.degree, $scope.user.work_status, $scope.user.residence, $scope.user.model_worker, page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '没有更多服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.services = $scope.services.concat(data);
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /*=================服务项目点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];
        if ($scope.service_likes.has_likes === true) { //取消点赞
          //$scope.show_likes = false;
        } else if ($scope.service_likes.has_likes === undefined || $scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else if (data.errcode == -1) {
                  $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
                    // $location.path('/login');
                    $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                    if ($scope.is_gesture === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.alert('请先登录', '温馨提示：', '好的').then(function() {
              // $location.path('/login');
              $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
              if ($scope.is_gesture === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            });
          }

        }
      };
      /*=================服务项目点赞结束================*/

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
