(function() {
  'use strict';
  angular.module('my')
    .controller('myCtrl', function($scope, $q, $state, $ionicModal, $ionicLoading, $interval, $cordovaDialogs, md5Ser, mySer, templateUrlPath, $location) {
      $scope.user = mySer.getUserInfo();
      $scope.user.orgParentList = '';
      $scope.token = localStorage.getItem('bj12351.token');

      $scope.modify = {};
      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.token = localStorage.getItem('bj12351.token');
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
        if ($scope.user && $scope.user.org_parent_list) {
          var orgParentListArr = $scope.user.org_parent_list.split(',');
          orgParentListArr.pop();
          orgParentListArr.reverse();
          $scope.user.orgParentList = orgParentListArr.toString().replace(/,/g, '>');
        }
      });

      $scope.toState = function(state) {
        if (state == 'tab.worker_charge_insurance') {
          $cordovaDialogs.confirm('查询等待时间较长，需耐心等待。确认查询？', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              $state.go(state);
            }
          });
        } else if (state == 'tab.myClaim') {
          $cordovaDialogs.alert('暂缓开通', '温馨提示', '好的');
        } else {
          $state.go(state);
        }
      };

      /**刷新我的信息**/
      $scope.refresh = function() {
        mySer.info().then(function(data) {
            if (data.errcode === undefined) {
              $scope.user = data;
              if ($scope.user.org_parent_list != null && $scope.user.org_parent_list !== '') {
                var orgParentListArr = $scope.user.org_parent_list.split(',');
                orgParentListArr.pop();
                orgParentListArr.reverse();
                $scope.user.orgParentList = orgParentListArr.toString().replace(/,/g, '>');
              }
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                localStorage.removeItem('bj12351.token');
                localStorage.removeItem('bj12351.user');
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      /**签到**/
      $scope.signIn = function() {
        $state.go('tab.mySignIn');
      };

      /**修改密码**/
      $scope.modifyPwd = function() {
        mySer.modifyPwd(md5Ser.md5($scope.modify.oldpwd), md5Ser.md5($scope.modify.newpwd)).then(function(data) {
          if (data.errcode === 0) {
            $scope.modify = {};
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $scope.closeModal('modify_pwd');
          } else if (data.errcode == -1) {
            $cordovaDialogs.confirm('登录已失效，再登录一次吧', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      $scope.feedback = {};
      /**提交反馈**/
      $scope.doFeed = function() {
        if ($scope.feedback.content !== '' && $scope.feedback.content.length > 256) {
          $cordovaDialogs.alert('反馈的内容不能超过256个字。', '温馨提示', '好的');
          return;
        }
        mySer.doFeed($scope.feedback.star, $scope.feedback.content).then(function(data) {
          if (data.errcode === 0) {
            $cordovaDialogs.alert(data.errmsg, '提交成功', '好的');
            $scope.closeModal('feedback');
          } else if (data.errcode == -1) {
            $cordovaDialogs.confirm('登录已失效，再登录一次吧', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '反馈失败', '好的');
            $scope.closeModal('feedback');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**我要报错**/
      $scope.area = JSON.parse(localStorage.getItem('bj12351.ct_area_beijing')); //现居住地
      $scope.education = JSON.parse(localStorage.getItem('bj12351.ct_education')); //学历

      $scope.select = {};
      $scope.select.area = getObjByCode($scope.user.residence, $scope.area); //选择的现居住地
      $scope.select.education = getObjByCode($scope.user.degree, $scope.education); //选择的学历

      /**根据代码值获取对象**/
      function getObjByCode(code, ary) {
        for (var item in ary) {
          if (ary[item].code == code) {
            return ary[item];
          }
        }
      }

      /**我要报错提交**/
      $scope.errSubmit = function() {
        mySer.errSubmit($scope.select.area.code, $scope.select.education.code).then(function(data) {
          if (data.errcode == 0) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
              $scope.closeModal('error');
            });
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录失效，请重新登录', '温馨提示', '好的');
          } else {
            $cordovaDialogs.alert('网络繁忙，请稍后重试', '温馨提示', '好的');
          }
        });
      };

      /**清空缓存**/
      $scope.clearStorage = function() {
        $cordovaDialogs.confirm('确定清空缓存', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            localStorage.removeItem('bj12351.manifest');
            $cordovaDialogs.alert('缓存清空成功', '温馨提示', '好的');
          }
        });
      };

      /**退出**/
      $scope.logout = function() {
        $cordovaDialogs.confirm('确定退出登录', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            localStorage.removeItem('bj12351.token');
            localStorage.removeItem('bj12351.user');
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          }
        });
      };


      /**
       * 用户协议
       */
      $scope.userProtocol = function() {
        $location.path('/tab/my_protocol/21805/detail');
      };

      /**
       * 隐私协议
       */
      $scope.privacyProtocol = function() {
        $location.path('/tab/my_protocol/21803/detail');
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'my_info') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          //初始化反馈
          $scope.feedback = {};
          $scope.feedback.star = 5;
          $scope.feedback.content = '';

          //初始化我要报错
          $scope.select.area = getObjByCode($scope.user.residence, $scope.area); //选择的现居住地
          $scope.select.education = getObjByCode($scope.user.degree, $scope.education); //选择的学历

          if (modal_name == 'modify_pwd') {
            $scope.modify.oldpwd = '';
            $scope.modify.newpwd = '';
            $scope.modify.cfmpwd = '';
          }
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
