(function() {
  'use strict';
  angular
    .module('my')
    .factory('mySer', function($http, $q, API, $ionicLoading) {
      var user = JSON.parse(localStorage.getItem("bj12351.user")) || {};

      return {
        getUserInfo: function() {
          return user;
        },

        //是否是会员
        isCollected: function(id_card) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/user/is-collected.jsp?id_card=' + id_card, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(data);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //获取用户信息
        info: function() {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/info.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                user = data;
                localStorage.setItem('bj12351.user', JSON.stringify(data));
                localStorage.setItem('bj12351.id_card', data.id_card);
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        //修改密码
        modifyPwd: function(oldpw, newpw) {
          var q = $q.defer();
          $http.post(API.getHost() + '/user/modify-password-by-password.jsp', {
              token: localStorage.getItem('bj12351.token'),
              old_password: oldpw,
              new_password: newpw
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        //反馈
        doFeed: function(star, content) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/system/feedback.jsp', {
              token: localStorage.getItem('bj12351.token'),
              star: star,
              content: content
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(err) {
              q.reject(err);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //我要报错
        errSubmit: function(area, education) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/correct_member.jsp', {
              token: localStorage.getItem('bj12351.token'),
              area: area,
              education: education
            }, {
              timeout: 60000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(err) {
              q.reject(err);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
