(function() {
  'use strict';
  angular.module('myCards')
    .controller('myCardsCtrl', function($scope, $state, $ionicLoading, $cordovaDialogs, $ionicListDelegate, myCardsSer) {
      $scope.cards = [];

      $scope.sortMainCard = function(obj) {
        if (obj.is_main_card == '是') {
          return 0;
        }
      };

      /**设为默认**/
      $scope.setDefault = function(cardNo) {
        $cordovaDialogs.confirm('修改主卡需使用身份证号或手机号重新登录', '温馨提示', ['确认修改', '暂不修改']).then(function(buttonIndex) {
          $ionicListDelegate.closeOptionButtons();
          if (buttonIndex == 1) {
            myCardsSer.setDefault(cardNo).then(function(data) {
              if (data.errcode == 0) {
                localStorage.removeItem('bj12351.token');
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                  if (data.errcode == -1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              }
            });
          }
        });
      };

      /**获取卡片列表**/
      $scope.refresh = function(backdrop) {
        myCardsSer.refresh(backdrop).then(function(data) {
            if (data.errcode == 0) {
              $scope.cards = data.errmsg;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                if (data.errcode == -1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh(true);

    });
})();
