(function() {
  'use strict';

  angular
    .module('myCards')
    .factory('myCardsSer', function($http, $q, API, $ionicLoading) {
      return {
        getCards: function() {
          return cards;
        },

        refresh: function(backdrop) {
          var q = $q.defer();
          if (backdrop) {
            $ionicLoading.show({
              template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
            });
          }

          $http.get(API.getHost() + '/cards/get-list.jsp' +
              '?token=' + localStorage.getItem('bj12351.token'), {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              if (backdrop) {
                $ionicLoading.hide();
              }
            });
          return q.promise;
        },

        setDefault: function(cardNo) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });

          $http.get(API.getHost() + '/cards/set-default.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&card_no=' + cardNo, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
            return q.promise;
        }

      };
    });
})();
