(function() {
  'use strict';

  angular
    .module('myClaim')
    .controller('myClaimCtrl', function($scope, $state, $location, $ionicLoading, $ionicModal, $cordovaDialogs, $ionicHistory, myClaimSer, myClaimApplySer, ylhzPaymentSer, templateUrlPath) {
      var page = 1;
      var size = 10;

      // $scope.user = ylhzPaymentSer.getUser();
      $scope.claims = [];
      $scope.hasMore = false;


      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.token = localStorage.getItem('bj12351.token');
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      });

      /**删除**/
      $scope.doDelete = function(claimId, claimType) {
        $cordovaDialogs.confirm('确定删除此申请', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            myClaimSer.deleteClaim(claimId, claimType).then(function(data) {
              if (data.errcode == 0) {
                $scope.refresh();
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          }
        });
      };

      /**修改**/
      $scope.doEdit = function(claimId, type, status) {
        myClaimApplySer.clearInfo();
        if (status == 1) {
          $location.path('/tab/my-claim/' + claimId + '/' + type + '/1/apply');
        } else if (status == 11) {
          $location.path('/tab/my-claim/' + claimId + '/' + type + '/2/apply2/1');
        }
      };

      /**路径跳转**/
      $scope.toPath = function(path) {
        if (localStorage.getItem('bj12351.token')) {
          $ionicHistory.clearCache().then(function() {
            myClaimApplySer.clearInfo();
            $location.path(path);
          });
        } else {
          $cordovaDialogs.alert("登录已失效，请重新登录", '温馨提示', '好的');
        }
      };
      /**路由跳转**/
      $scope.toLocationPath = function(type) {
        console.log("type:" + type);
        if (localStorage.getItem('bj12351.token')) {
          $location.path('/tab/my/myClaimDetail/' + type);
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };

    });
})();
