(function() {
  'use strict';

  angular
    .module('myClaimApply')


    //选择类型和输入流水号
    .controller('myClaimApplyInputCtrl', function($scope, $state, $stateParams, $location, $ionicLoading, $ionicModal, $ionicHistory, $cordovaDialogs, $cordovaFileTransfer, templateUrlPath, myClaimApplySer, API) {
      $scope.claim = {};
      $scope.reEdit = true; //是否可以修改
      $scope.claimTypeList = [{
        value: '1',
        name: '医疗类'
      }];
      $scope.claim.type = $scope.claimTypeList[0];

      //查看大图
      $scope.viewPic = function(modal_name, url) {
        $scope.largePic = url;
        $scope.openModal(modal_name);
      };


      var step = $stateParams.step || 1;
      var claimId = $stateParams.claimId || 0;
      var claimType = $stateParams.claimType;
      /**路由跳转**/
      $scope.toPathApply = function(step) {
        if (localStorage.getItem('bj12351.token')) {
          if (step == 1) { //从类型跳转到流水号界面
            $location.path('/tab/my-claim/' + claimId + '/' + $scope.claim.type.value + '/1/apply');
          } else if (step == 2) { //从流水号界面跳转到有效保单界面
            $location.path('/tab/my-claim/' + claimId + '/' + $scope.claim.type.value + '/1/apply/list');
          }

        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };


      //获取有效保单列表
      $scope.effectClaimList = function() {
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.claim.type.value == 0) {
            $cordovaDialogs.alert('请选择理赔险种', '温馨提示', '好的');
            return;
          } else if ($scope.claim.billNum == undefined || $scope.claim.billNum == "") {
            $cordovaDialogs.alert('交易流水号不能为空', '温馨提示', '好的');
            return;
          }
          myClaimApplySer.getEffectClaimList($scope.claim.billNum.toUpperCase(), $scope.claim.type.value).then(function(data) {
              if (data.errcode == undefined) {
                console.log(" data.content:", data.content);
                $scope.effect_claim_list = data.content || [];
                $scope.claim_list_length = $scope.effect_claim_list.length;

                $state.go('tab.myClaimApplyList', {
                  claimId: 0,
                  claimType: $scope.claim.type.value,
                  step: 1,
                  billNum: $scope.claim.billNum
                });

              } else if (data.errcode == -1) {
                // $cordovaDialogs.alert("登录已失效，请重新登录", '温馨提示', '好的');
                $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                    if (buttonIndex == 1) {
                      if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                        $state.go('tab.login');
                      } else {
                        $state.go('tab.login-other');
                      }
                    }
                  })
                  .finally(function() {
                    $scope.$broadcast('scroll.refreshComplete');
                  });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });

        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      }


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    })

    // 获取有效保单列表
    .controller('myClaimApplyListCtrl', function($scope, $state, $stateParams, $location, $ionicLoading, $ionicModal, $ionicHistory, $cordovaDialogs, $cordovaFileTransfer, templateUrlPath, myClaimApplySer, API) {
      $scope.claim = {};
      $scope.step = $stateParams.step || 1;
      $scope.claimId = $stateParams.claimId || 0;
      $scope.claimType = $stateParams.claimType || 1;
      $scope.billNum = $stateParams.billNum || '';
      $scope.is_all_err = 0;

      //获取有效保单列表
      $scope.effectClaimList = function() {
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.claimType == 0) {
            $cordovaDialogs.alert('请选择理赔险种', '温馨提示', '好的');
            return;
          } else if ($scope.billNum == undefined || $scope.billNum == "") {
            $cordovaDialogs.alert('交易流水号不能为空', '温馨提示', '好的');
            return;
          }

          myClaimApplySer.getEffectClaimList($scope.billNum, $scope.claimType).then(function(data) {
              if (data.errcode == undefined) {
                $scope.effect_claim_list = data.content || [];
                $scope.is_all_err = data.identification;
                $scope.claim_list_length = $scope.effect_claim_list.length;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };

      $scope.effectClaimList();

      $scope.next = function(toStep, claimType, billNum) {
        if (claimType == 0) {
          $cordovaDialogs.alert('请选择理赔险种', '温馨提示', '好的');
          return;
        } else if (billNum == undefined || billNum == "") {
          $cordovaDialogs.alert('交易流水号不能为空', '温馨提示', '好的');
          return;
        }

        $location.path('/tab/my-claim/0/' + claimType + '/' + billNum + '/2/apply2/0');
      }
    })


    //上传图片
    .controller('myClaimApplyCtrl', function($scope, $state, $stateParams, $location, $ionicLoading, $ionicModal, $ionicHistory, $cordovaDialogs, $ionicActionSheet, $cordovaCamera, $cordovaFileTransfer, templateUrlPath, myClaimApplySer, API) {
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.claim = {};
      $scope.claim2 = [];
      $scope.claim3 = {};

      var info = {};
      var step = $stateParams.step || 1;
      var claimId = $stateParams.claimId || 0;
      var claimType = $stateParams.claimType || 1;
      var billNum = $stateParams.billNum;


      $scope.isReSubmit = 0;
      if (step == 2) {
        $scope.isReSubmit = $stateParams.isReSubmit; //是否重提交 仅用于被打回的记录
      }

      /**第一步-理赔险种**/
      $scope.reEdit = true; //是否可以修改

      // if ((step == 1 && claimId != 0) || $scope.isReSubmit == 1) { //个人理赔点击“修改”进入时disabled
      //   $scope.reEdit = false;
      //   myClaimApplySer.refreshInfo(claimId, claimType).then(function(data) {
      //     if (data.errcode == undefined) {
      //       $scope.claim = data.claim;
      //       $scope.claim.type = $scope.claimTypeList[claimType];
      //       $scope.claim2 = data.claim2;
      //       $scope.claim3 = data.claim3;
      //     }
      //   }, function(error) {
      //     $ionicLoading.show({
      //       template: '网络繁忙，请稍后重试',
      //       duration: 1000
      //     });
      //   });
      // } else {
      //   $scope.claim.type = $scope.claimTypeList[0];
      // }

      /**第二步-上传图片**/
      var appHost = API.getInsuranceHost();
      $scope.imgHost = appHost.substr(0, appHost.length - 4);
      var imgIndex;
      $scope.imgHeight = window.innerWidth * (8 / 16);
      $scope.tplType = '';

      /**显示示例**/
      $scope.showTpl = function(type) {
        $scope.tplType = type;
        $scope.openModal('my_claim/show_template');
      };

      /**拍照**/
      function takePhoto() {
        var options = {
          quality: 30, //图片质量 0-100
          destinationType: Camera.DestinationType.FILE_URI, //返回值格式
          sourceType: Camera.PictureSourceType.CAMERA, //图片来源 摄像头
          correctOrientation: true //旋转图像至设备正确方向
        };

        $cordovaCamera.getPicture(options).then(function(imageURI) {
          myClaimApplySer.uploadPhoto(imgIndex, claimType, billNum, imageURI).then(function(data) {
            if (data.errcode == 0) {
              $scope.claim2[imgIndex - 1] = {
                "url": data.errmsg.thumbnail
              };
              localStorage.setItem('bj12351.urlPre', data.errmsg.urlPre);
              if (data.errmsg.id_card_img == 1) {
                localStorage.setItem('bj12351.savePath1', data.errmsg.savePath);
                localStorage.setItem('bj12351.zoomPath1', data.errmsg.thumbnail);
              } else if (data.errmsg.id_card_img == 2) {
                localStorage.setItem('bj12351.savePath2', data.errmsg.savePath);
                localStorage.setItem('bj12351.zoomPath2', data.errmsg.thumbnail);
              }
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试',
              duration: 1000
            });
          });
        }, function(err) {});
      }

      /**选择图库**/
      function pickImage() {
        var options = {
          quality: 30, //图片质量 0-100
          destinationType: Camera.DestinationType.FILE_URI, //返回值格式
          sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM, //图片来源 图库
          correctOrientation: true //旋转图像至设备正确方向
        };

        $cordovaCamera.getPicture(options).then(function(imageURI) {
          myClaimApplySer.uploadPhoto(imgIndex, claimType, billNum, imageURI).then(function(data) {
            if (data.errcode == 0) {
              $scope.claim2[imgIndex - 1] = {
                "url": data.errmsg.thumbnail
              };
              localStorage.setItem('bj12351.urlPre', data.errmsg.urlPre);
              if (data.errmsg.id_card_img == 1) {
                localStorage.setItem('bj12351.savePath1', data.errmsg.savePath);
                localStorage.setItem('bj12351.zoomPath1', data.errmsg.thumbnail);
              } else if (data.errmsg.id_card_img == 2) {
                localStorage.setItem('bj12351.savePath2', data.errmsg.savePath);
                localStorage.setItem('bj12351.zoomPath2', data.errmsg.thumbnail);
              }
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试',
              duration: 1000
            });
          });
        }, function(err) {});
      }

      /**添加图片**/
      $scope.addPhoto = function(picIndex) {
        imgIndex = picIndex;
        $ionicActionSheet.show({
          cancelOnStateChange: true, //在菜单取消后刷新状态
          titleText: "请选择图片获取方式",
          buttons: [{
            text: '相机'
          }, {
            text: '图库'
          }],
          cancelText: '取消',
          cancel: function() {
            return true;
          },
          buttonClicked: function(index) {
            switch (index) {
              case 0:
                takePhoto();
                break;
              case 1:
                pickImage();
                break;
              default:
                break;
            }
            return true;
          }
        });
      };


      /**下一步**/
      $scope.next = function(toStep) {
        if (toStep == 2) {

          if ($scope.claim.type.value == 0) {
            $cordovaDialogs.alert('请选择理赔险种', '温馨提示', '好的');
            return;
          } else if ($scope.claim.billNum == undefined || $scope.claim.billNum == "") {
            $cordovaDialogs.alert('交易流水号不能为空', '温馨提示', '好的');
            return;
          }

          $location.path('/tab/my-claim/' + claimId + '/' + claimType + '/2/apply2/0');
          // if (claimId == 0 && $scope.reEdit) { //新增理赔单
          //   myClaimApplySer.addClaim($scope.claim.type.value, $scope.claim.year, $scope.claim.billNum).then(function(data) {
          //     if (data.errcode == 0) {
          //       claimId = data.claimId;
          //       claimType = data.type;
          //       myClaimApplySer.refreshInfo(claimId, claimType).then(function(data) {
          //         $scope.reEdit = false; //是否可以修改
          //         if (data.errcode == undefined) {
          //           $scope.claim = data.claim;
          //           $scope.claim.type = $scope.claimTypeList[data.claim.type];
          //           $scope.claim2 = data.claim2;
          //           $scope.claim3 = data.calim3;
          //           $location.path('/tab/my-claim/' + claimId + '/' + claimType + '/2/apply2/0');
          //         }
          //       }, function(error) {
          //         $ionicLoading.show({
          //           template: '网络繁忙，请稍后重试',
          //           duration: 1000
          //         });
          //       });
          //     } else {
          //       $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          //       return;
          //     }
          //   }, function(error) {
          //     $ionicLoading.show({
          //       template: '网络繁忙，请稍后重试',
          //       duration: 1000
          //     });
          //   });
          // } else { //修改理赔单
          //   $location.path('/tab/my-claim/' + claimId + '/' + claimType + '/2/apply2/0');
          // }
        } else if (toStep == 3) {
          if (!$scope.claim2[0].url) {
            $cordovaDialogs.alert("请上传身份证照片正面（国徽面）", '温馨提示', '好的');
            return;
          } else if (!$scope.claim2[1].url) {
            $cordovaDialogs.alert("请上传身份证照片反面（人像面）", '温馨提示', '好的');
            return;
          }

          $location.path('/tab/my-claim/' + claimId + '/' + claimType + '/' + billNum + '/3/apply3');
        }
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }

        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      /**界面监听方法**/
      $scope.$on('$ionicView.beforeEnter', function() {
        info = myClaimApplySer.getInfo();
        // if (info.claim == undefined) { //用于列表页新增进入理赔第一步
        //   $scope.claim = {};
        //   $scope.claim.type = claimType || 1;
        // } else { //用户理赔第一、二、三切换
        //   $scope.claim = info.claim;
        //   $scope.claim.type = info.claim.type;
        //   $scope.claim2 = info.claim2;
        //   $scope.claim3 = info.claim3;
        // }
        if (step == 3) {
          myClaimApplySer.refreshInfo(claimId, claimType, billNum).then(function(data) {
            if (data.errcode == undefined || data.errcode == 0) {
              $scope.claim = data.errcode;
              $scope.claim3 = data.errcode;
              // $scope.claim.type = $scope.claimTypeList[data.claim.type];
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试',
              duration: 1000
            });
          });
        }
      });

    })


    //申请3
    .controller('myClaimApplyInfoCtrl', function($scope, $state, $stateParams, $location, $ionicLoading, $ionicModal, $ionicHistory, $cordovaDialogs, $ionicActionSheet, $cordovaCamera, $cordovaFileTransfer, templateUrlPath, myClaimApplySer, API) {
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.claim = {};
      $scope.claim2 = [];
      $scope.claim3 = {};

      var info = {};
      var step = $stateParams.step || 1;
      var claimId = $stateParams.claimId || 0;
      var claimType = $stateParams.claimType || 1;
      var billNum = $stateParams.billNum;

      $scope.urlPre = localStorage.getItem('bj12351.urlPre') || '';
      $scope.savePath1 = localStorage.getItem('bj12351.savePath1') || '';
      $scope.zoomPath1 = localStorage.getItem('bj12351.zoomPath1') || '';
      $scope.savePath2 = localStorage.getItem('bj12351.savePath2') || '';
      $scope.zoomPath2 = localStorage.getItem('bj12351.zoomPath2') || '';

      $scope.isReSubmit = 0;


      /**第一步-理赔险种**/
      $scope.reEdit = true; //是否可以修改



      /**打回记录修改图片后提交**/
      $scope.doReSubmit = function() {
        if ($scope.claim2[0] == undefined) {
          $cordovaDialogs.alert("请上传身份证/社保卡正面", '温馨提示', '好的');
          return;
        } else if ($scope.claim2[1] == undefined) {
          $cordovaDialogs.alert("请上传工会会员互助服务卡正面", '温馨提示', '好的');
          return;
        } else if ($scope.claim2[2] == undefined) {
          $cordovaDialogs.alert("请上传住院费用清单", '温馨提示', '好的');
          return;
        }
        $cordovaDialogs.confirm('确认提交申请', '温馨提示', ['确认', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            myClaimApplySer.reSubmit(claimId, claimType).then(function(data) {
              if (data.errcode == 0) {
                $cordovaDialogs.alert('提交申请成功', '温馨提示', '好的');
                $ionicHistory.goBack(-1);
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试',
                duration: 1000
              });
            });
          }
        });
      };

      /**提交**/
      $scope.doSubmit = function() {
        $cordovaDialogs.confirm('确认提交申请', '温馨提示', ['确认', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            myClaimApplySer.doSubmit(claimId, claimType, billNum, $scope.urlPre, $scope.savePath1, $scope.zoomPath1, $scope.savePath2, $scope.zoomPath2).then(function(data) {
              if (data.errcode == 0) {
                $cordovaDialogs.alert('提交申请成功', '温馨提示', '好的');
                $ionicHistory.goBack(-5);
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试',
                duration: 1000
              });
            });
          }
        });
      };

      /**退出理赔**/
      $scope.exit = function() {
        localStorage.removeItem('bj12351.urlPre');
        localStorage.removeItem('bj12351.savePath1');
        localStorage.removeItem('bj12351.zoomPath1');
        localStorage.removeItem('bj12351.savePath2');
        localStorage.removeItem('bj12351.zoomPath2');
        $ionicHistory.goBack(-5);
      };


      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }

        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      /**界面监听方法**/
      $scope.$on('$ionicView.beforeEnter', function() {
        info = myClaimApplySer.getInfo();
        if (step == 3) {
          myClaimApplySer.refreshInfo(claimId, claimType, billNum).then(function(data) {
            if (data.errcode == undefined || data.errcode == 0) {
              $scope.claim3 = data.errmsg;
              // $scope.claim.type = $scope.claimTypeList[data.claim.type];
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试',
              duration: 1000
            });
          });
        }
      });

    });

})();
