(function() {
  'use strict';

  angular
    .module('myClaimApply')
    .factory('myClaimApplySer', function($http, $q, API, $ionicLoading, $cordovaFileTransfer) {
      var info = {};
      return {
        getInfo: function() {
          return info;
        },

        clearInfo: function() {
          info = {};
        },

        addClaim: function(type, billNum) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getInsuranceHost() + '/claim/add_claim_' + type + '.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&type=' + type +
              '&billNum=' + billNum, {
                timeout: 20000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        getEffectClaimList: function(inh_no, product_type) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getInsuranceHost() + '/claim/effective_claim_list.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&product_type=' + product_type +
              '&inh_no=' + inh_no, {
                timeout: 300000
              })
            .success(function(data) {
              var listDataAll = angular.toJson(data);
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        refreshInfo: function(claimId, product_type, inh_no) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getInsuranceHost() + '/claim/getClaimInfo.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') + '&product_type=' + product_type + '&inh_no=' + inh_no + '&claim_id=' + claimId, {
                timeout: 60000
              })
            .success(function(data) {
              if (data.errcode == undefined) {
                info = data;
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        /**上传图片**/
        uploadPhoto: function(id_card_img, product_type, inh_no, imageURI) {
          var q = $q.defer();
          var server = API.getInsuranceHost() + '/claim/upload_photo.jsp' +
            '?token=' + localStorage.getItem('bj12351.token') +
            '&product_type=' + product_type +
            '&inh_no=' + inh_no +
            '&id_card_img=' + id_card_img;

          // var server = 'http://apppx.bjzgh12351.org/mobile/api/claim/upload_photo.jsp' +
          //   '?token=' + localStorage.getItem('bj12351.token') +
          //   '&product_type=' + product_type +
          //   '&inh_no=' + inh_no +
          //   '&id_card_img=' + id_card_img;

          // var server = API.getHost() + '/insurance/upload_photo.jsp' +
          //   '?token=' + localStorage.getItem('bj12351.token') +
          //   '&type=' + product_type +
          //   '&claim_id=0' +
          //   '&file_type=' + id_card_img;

          var options = {
            "encodeURI": true,
            "fileKey": "file",
            "chunkedMode": false,
            "fileName": imageURI.substr(imageURI.lastIndexOf('/') + 1),
            "mimeType": "image/jpeg"
          };

          $cordovaFileTransfer.upload(server, imageURI, options).then(function(data) {
            $ionicLoading.hide();
            q.resolve(JSON.parse(data.response));
          }, function(err) {
            $ionicLoading.hide();
            q.reject();
          }, function(progress) {
            var loaded = Math.floor(parseInt((progress.loaded / progress.total) * 100));
            $ionicLoading.show({
              template: '正在上传：' + loaded + '%'
            });
          });
          return q.promise;
        },

        /**上报**/
        doSubmit: function(claimId, product_type, inh_no, urlPre, savePath1, zoomPath1, savePath2, zoomPath2) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getInsuranceHost() + '/claim/add_claim.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&product_type=' + product_type +
              '&inh_no=' + inh_no +
              '&claim_id=' + claimId +
              '&urlPre=' + urlPre +
              '&savePath1=' + savePath1 +
              '&zoomPath1=' + zoomPath1 +
              '&savePath2=' + savePath2 +
              '&zoomPath2=' + zoomPath2, {
                timeout: 300000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        /**重新提交**/
        reSubmit: function(claimId, claimType) {
          var q = $q.defer();
          $http.get(API.getInsuranceHost() + '/claim/reportClaim.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&type=' + claimType +
              '&claim_id=' + claimId, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }
      };
    });
})();
