(function() {
  'use strict';
  angular
    .module('myClaimDetail')
    .controller('myClaimDetailCtrl', function($scope, $state, $ionicLoading, $ionicListDelegate, $cordovaDialogs, myClaimDetailSer, ylhzPaymentSer, $location, $ionicModal, templateUrlPath, $stateParams) {

      var page = 1;
      var size = 10;

      // $scope.user = ylhzPaymentSer.getUser();
      $scope.claims = [];
      $scope.hasMore = false;

      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.token = localStorage.getItem('bj12351.token');
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      });

      $scope.title = '申报明细';
      $scope.list_type = $stateParams.type;
      if ($stateParams.type == 2) {
        $scope.title = '支付成功';
      } else if ($stateParams.type == 3) {
        $scope.title = '申报失败';
      }
      /**刷新**/
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          // ylhzPaymentSer.refreshUser().then(function(data) {
          //   if (data.errcode == undefined) {
          //     $scope.user = data;
          //   }
          // });

          myClaimDetailSer.refreshClaims(page, size, $stateParams.type).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂无记录',
                    duration: 1000
                  });
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.claims = data;
              } else if (data.errcode == -1) {
                $cordovaDialogs.confirm('登录已失效', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };
      $scope.refresh();

      /**更多**/
      $scope.more = function() {
        if (localStorage.getItem('bj12351.token')) {
          ylhzPaymentSer.refreshUser().then(function(data) {
            if (data.errcode == undefined) {
              $scope.user = data;
            }
          });

          myClaimDetailSer.refreshClaims(page, size, $stateParams.type).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂无记录',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                }
                page++;
                $scope.claims = $scope.claims.concat(data);;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('登录已失效', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('尚未登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };

      /**删除**/
      $scope.doDelete = function(claimId, claimType) {
        $cordovaDialogs.confirm('确定删除此申请', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            myClaimDetailSer.deleteClaim(claimId, claimType).then(function(data) {
              if (data.errcode == 0) {
                $scope.refresh();
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          }
        });
      };


      /**路径跳转**/
      $scope.toPath = function(path) {
        $ionicHistory.clearCache().then(function() {
          myClaimApplySer.clearInfo();
          $location.path(path);
        });
      };
    });
})();
