(function() {
  'use strict';
  angular
    .module('myClaimDetail')
    .factory('myClaimDetailSer', function($q, $http, API, $ionicLoading) {
      return {
        refreshClaims: function(page, size, type) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getInsuranceHost() + '/claim/claim_list.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size + '&type=' + type, {
                timeout: 30000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        deleteClaim: function(claimId, claimType) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getInsuranceHost() + '/claim/del_claim.jsp', {
              token: localStorage.getItem('bj12351.token'),
              product_type2: claimType,
              claim_id: claimId
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };
    });
})();
