(function() {
  'use strict';

  angular
    .module('credits')
    .factory('creditsSer', function($http, $q, API, $ionicLoading, $cordovaFileTransfer) {
      var creditsList = JSON.parse(localStorage.getItem('bj12351.creditsList')) || [];
      var awardList = JSON.parse(localStorage.getItem('bj12351.awardList')) || [];
      var exchangeList = JSON.parse(localStorage.getItem('bj12351.exchangeList')) || [];
      return {
        getCreditsList: function() {
          return creditsList;
        },
        getAwardList: function() {
          return awardList;
        },
        getExchangeList: function() {
          return exchangeList;
        },
        refreshCreditsList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/credits-detail.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                creditsList = data;
                localStorage.setItem('bj12351.creditsList', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreCreditsList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/credits-detail.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        refreshExchangeList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/exchange-history.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                exchangeList = data;
                localStorage.setItem('bj12351.exchangeList', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreExchangeList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/exchange-history.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        creditsCount: function() {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/credits-count.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        refreshAwardList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/award-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                awardList = data;
                localStorage.setItem('bj12351.awardList', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreAwardList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/award-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        applyAward: function(award_id) { //用于实物、现场发放或邮寄类型
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/apply.jsp?token=' + localStorage.getItem('bj12351.token') + '&award_id=' + award_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        convertAward: function(award_apply_id, award_id, award_type, send_type, name, mobile, address, postcode) {
          var q = $q.defer();
          $http.get(API.getHost() + '/credits/convert.jsp?token=' + localStorage.getItem('bj12351.token') + '&award_apply_id=' + award_apply_id + '&award_id=' + award_id + '&award_type=' + award_type + '&send_type=' + send_type + '&name=' + name + '&mobile=' + mobile + '&address=' + address + '&postcode=' + postcode, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }
      };
    });
})();
