(function() {
  'use strict';

  angular
    .module('credits')
    .controller('creditsDetailCtrl', creditsDetailCtrl);

  creditsDetailCtrl.$inject = ['$scope', '$ionicSlideBoxDelegate', '$ionicLoading', '$state', '$interval', '$stateParams', '$location', '$cordovaDialogs', '$ionicModal', 'templateUrlPath', 'creditsSer'];

  function creditsDetailCtrl($scope, $ionicSlideBoxDelegate, $ionicLoading, $state, $interval, $stateParams, $location, $cordovaDialogs, $ionicModal, templateUrlPath, creditsSer) {
    $scope.creditsList = creditsSer.getCreditsList();
    var page = 1;
    var size = 20;
    $scope.hasMore = $scope.creditsList.length >= size;

    $scope.refresh = function() {
      creditsSer.refreshCreditsList(1, size).then(function(data) {
          if (data.errcode == undefined) {
            if (data.length == 0) {
              $ionicLoading.show({
                template: '暂时没有积分。',
                duration: 1000
              });
            } else if (data.length < size) {
              $scope.hasMore = false;
            } else {
              $scope.hasMore = true;
            }
            page = 2;
            $scope.creditsList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };
    $scope.refresh();

    $scope.more = function() {
      creditsSer.moreCreditsList(page, size).then(function(data) {
          if (data.errcode == undefined) {
            if (data.length == 0) {
              $ionicLoading.show({
                template: '没有更多积分。',
                duration: 1000
              });
              $scope.hasMore = false;
            } else if (data.length < size) {
              $scope.hasMore = false;
            }
            page++;
            $scope.creditsList = $scope.creditsList.concat(data);
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    };



    $scope.dir = "desc";
    $scope.changeSortAsc = function() {
      $scope.dir = "asc";
      // $scope.exchangRefresh();
    };

    $scope.changeSortDesc = function() {
      $scope.dir = "desc";
      // $scope.exchangRefresh();
    };
    $scope.toUrl = function(type, id) {
      if (type == 3 || type == 4) {
        $location.path('/tab/my-service/' + id + '/detail');
      }
    };
  }
})();
