(function() {
  'use strict';

  angular
    .module('credits')
    .controller('exchangeHistoryCtrl', exchangeHistoryCtrl);

  exchangeHistoryCtrl.$inject = ['$scope', '$ionicSlideBoxDelegate', '$ionicLoading', '$state', '$interval', '$stateParams', '$location', '$cordovaDialogs', '$ionicModal', 'templateUrlPath', 'creditsSer'];

  function exchangeHistoryCtrl($scope, $ionicSlideBoxDelegate, $ionicLoading, $state, $interval, $stateParams, $location, $cordovaDialogs, $ionicModal, templateUrlPath, creditsSer) {
    $scope.exchangeList = creditsSer.getExchangeList();
    var page = 1;
    var size = 10;
    $scope.hasMore = $scope.exchangeList.length >= size;
    $scope.refresh = function() {
      creditsSer.refreshExchangeList(1, size).then(function(data) {
          if (data.errcode == undefined) {
            if (data.length == 0) {
              $ionicLoading.show({
                template: '暂时没有兑换记录。',
                duration: 1000
              });
            } else if (data.length < size) {
              $scope.hasMore = false;
            } else {
              $scope.hasMore = true;
            }
            page = 2;
            $scope.exchangeList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };
    $scope.refresh();

    $scope.more = function() {
      creditsSer.moreExchangeList(page, size).then(function(data) {
          if (data.errcode == undefined) {
            if (data.length == 0) {
              $ionicLoading.show({
                template: '没有更多兑换记录。',
                duration: 1000
              });
              $scope.hasMore = false;
            } else if (data.length < size) {
              $scope.hasMore = false;
            }
            page++;
            $scope.exchangeList = $scope.exchangeList.concat(data);
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    };




  }
})();
