(function() {
  'use strict';
  angular
    .module('myEmployee')

    .controller('myEmployeeCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, $cordovaDialogs, myEmployeeSer, templateUrlPath) {
      var page = 1;
      var size = 10;
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.hy_id = $scope.user.hy_id || 0;

      $scope.hasMore = false;

      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.hy_id = $scope.user.hy_id || 0;
          myEmployeeSer.refresh($scope.hy_id, 1, size).then(function(data) {
              if (data.errcode === undefined) {
                if (data.length === 0) {
                  $ionicLoading.show({
                    template: '暂无预约服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.employees = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };
      $scope.refresh();

      //获取服务列表
      $scope.doRefresh = function() {
        $scope.refresh();
      };

      $scope.more = function() {
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
        $scope.hy_id = $scope.user.hy_id || 0;
        myEmployeeSer.more($scope.hy_id, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多预约服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.employees = $scope.employees.concat(data);
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };



      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
