(function() {
  'use strict';
  angular
    .module('myEmployeeDetail')

    .controller('myEmployeeDetailCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, $cordovaDialogs, myEmployeeDetailSer, templateUrlPath) {
      $scope.edit = {};
      $scope.edit.book_content = "";

      $scope.refresh = function() {
        myEmployeeDetailSer.detail($stateParams.bookId).then(function(data) {
            if (data.errcode == undefined) {
              $scope.service = data;
              $scope.edit.book_content = $scope.service.BookServiceContent;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
            $ionicHistory.goBack();
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      // 取消预约
      $scope.cancel = function() {
        if (localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您要取消预约吗？', '温馨提示', ['取消预约', '不取消']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              myEmployeeDetailSer.cancel($stateParams.bookId).then(function(data) {
                if (data.errcode == 0) {
                  $ionicLoading.show({
                    template: '取消成功。',
                    duration: 1000
                  });
                  $ionicHistory.goBack();
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              });
            }
          });
        } else {
          $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };

      //提交修改
      $scope.submit_emp = function() {
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.edit.book_content == undefined || $scope.edit.book_content == '') {
            $cordovaDialogs.alert('请填写预约服务内容', '温馨提示', '好的');
            return;
          }
          if ($scope.edit.book_content.length > 64) {
            $cordovaDialogs.alert('预约服务内容不能超过64个字', '温馨提示', '好的');
            return;
          }

          myEmployeeDetailSer.editContent($stateParams.bookId, $scope.edit.book_content).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功修改服务内容', '温馨提示', '好的').then(function() {
                $scope.closeModal('edit_employee');
              });
              $scope.refresh();
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                $scope.closeModal('edit_employee');
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      }


      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
