(function() {
  'use strict';
  angular
    .module('myEmployeeDetail')
    .factory('myEmployeeDetailSer', function($q, $http, API, $ionicLoading) {

      return {
        detail: function(book_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/employee/my-employee-info.jsp?token=' + localStorage.getItem('bj12351.token') + '&book_id=' + book_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //取消预定
        cancel: function(book_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/employee/cancel.jsp', {
              book_id: book_id,
              token: localStorage.getItem('bj12351.token')
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        //修改预定内容
        editContent: function(book_id, content) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/employee/edit.jsp', {
              token: localStorage.getItem('bj12351.token'),
              book_id: book_id,
              content: content
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }


      };
    });
})();
