(function() {
  'use strict';

  angular
    .module('logistics')
    .controller('logisticsCtrl', function($scope, $ionicSlideBoxDelegate, $ionicLoading, $state, $interval, $stateParams, $location, $cordovaDialogs, $ionicModal, templateUrlPath, $http, logisticsSer) {
      $scope.logisticsService = logisticsSer.getlogisticsService();
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.search = {};
      $scope.search.name = '';
      $scope.page = 1;
      $scope.size = 10;
      $scope.hasMore = $scope.logisticsService.length >= $scope.size;

      $scope.refresh = function() {
        logisticsSer.refreshLogisticsService($scope.search.name, $scope.user.id_card, 1, $scope.size)
          .then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '暂时没有物流信息。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < $scope.size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              $scope.page = 2;
              $scope.logisticsService = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      $scope.more = function() {
        logisticsSer.moreLogisticsService($scope.search.name, $scope.user.id_card, $scope.page, $scope.size)
          .then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '没有更多物流信息。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < $scope.size) {
                $scope.hasMore = false;
              }
              $scope.page++;
              $scope.logisticsService = $scope.logisticsService.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
      };

    });
})();
