(function() {
  'use strict';
  angular
    .module('logistics')
    .factory('logisticsSer', function($http, API, $q, $ionicLoading) {
      var logistics_service = JSON.parse(localStorage.getItem('bj12351.logistics_service')) || [];

      return {
        getlogisticsService: function() {
          return logistics_service;
        },
        refreshLogisticsService: function(name, idcode, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/logistics.jsp?name=' + name + '&idcode=' + idcode + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                logistics_service = data;
                localStorage.setItem('bj12351.logistics_service', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreLogisticsService: function(name, idcode, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/logistics.jsp?name=' + name + '&idcode=' + idcode + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
