(function() {
  'use strict';
  angular
    .module('myMessageDetail')
    .controller('myMessageDetailCtrl', function($scope, $state, $ionicHistory, $ionicListDelegate, $ionicScrollDelegate, $stateParams, $cordovaDialogs, $ionicModal, $ionicLoading, $location, myMessageDetailSer, templateUrlPath) {
      $scope.pro = $stateParams.proId;
      $scope.mes = 'one';
      var messageType = 1;

      var page = 1;
      var size = 10;
      $scope.hasMore = false;
      $scope.userDrag = false;

      function calcType() {
        switch ($scope.pro) {
          case '0':
            if ($scope.mes == 'one') {
              messageType = 1;
            } else if ($scope.mes == 'two') {
              messageType = 2;
            } else if ($scope.mes == 'three') {
              messageType = 3;
            }
            break;

          case '1':
            messageType = 4;
            break;

          case '2':
            messageType = 5;
            break;

          case '3':
            if ($scope.mes == 'one') {
              messageType = 6;
            } else if ($scope.mes == 'two') {
              messageType = 7;
            }
            break;

          case '4':
            messageType = 8;
            break;

          case '5':
            if ($scope.mes == 'one') {
              messageType = 9;
            } else if ($scope.mes == 'two') {
              messageType = 10;
            }
            break;

          case '6':
            if ($scope.mes == 'one') {
              messageType = 11;
            } else if ($scope.mes == 'two') {
              messageType = 12;
            } else if ($scope.mes == 'three') {
              messageType = 13;
            } else if ($scope.mes == 'four') {
              messageType = 14;
            }
            break;

          case '7':
            messageType = 15;
            break;
        }
      }

      /**选择分组**/
      $scope.switchbg = function(type) {
        $scope.mes = type;
        $scope.userDrag = false; //用户上拉手势置为false
        $scope.hasMore = false; //是否更多置为false
        $ionicScrollDelegate.scrollTop(false); //滚动至顶部 无动画
        $scope.refresh();
      };

      /**用户上拉手势**/
      $scope.dragUp = function() {
        $scope.userDrag = true;
      };

      /**刷新**/
      $scope.refresh = function() {
        calcType();
        if (localStorage.getItem('bj12351.token')) {
          myMessageDetailSer.getMessages(messageType, 1, size).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂无消息',
                    duration: 1000
                  });
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.messages = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      $scope.more = function() {
        if (localStorage.getItem('bj12351.token')) {
          myMessageDetailSer.getMessages(messageType, page, size).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page++;
                $scope.messages = $scope.messages.concat(data);
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        } else {
          $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      /**删除消息**/
      $scope.doDelete = function(index, message_id) {
        $cordovaDialogs.confirm('确定删除此消息', '温馨提示', ['确定', '取消']).then(function(buttonIndex) {
          $ionicListDelegate.closeOptionButtons();
          if (buttonIndex == 2) {
            return;
          }

          if (localStorage.getItem('bj12351.token')) {
            myMessageDetailSer.doDelete(message_id, index).then(function(data) {
              if (data.errcode == 0) {
                $scope.refresh();
              } else if (data.errcode == -1) {
                $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else if (data.errcode == -2) {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function() {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          } else {
            $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          }
        });
      };

      /**跳转服务详情**/
      $scope.toUrl = function(id) {
        if (id > 0) {
          $location.path('/tab/service/' + id + '/detail');
        }
      };

      $scope.$on('$ionicView.beforeEnter', function() {
        $scope.refresh();
      });
    });
})();
