(function() {
  'use strict';
  angular
    .module('myMessageSetting')
    .controller('myMessageSettingCtrl', function($scope, $state, $ionicLoading, $cordovaDialogs, myMessageSettingSer) {
      $scope.serviceForeshow = true;
      $scope.membership = true;
      $scope.mutual = true;
      $scope.boost = true;
      $scope.recovery = true;

      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          myMessageSettingSer.refresh().then(function(data) {
              if (data.errcode == undefined) {
                $scope.serviceForeshow = data.service_foreshow == 1;
                $scope.membership = data.membership == 1;
                $scope.mutual = data.mutual == 1;
                $scope.boost = data.boost == 1;
                $scope.recovery = data.recovery == 1;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(err) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };
      $scope.refresh();

      $scope.switch = function(type, choose) {
        if (localStorage.getItem('bj12351.token')) {
          if (choose) {
            choose = 1;
          } else {
            choose = 2;
          }
          myMessageSettingSer.pushSwitch(type, choose).then(function(data) {
            if (data.errcode != 0) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(err) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.confirm('登录失效，请重新登录', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

    });
})();
