(function() {
  'use strict';
  angular
    .module('myMessageSetting')
    .factory('myMessageSettingSer', function($http, API, $q, $ionicLoading) {
      return {
        refresh: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/user/message-setting.jsp' +
              '?token=' + localStorage.getItem('bj12351.token'), {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //消息开关
        pushSwitch: function(type, choose) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/message-switch.jsp', {
              token: localStorage.getItem('bj12351.token'),
              type: type,
              choose: choose
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
