(function() {
  'use strict';
  angular
    .module('myReserve')
    .controller('myReserveCtrl', function($scope, $state, $ionicLoading, $ionicListDelegate, $cordovaDialogs, myReserveSer, $location, $ionicModal, templateUrlPath) {
      $scope.reserveList = myReserveSer.getReserveList();
      var page = 1;
      var size = 10;
      $scope.hasMore = $scope.reserveList.length >= size;
      $scope.refresh = function() {
        myReserveSer.refreshReserveList(1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂时没有预约。',
                  duration: 1000
                });
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.reserveList = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      /**更多**/
      $scope.more = function() {
        myReserveSer.moreReserveList(page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '没有更多预约。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.reserveList = $scope.reserveList.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };
      $scope.hideDetail = function(index) {
        $scope.reserveList[index].hideDetail = !$scope.reserveList[index].hideDetail;
      };


      $scope.addReserve = {};
      $scope.search = {};
      $scope.addReserve.firm = {};
      $scope.addReserve.firm.code = '';
      $scope.addReserve.firm.name = '请选择';
      $scope.addReserve.orderTime = '';
      $scope.addReserve.submitOrderTime = '';
      $scope.addReserve.title = '';
      $scope.addReserve.content = '';
      $scope.addReserve.linkman = '';
      $scope.search.firm = '';
      $scope.firmList = [];



      $scope.searchStation = function() {
        if ($scope.search.firm === '') {
          $cordovaDialogs.alert('服务站名称不能为空', '温馨提示', '好的');
          return;
        }
        myReserveSer.searchStation($scope.search.firm).then(function(data) {
          if (data.errcode == undefined) {
            $scope.firmList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      $scope.submit = function() {
        if ($scope.addReserve.firm == {}) {
          $cordovaDialogs.alert('请选择工会服务站', '温馨提示', '好的');
          return;
        }
        if ($scope.addReserve.firm.code == '') {
          $cordovaDialogs.alert('请选择工会服务站', '温馨提示', '好的');
          return;
        }
        if ($scope.addReserve.orderTime == '') {
          $cordovaDialogs.alert('请选择预约时间', '温馨提示', '好的');
          return;
        }
        if ($scope.addReserve.title == '') {
          $cordovaDialogs.alert('请填写预约业务', '温馨提示', '好的');
          return;
        }
        if ($scope.addReserve.content == '') {
          $cordovaDialogs.alert('请填写预约服务内容', '温馨提示', '好的');
          return;
        }

        var minutes = '';
        if ($scope.addReserve.orderTime.getMinutes() < 10) {
          minutes = '0' + $scope.addReserve.orderTime.getMinutes();
        } else {
          minutes = $scope.addReserve.orderTime.getMinutes();
        }

        $scope.addReserve.submitOrderTime = $scope.addReserve.orderTime.getFullYear() + '-' + ($scope.addReserve.orderTime.getMonth() + 1) + '-' + $scope.addReserve.orderTime.getDate() + ' ' + $scope.addReserve.orderTime.getHours() + ':' + minutes + ':00';

        myReserveSer.addReserve($scope.addReserve.content, $scope.addReserve.title, $scope.addReserve.submitOrderTime, $scope.addReserve.linkman, $scope.addReserve.firm.code).then(function(data) {
          if (data.errcode === 0) {
            $scope.addReserve = {};
            $scope.search = {};
            $scope.addReserve.firm = {};
            $scope.addReserve.firm.code = '';
            $scope.addReserve.firm.name = '请选择';
            $scope.addReserve.orderTime = '';
            $scope.addReserve.submitOrderTime = '';
            $scope.addReserve.title = '';
            $scope.addReserve.content = '';
            $scope.addReserve.linkman = '';
            $scope.search.firm = '';
            $scope.firmList = [];
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $scope.closeModalAndClear('reserve_station');
          } else if (data.errcode == -1) {
            $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };


      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.closeModalAndClear = function(modal_name) {
        $scope.addReserve = {};
        $scope.search = {};
        $scope.addReserve.firm = {};
        $scope.addReserve.firm.code = '';
        $scope.addReserve.firm.name = '请选择';
        $scope.addReserve.orderTime = '';
        $scope.addReserve.submitOrderTime = '';
        $scope.addReserve.title = '';
        $scope.addReserve.content = '';
        $scope.addReserve.linkman = '';
        $scope.search.firm = '';
        $scope.firmList = [];
        $scope.modal[modal_name].remove();
      };

    });
})();
