(function() {
  'use strict';
  angular
    .module('myReserve')
    .factory('myReserveSer', function($q, $http, API, $ionicLoading) {
      var reserveList = JSON.parse(localStorage.getItem('bj12351.reserveList')) || [];
      return {
        getReserveList: function() {
          return reserveList;
        },
        refreshReserveList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/reserve-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                reserveList = data;
                localStorage.setItem('bj12351.reserveList', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreReserveList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/reserve-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        addReserve: function(content, title, order_time, link_man, firm_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/add-reserve.jsp', {
              token: localStorage.getItem('bj12351.token'),
              content: content,
              title: title,
              order_time: order_time,
              link_man: link_man,
              firm_id: firm_id
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        searchStation: function(station_name) {
          var q = $q.defer();
          $http.get(API.getHost() + '/station/search.jsp?station_name=' + station_name, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }
      };
    });
})();
