(function() {
  'use strict';
  angular
    .module('myService')
    .controller('myServiceCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, $cordovaDialogs, myServiceSer, templateUrlPath) {
      $scope.search = {};
      $scope.search.name = '';
      $scope.services = myServiceSer.getMyServices();
      $scope.cancell_show = true;
      $scope.comment = {};
      $scope.comment_station = {};

      $scope.uncomment = myServiceSer.getUncomment();

      myServiceSer.getUnusedCount(localStorage.getItem('bj12351.token'))
        .then(function(data) {
          $scope.unused = data.count;
        });
      myServiceSer.getCancelledCount(localStorage.getItem('bj12351.token'))
        .then(function(data) {
          $scope.cancelled = data.count;
          if (localStorage.getItem('bj12351.cancel_cnt')) {
            if (localStorage.getItem('bj12351.cancel_cnt') == $scope.cancelled) {
              // localStorage.setItem('bj12351.cancel_cnt', $scope.cancelled);
              $scope.cancell_show = false;
            }
          } else {
            localStorage.setItem('bj12351.cancel_cnt', $scope.cancelled);
          }
        });
      myServiceSer.checkComment(localStorage.getItem('bj12351.token'))
        .then(function() {
          $scope.uncomment = myServiceSer.getUncomment();
        });


      var page = 1;
      var size = 10;

      $scope.hasMore = false;
      $scope.group = 'unused';
      /**选择分组**/
      $scope.switchGrp = function(type) {
        if (type == 'all') {
          $state.go('tab.myServiceAll');
        } else {
          $scope.group = type;
          localStorage.setItem('bj12351.service_type', type);
          if ($scope.group == 'cancel') {
            $scope.cancell_show = false;
            localStorage.setItem('bj12351.cancel_cnt', $scope.cancelled);
          }
          $scope.refresh();
        }
      };
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          $scope.group = localStorage.getItem('bj12351.service_type') || 'unused';
          myServiceSer.refresh($scope.search.name, $scope.group, 1, size).then(function(data) {
              if (data.errcode === undefined) {
                if (data.length === 0) {
                  $ionicLoading.show({
                    template: '暂无服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                if ($scope.group == 'cancell') {
                  $scope.cancelled = 0;
                }
                $scope.services = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };
      $scope.refresh();

      //获取服务列表
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      $scope.more = function() {
        $scope.group = localStorage.getItem('bj12351.service_type') || 'unused';
        myServiceSer.more($scope.search.name, $scope.group, page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.services = $scope.services.concat(data);
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**选择预约时间**/
      $scope.selectStationDate = function(event) {
        event.preventDefault();
        $scope.openModal('reserve/select_station_date');
      };

      /**添加评价**/
      $scope.addComment = function(index, event) {
        event.preventDefault();
        $scope.serchant = $scope.services[index];
        $scope.comment = {};
        $scope.openModal('comment/list_add_comment');
      };

      /**提交评价**/

      $scope.submitComment = function(apply_id) {
        var token = localStorage.getItem('bj12351.token');
        var name = JSON.parse(localStorage.getItem('bj12351.user')).name;
        var star = $scope.comment.star;
        var content = $scope.comment.content;
        var star_station = $scope.comment_station.star;
        var content_station = $scope.comment_station.content;
        var is_anonymity = $scope.comment.is_anonymity;
        if (token) {
          myServiceSer.submitComment(apply_id, content, star, content_station, star_station, is_anonymity).then(function(data) {
            if (data.errcode !== undefined && data.errcode !== 0) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            } else {
              $scope.modal['comment/list_add_comment'].remove();
              $cordovaDialogs.alert('评价成功。', '温馨提示', '好的');
              for (var i = 0; i < $scope.services.length; i++) {
                if (apply_id === $scope.services[i].id) {
                  $scope.services[i].is_comment = true;
                }
              }
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      /*=================服务项目点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];
        if ($scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.service_id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          }
        }
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.comment.star = 5;
          $scope.comment.content = '';
          $scope.comment_station.star = 5;
          $scope.comment_station.content = '';
          $scope.comment.is_anonymity = true;
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    })

    .controller('myServiceAllCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, $cordovaDialogs, myServiceSer, templateUrlPath) {
      $scope.search = {};
      $scope.search.name = '';
      $scope.services = myServiceSer.getMyServices();

      $scope.comment = {};
      $scope.comment_station = {};

      var page = 1;
      var size = 10;

      $scope.hasMore = false;

      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          myServiceSer.refresh($scope.search.name, 'all', 1, size).then(function(data) {
              if (data.errcode === undefined) {
                if (data.length === 0) {
                  $ionicLoading.show({
                    template: '暂无服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.services = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };
      $scope.refresh();

      //获取服务列表
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      $scope.more = function() {
        myServiceSer.more($scope.search.name, 'all', page, size).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '无更多服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.services = $scope.services.concat(data);
            } else {
              $scope.hasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**选择预约时间**/
      $scope.selectStationDate = function(event) {
        event.preventDefault();
        $scope.openModal('reserve/select_station_date');
      };

      /**添加评价**/
      $scope.addComment = function(index, event) {
        event.preventDefault();
        $scope.serchant = $scope.services[index];
        $scope.comment = {};
        $scope.openModal('comment/list_add_comment');
      };

      /**提交评价**/

      $scope.submitComment = function(apply_id) {
        var token = localStorage.getItem('bj12351.token');
        var name = JSON.parse(localStorage.getItem('bj12351.user')).name;
        var star = $scope.comment.star;
        var content = $scope.comment.content;
        var star_station = $scope.comment_station.star;
        var content_station = $scope.comment_station.content;
        var is_anonymity = $scope.comment.is_anonymity;
        if (token) {
          myServiceSer.submitComment(apply_id, content, star, content_station, star_station, is_anonymity).then(function(data) {
            if (data.errcode !== undefined && data.errcode !== 0) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            } else {
              $scope.modal['comment/list_add_comment'].remove();
              $cordovaDialogs.alert('评价成功。', '温馨提示', '好的');
              for (var i = 0; i < $scope.services.length; i++) {
                if (apply_id === $scope.services[i].id) {
                  $scope.services[i].is_comment = true;
                }
              }
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      /*=================服务项目点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];
        if ($scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.service_id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          }
        }
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.comment.star = 5;
          $scope.comment.content = '';
          $scope.comment_station.star = 5;
          $scope.comment_station.content = '';
          $scope.comment.is_anonymity = true;
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
