(function() {
  'use strict';
  angular
    .module('myService')
    .factory('myServiceSer', function($q, $http, API, $ionicLoading) {
      var myServices = JSON.parse(localStorage.getItem('bj12351.my_services')) || [];
      var uncomment = 0;
      return {
        getMyServices: function() {
          return myServices;
        },

        refresh: function(service_name, type, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/my-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&type=' + type + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                myServices = data;
                localStorage.setItem('bj12351.my_services', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        more: function(service_name, type, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/my-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&type=' + type + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        submitComment: function(apply_id, content, star, content_station, star_station, is_anonymity) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/service/comment.jsp', {
              token: localStorage.getItem('bj12351.token'),
              apply_id: apply_id,
              content: content,
              star: star,
              content_station: content_station,
              star_station: star_station,
              is_anonymity: is_anonymity
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        setMyServiceIsComment: function(apply_id, is_comment) {
          for (var i = 0; i < myServices[i].length; i++) {
            if (apply_id === myServices[i].id) {
              myServices[i].is_comment = is_comment;
            }
          }
        },
        postServiceLikes: function(token, batch_id, is_likes) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/service/service-likes.jsp', {
              token: token,
              batch_id: batch_id,
              is_likes: is_likes
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },
        getUnusedCount: function(token) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/unused-count.jsp?token=' + token, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '没有信息',
                  duration: 1000
                });
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        getCancelledCount: function(token) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/cancelled-count.jsp?token=' + token, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '没有信息',
                  duration: 1000
                });
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        getUncomment: function() {
          return uncomment;
        },
        checkComment: function(token) {
          var q = $q.defer();
          $http.get(API.getHost() + '/user/count-uncomment.jsp?token=' + token)
            .success(function(data) {
              if (data.errcode === undefined) {
                uncomment = data.count_uncomment || 0;
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
