(function() {
  'use strict';
  angular
    .module('myServiceDetail')
    .controller('myServiceDetailCtrl', function($scope, $state, $stateParams, $ionicHistory, $ionicLoading, $cordovaDialogs, $ionicModal, $sce, myServiceDetailSer, serviceDetailSer, templateUrlPath, myServiceSer) {
      $scope.service = {};
      $scope.comment = {};
      $scope.comments = [];
      $scope.comment_station = {};

      var page = 1;
      var size = 10;
      $scope.commentHasMore = false;
      $scope.hideComment = true;

      //查看大图
      $scope.viewPic = function(modal_name, url) {
        $scope.largePic = url;
        $scope.openModal(modal_name);
      };

      $scope.refresh = function() {
        myServiceDetailSer.detail($stateParams.serviceId).then(function(data) {
            if (data.errcode == undefined) {
              $scope.service = data;
              $scope.service.description = $sce.trustAsHtml(data.description);
              $scope.refreshComments();
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
            $ionicHistory.goBack();
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      /**刷新评论**/
      $scope.refreshComments = function() {
        serviceDetailSer.getComments($scope.service.id, 1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length < size) {
                $scope.commentHasMore = false;
              } else {
                $scope.commentHasMore = true;
              }
              page = 2;
              $scope.comments = data;
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };

      /**更多评论**/
      $scope.moreComments = function() {
        serviceDetailSer.getComments($scope.service.id, page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length < size) {
                $scope.commentHasMore = false;
              }
              page++;
              $scope.comments = $scope.comments.concat(data);
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**添加评论**/
      $scope.submitComment = function(modal_name) {
        var star = $scope.comment.star;
        var content = $scope.comment.content;
        var star_station = $scope.comment_station.star;
        var content_station = $scope.comment_station.content;
        var is_anonymity = $scope.comment.is_anonymity;
        if (localStorage.getItem('bj12351.token')) {
          myServiceSer.submitComment($stateParams.serviceId, content, star, content_station, star_station, is_anonymity).then(function(data) {
            if (data.errcode == 0) {
              var now = new Date();
              $scope.comments.unshift({
                content: content,
                star: star,
                is_anonymity: is_anonymity,
                member_name: JSON.parse(localStorage.getItem('bj12351.user')).name,
                create_at: now.getFullYear() + '-' + (now.getMonth() + 1) + '-' + now.getDate() + ' ' + now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds()
              });
              $scope.closeModal(modal_name);
              $cordovaDialogs.alert('评价成功。', '温馨提示', '好的');
              myServiceSer.setMyServiceIsComment($stateParams.service_id, true);
              $scope.refresh();
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.confirm('您尚未登录哦。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            }
          });
        }
      };

      /**取消预订**/
      $scope.cancel = function() {
        if (localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您要取消预定吗？', '温馨提示', ['取消预定', '不取消']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              myServiceDetailSer.cancel($stateParams.serviceId).then(function(data) {
                if (data.errcode == 0) {
                  $ionicLoading.show({
                    template: '取消成功。',
                    duration: 1000
                  });
                  $ionicHistory.goBack();
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              });
            }
          });
        } else {
          $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.comment.star = 5;
          $scope.comment.content = '';
          $scope.comment_station.star = 5;
          $scope.comment_station.content = '';
          $scope.comment.is_anonymity = true;
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });

    });
})();
