(function() {
  'use strict';
  angular
    .module('myServiceDetail')
    .factory('myServiceDetailSer', function($q, $http, $ionicLoading, API) {
      return {
        detail: function(service_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/service/my-service-info.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_id=' + service_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //取消预定
        cancel: function(service_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.post(API.getHost() + '/service/cancel.jsp', {
              service_id: service_id,
              token: localStorage.getItem('bj12351.token')
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
