(function() {
  'use strict';
  angular
    .module('mySignIn')
    .controller('mySignInCtrl', function($scope, $state, $stateParams, $ionicHistory, $ionicLoading, $cordovaDialogs, $ionicModal, templateUrlPath, mySignInSer) {
      var signed = [];
      var date = new Date();
      Calendar.init(date);

      $scope.refresh = function() {
        mySignInSer.signed().then(function(data) {
            if (data.errcode === undefined) {
              signed = data;

              // $("#calendar").html(Calendar.getCalendar([1, 2, 3, 4, 5]));
              $("#calendar").html(Calendar.getCalendar(signed));
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      $scope.signin = function() {
        mySignInSer.signin().then(function(data) {
          if (data.errcode === 0) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $scope.refresh();
          } else if (data.errcode === -1) {
            $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        });
      };


    });
})();
