(function () {
  'use strict';
  angular
    .module('oauth')
    .controller('oauthCtrl', function ($cordovaDialogs, $scope, $ionicLoading, $cordovaDevice, $http, oauthSer) {
      $scope.user = JSON.parse(localStorage.getItem('bj12351.user')) || {};
      $scope.token = localStorage.getItem('bj12351.token');
      $scope.appId = localStorage.getItem('bj12351.third_appId');
      $scope.secret = localStorage.getItem('bj12351.third_secret');
      $scope.third_app = {};

      $scope.$on('$ionicView.beforeEnter', function () {
        $scope.token = localStorage.getItem('bj12351.token');
        
        if ($scope.user == {}) {
          oauthSer.getUserInfo();
        }


        oauthSer.getThirdApp().then(function (data) {
          if (data.errcode === undefined) {
            $scope.third_app = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function () {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });


      });

      /**授权**/
      $scope.oauth = function () {
        oauthSer.oauth($scope.appId, $scope.secret, $scope.third_app.redirect_uri, $scope.token).then(function (data) {
          if (data.errcode === 0) {
            if (startApp) {
              //判断是IOS和Android版本
              if ($cordovaDevice.getPlatform() === 'iOS') {
                var sApp = startApp.set($scope.third_app.ios_urlSchema+"://?code=" + data.code);
                sApp.start(function () {
                  $scope.exitApp();
                }, function (error) { /* fail */
                  console.log('start fail', error)
                });
                $scope.exitApp();
              } else {
                var sApp = startApp.set({
                  "application": $scope.third_app.package_name,
                  "component": [$scope.third_app.package_name,$scope.third_app.activity_name]
                },
                  {
                    "code": data.code
                  });
                sApp.start(function () {
                  ionic.Platform.exitApp();
                }, function (error) { /* fail */
                  console.log('start fail', error)
                });
                ionic.Platform.exitApp();
              }
            }
          }
        }, function () {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**退出app**/
      $scope.exitApp = function () {
        var app = window.plugins.app;
        app.exit({
          "platform": $cordovaDevice.getPlatform()
        });
      }


    });
})();
