(function() {
  'use strict';
  angular
    .module('oauth')
    .factory('oauthSer', function($q, $http, $ionicLoading, API) {
      var user = JSON.parse(localStorage.getItem('bj12351.user'));

      return {
        getUserInfo: function() {
          return user;
        },
        getThirdApp:function(){
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getOauthHost() + '/core/app-info.jsp', {
              appId: localStorage.getItem('bj12351.third_appId')
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
        ,
        oauth: function(appId, secret, redirect_uri,token) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getOauthHost() + '/core/code.jsp', {
              appId: appId,
              secret: secret,
              redirect_uri: redirect_uri,
              token: token
            }, {
              timeout: 10000
            })
            .success(function(data) {
              // alert(data.errcode);
              // alert(data.code);
              if (data.errcode == 0) {
                localStorage.setItem('bj12351.third_code', data.code);
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };
    });
})();
