(function() {
  'use strict';
  angular
    .module('oauthLogin')
    .factory('oauthLoginSer', function($q, $http, $ionicLoading, API) {
      var user = JSON.parse(localStorage.getItem('bj12351.user')) || {};

      return {
        getUserInfo: function() {
          return user;
        },

        login: function(login_name, password, login_type) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/login.jsp', {
              login_name: login_name,
              password: password,
              login_type: login_type
            }, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode == 0) {
                localStorage.setItem('bj12351.token', data.token);
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //获取用户信息
        info: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/user/info.jsp?token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                user = data;
                localStorage.setItem('bj12351.user', JSON.stringify(data));
                localStorage.setItem('bj12351.id_card', data.id_card);
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();