(function() {
  'use strict';

  angular
    .module('protectRight')
    .controller('protectRightCtrl', function($scope, $cordovaDialogs, $ionicLoading, $ionicHistory, protectRightSer) {
      $scope.user = {};
      $scope.user.name = '';
      $scope.user.gender = "0";
      $scope.user.phone = '';
      $scope.user.email = '';
      $scope.user.title = '';
      $scope.user.content = '';

      $scope.submit = function() {
        if ($scope.is_help === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.is_help = true;

        if ($scope.user.name == "") {
          $cordovaDialogs.alert('姓名不能为空！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.gender == "0") {
          $cordovaDialogs.alert('请选择性别！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.phone.toString().length != 11) {
          $cordovaDialogs.alert('请正确填写手机号！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.email == "") {
          $cordovaDialogs.alert('邮箱不能为空！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.title == "") {
          $cordovaDialogs.alert('主题不能为空！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }
        if ($scope.user.title !== "" && $scope.user.title.length > 64) {
          $cordovaDialogs.alert('主题不能超过64个字！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.content == "") {
          $cordovaDialogs.alert('求助内容不能为空！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        if ($scope.user.content !== "" && $scope.user.content.length > 500) {
          $cordovaDialogs.alert('求助内容不能超过500个字！', '温馨提示', '好的');
          $scope.is_help = false;
          return;
        }

        protectRightSer.protect($scope.user.name, $scope.user.gender, $scope.user.phone, $scope.user.email, $scope.user.title, $scope.user.content).then(function(data) {
          if (data.errcode == 0) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $scope.user.name = '';
            $scope.user.gender = '';
            $scope.user.phone = '';
            $scope.user.email = '';
            $scope.user.title = '';
            $scope.user.content = '';
            $ionicHistory.goBack();
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $scope.is_help = false;
          } else {
            $cordovaDialogs.alert('提交失败，请稍后重试。', '温馨提示', '好的');
            $scope.is_help = false;
          }
        }, function() {
          $scope.is_help = false;
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

    });
})();
