(function() {
  'use strict';
  angular
    .module('receive')
    .controller('receiveCtrl', function($scope, $state, $cordovaDialogs, $ionicModal, $ionicLoading, $ionicListDelegate, mySer, receiveSer, codelistSer, templateUrlPath) {
      $scope.user = mySer.getUserInfo();
      $scope.select_areas = JSON.parse(localStorage.getItem('bj12351.ct_area_beijing'));
      $scope.select_areas.unshift({
        code: 0,
        name: '--请选择区域--'
      });

      $scope.add = {};
      $scope.add.address = '';
      $scope.add.post_code = '';
      $scope.add.detail_address = '';
      $scope.add.select_area = $scope.select_areas[0];

      /**删除**/
      $scope.doDelete = function(index, receive) {
        receiveSer.doDelete(receive.id).then(function(data) {
          if (data.errcode === 0) {
            $scope.user.receives.splice(index, 1);
            localStorage.setItem('bj12351.user', JSON.stringify($scope.user));
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录已失效，请重新登录', '温馨提示', '好的');
            // $state.go('tab.login');
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**添加**/
      $scope.doAdd = function() {
        if ($scope.add.select_area.code === 0) {
          $cordovaDialogs.alert('请选择区域', '温馨提示', '好的');
          return;
        }

        if ($scope.add.detail_address === '') {
          $cordovaDialogs.alert('请填写完整的详细地址', '温馨提示', '好的');
          return;
        }

        if ($scope.add.post_code === '') {
          $cordovaDialogs.alert('请填写邮政编码', '温馨提示', '好的');
          return;
        }

        $scope.add.address = '北京市' + $scope.add.select_area.name + $scope.add.detail_address;
        var receive = {
          id: '',
          address: $scope.add.address,
          post_code: $scope.add.post_code
        };

        receiveSer.doAdd($scope.add.address, $scope.add.post_code).then(function(data) {
          if (data.errcode === 0) {
            mySer.info().then(function(data) {
              $scope.user = data;
              if ($scope.user.receives.length == 1) {
                $scope.setDefault(0, $scope.user.receives[index]);
              }
            });
            $scope.add.post_code = '';
            $scope.add.detail_address = '';
            $scope.closeModal('add_receive');
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录已失效，请重新登录', '温馨提示', '好的');
            // $state.go('tab.login');
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**设为默认**/
      $scope.setDefault = function(index, receive) {
        receiveSer.setDefault(receive.id).then(function(data) {
          if (data.errcode === 0) {
            //设置默认地址成功
            for (var i = 0; i < $scope.user.receives.length; i++) {
              $scope.user.receives[i].is_default = false;
            }
            $scope.user.receives[index].is_default = true;

            localStorage.setItem('bj12351.user', JSON.stringify($scope.user));
            $ionicListDelegate.closeOptionButtons();
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录已失效，请重新登录', '温馨提示', '好的');
            // $state.go('tab.login');
            $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
            if ($scope.is_gesture === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.add.post_code = '';
          $scope.add.detail_address = '';
          $scope.add.select_area = $scope.select_areas[0];
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
