(function() {
  'use strict';
  angular
    .module('receive')
    .factory('receiveSer', function($http, API, $q, $ionicLoading) {
      return {
        doDelete: function(receive_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/delete-receive.jsp', {
              token: localStorage.getItem('bj12351.token'),
              receive_id: receive_id
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        doAdd: function(address, post_code) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/add-receive.jsp', {
              token: localStorage.getItem('bj12351.token'),
              address: address,
              post_code: post_code
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        setDefault: function(receive_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/set-default-receive.jsp', {
              token: localStorage.getItem('bj12351.token'),
              receive_id: receive_id
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
