(function() {
  'use strict';
  angular
    .module('register')
    .controller('registerCtrl', function($scope, $ionicLoading, $location, $state, $ionicHistory, $cordovaDialogs, $interval, $ionicPopover, md5Ser, mySer, registerSer) {
      $scope.register = {};

      $scope.register.name = '';
      $scope.register.card = '';
      $scope.register.phone = '';
      $scope.register.verification_code = '';
      $scope.register.pw = '';
      $scope.register.checked = false;

      $scope.gain_code = '发送验证码';
      var token = '';

      function countDown() {
        $scope.gain_code = '发送中' + '(' + 90 + 's)';
        var wait = 90;
        if (count !== undefined) {
          $interval.cancel(count);
        }
        var count = $interval(function() {
          $scope.gain_code = '发送中' + '(' + wait + 's)';
          wait--;
          if (wait === 0) {
            $interval.cancel(count);
            $scope.gain_code = '发送验证码';
            $scope.register.checked = false;
          }
        }, 1000);
      }

      $scope.verify = function() {
        registerSer.verify($scope.register.name, $scope.register.card.toUpperCase(), 1).then(function(data) {
          if (data.errcode === 0) {
            token = data.token;
            localStorage.setItem('bj12351.temptoken', data.token);
            $scope.register.name = '';
            $scope.register.card = '';
            $location.path('/tab/reg-done');
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      $scope.send_code = function() {
        token = localStorage.getItem('bj12351.temptoken'); //获取temptoken
        registerSer.sendValidCode(token, $scope.register.phone).then(function(data) {
          if (data.errcode === 0) {
            $scope.register.checked = true;
            countDown();
          } else {
            $cordovaDialogs.alert("网络繁忙，请返回重新验证。", '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      $scope.register_judge = function() {
        token = localStorage.getItem('bj12351.temptoken'); //获取temptoken
        localStorage.removeItem('bj12351.temptoken'); //移除temptoken
        localStorage.setItem('bj12351.token', token);
        registerSer.modifyPhone(token, $scope.register.phone, $scope.register.verification_code, md5Ser.md5($scope.register.pw)).then(function(data) {
          if (data.errcode == 0) {
            if (localStorage.getItem('bj12351.user')) {
              $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
              $scope.user.phone = $scope.register.phone;
              localStorage.setItem('bj12351.user', JSON.stringify($scope.user));
              localStorage.setItem('bj12351.id_card', $scope.user.id_card);
            }
            mySer.info().then(function(data) {
              if (data.errcode === undefined) {
                $scope.register.name = '';
                $scope.register.card_name = '';
                $scope.register.jing_card = '';
                $scope.register.phone = '';
                $scope.register.pw = '';
                $scope.register.verification_code = '';
                $scope.gain_code = '发送验证码';
                $scope.register.checked = false;
                $location.path('/tab/home');
              } else if (data.errcode == -2) {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                  localStorage.removeItem('bj12351.token');
                  localStorage.removeItem('bj12351.user');
                  // $state.go('tab.login');
                  $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                  if ($scope.is_gesture === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                });
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          } else if (data.errcode == 1) {
            $cordovaDialogs.alert('验证码已过期，请重新获取。', '温馨提示', '好的');
          } else if (data.errcode == 2) {
            $cordovaDialogs.alert('验证码填写错误，请重新填写。', '温馨提示', '好的');
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('信息生成失败，请重新注册。', '温馨提示', '好的');
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

    });
})();
