(function() {
    'use strict';
    angular
      .module('register')
      .factory('registerSer', function($q, $ionicLoading, API, $http) {
          return {
            verify: function(name, card, type) {
              var q = $q.defer();
              $ionicLoading.show({
                template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
              });
              $http.get(API.getHost() + '/user/verify.jsp' +
                  '?name=' + name +
                  '&card=' + card +
                  '&type=' + type +
                  '&jpush_id=' + localStorage.getItem('bj12351.jpush_id'))
                  .success(function(data) {
                    q.resolve(data);
                  })
                  .error(function(error) {
                    q.reject(error);
                  })
                  .finally(function() {
                    $ionicLoading.hide();
                  });
                  return q.promise;
                },

                sendValidCode: function(token, phone) {
                  var q = $q.defer();
                  $ionicLoading.show({
                    template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
                  });
                  $http.post(API.getHost() + '/user/send-valid-code.jsp', {
                      token: token,
                      phone: phone
                    })
                    .success(function(data) {
                      q.resolve(data);
                    })
                    .error(function(error) {
                      q.reject(error);
                    })
                    .finally(function() {
                      $ionicLoading.hide();
                    });
                  return q.promise;
                },

                modifyPhone: function(token, phone, valid_code, pw) {
                  var q = $q.defer();
                  $ionicLoading.show({
                    template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
                  });
                  $http.post(API.getHost() + '/user/modify-phone.jsp', {
                      token: token,
                      phone: phone,
                      valid_code: valid_code,
                      password: pw
                    })
                    .success(function(data) {
                      q.resolve(data);
                    })
                    .error(function(error) {
                      q.reject(error);
                    })
                    .finally(function() {
                      $ionicLoading.hide();
                    });
                  return q.promise;
                }

            };
          });
      })();
