(function() {
  'use strict';

  angular
    .module('scanEmployee')
    .controller('scanEmployeeCtrl', function($scope, $ionicLoading, $cordovaDialogs, $ionicPopup, $ionicHistory, $stateParams, $state, $location, scanBarcodeSer) {
      $scope.scan_emp = {};
      $scope.type = 1; //职工之家、职工小家、暖心驿站
      $scope.enter_name = '';
      $scope.employee_name = '';
      $scope.service_content = '';
      $scope.services = [];
      $scope.services_arr = [];
      $scope.select_service = '';


      $scope.listData = {};

      $scope.listData.id = 0;

      //会员选择的功能
      $scope.selected = [];
      $scope.updateSelection = function($event, service) {
        var checkbox = $event.target;
        var checked = checkbox.checked;
        if (checked) {
          $scope.selected.push(service);
        } else {
          var idx = $scope.selected.indexOf(service);
          $scope.selected.splice(idx, 1);
        }
      };

      $scope.newArr = function(id, value, checked) {
        var arr = {};
        arr.id = id;
        arr.value = value;
        arr.checked = checked;
        return arr;
      }

      //获取服务功能
      $scope.scan_verify = function() {
        $scope.listData = angular.fromJson($stateParams.data_scan) || {};
        if (localStorage.getItem('bj12351.token')) {
          $scope.type = $scope.listData.Type || 1;
          $scope.enter_name = $scope.listData.EnterpriseName || '';
          $scope.employee_name = $scope.listData.EmployeeHome || '';
          $scope.service_content = $scope.listData.ServiceContent || '';
          $scope.service_content = 'wifi,母婴室';
          if ($scope.service_content != '' && $scope.service_content != null && $scope.service_content != undefined) {
            $scope.services = $scope.service_content.split(',');
            for (var i = 0; i < $scope.services.length; i++) {
              $scope.services_arr[i] = $scope.newArr(i, $scope.services[i], false);
            }
          }
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };
      $scope.scan_verify();


      $scope.scan_employee = function() {
        if ($scope.scan_is_submit === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.scan_is_submit = true;
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.selected.length == 0) {
            $cordovaDialogs.alert('请选择您要参与的服务功能。', '温馨提示', '好的');
            $scope.scan_is_submit = false;
            return;
          }
          for (var i = 0; i < $scope.selected.length; i++) {
            $scope.select_service += $scope.selected[i].value;
            if (i != $scope.selected.length - 1) {
              $scope.select_service += ',';
            }
          }

          scanBarcodeSer.scanEmployee($scope.listData.id, $scope.select_service).then(function(data) {
            if (data.errcode === 0) {
              $ionicPopup.alert({
                title: '温馨提示',
                template: '参与成功。',
                buttons: [{
                  text: '好的',
                  type: 'button-positive',
                  onTap: function(e) {
                    $ionicHistory.goBack();
                  }
                }]
              });
            } else if (data.errcode == -1) {
              $ionicPopup.confirm({
                title: '温馨提示',
                template: '您尚未登录哦。',
                buttons: [{
                  text: '稍后登录'
                }, {
                  text: '现在登录',
                  type: 'button-positive',
                  onTap: function(e) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                }]
              });
              $scope.scan_is_submit = false;
            } else if (data.errcode == -2) {
              $ionicPopup.alert({
                title: '温馨提示',
                template: data.errmsg,
                buttons: [{
                  text: '好的',
                  type: 'button-positive',
                  onTap: function(e) {
                    $ionicHistory.goBack();
                  }
                }]
              });
              $scope.scan_is_submit = false;
            }
          }, function(error) {
            $scope.scan_is_submit = false;
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
          $scope.scan_is_submit = false;
        }


      };
    });

})();
