(function() {
  'use strict';

  angular
    .module('scanReserve')
    .controller('scanReserveCtrl', function($scope, $ionicLoading, $cordovaDialogs, $ionicPopup, $ionicHistory, $stateParams, $state, $location, scanBarcodeSer) {
      $scope.scan_reserve = {};
      $scope.scan_reserve.phone = '';
      $scope.scan_reserve.count = 1;
      $scope.listData = {};
      $scope.max_num = 0;
      $scope.min_num = 0;
      $scope.listData.service_id = 0;
      $scope.listData.firm_id = 0;
      // $scope.listData = angular.fromJson($stateParams.data_scan) || {};
      $scope.scan_verify = function() {
        $scope.listData = angular.fromJson($stateParams.data_scan) || {};
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.scan_reserve.phone = $scope.user.phone;
          $scope.max_num = $scope.listData.max_num || 0;
          $scope.min_num = $scope.listData.min_num || 0;
          $scope.scan_reserve.count = $scope.max_num > 0 ? $scope.max_num : $scope.min_num;
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };
      $scope.scan_verify();


      $scope.scan_service_reserve = function() {
        if ($scope.scan_is_submit === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.scan_is_submit = true;
        if (localStorage.getItem('bj12351.token')) {
          if ($scope.max_num > 0) {
            if ($scope.scan_reserve.count > $scope.max_num) {
              $cordovaDialogs.alert('本活动最大领取数量为' + $scope.max_num + '，请重新填写领取数量。', '温馨提示', '好的');
              $scope.scan_is_submit = false;
              return;
            }
          }
          if ($scope.scan_reserve.count < $scope.min_num) {
            $cordovaDialogs.alert('本活动最小领取数量为' + $scope.min_num + '，请重新填写领取数量。', '温馨提示', '好的');
            $scope.scan_is_submit = false;
            return;
          }
          if ($scope.scan_reserve.phone !== '' && (!/^1\d{10}$/.test($scope.scan_reserve.phone))) {
            $cordovaDialogs.alert('请输入正确的联系人手机号', '温馨提示', '好的');
            $scope.scan_is_submit = false;
            return;
          }
          scanBarcodeSer.take(localStorage.getItem('bj12351.token'), $scope.listData.service_id, $scope.listData.firm_id, $scope.scan_reserve.count, $scope.scan_reserve.phone).then(function(data) {
            if (data.errcode === 0) {
              $scope.scan_is_submit = false;
              $ionicPopup.confirm({
                title: '温馨提示',
                template: '恭喜！您是第' + data.number + '位参加此活动的会员，去评价一下吧~',
                buttons: [{
                  text: '稍后评价',
                  onTap: function(e) {
                    $ionicHistory.goBack();
                  }
                }, {
                  text: '现在评价',
                  type: 'button-positive',
                  onTap: function(e) {
                    $location.path('/tab/my-service');
                  }
                }]
              });
            } else if (data.errcode == -1) {
              $ionicPopup.confirm({
                title: '温馨提示',
                template: '您尚未登录哦。',
                buttons: [{
                  text: '稍后登录'
                }, {
                  text: '现在登录',
                  type: 'button-positive',
                  onTap: function(e) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                }]
              });
              $scope.scan_is_submit = false;
            } else if (data.errcode == -2) {
              $ionicPopup.alert({
                title: '温馨提示',
                template: data.errmsg,
                buttons: [{
                  text: '好的',
                  type: 'button-positive',
                  onTap: function(e) {
                    $ionicHistory.goBack();
                  }
                }]
              });
              $scope.scan_is_submit = false;
            }
          }, function(error) {
            $scope.scan_is_submit = false;
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
          $scope.scan_is_submit = false;
        }


      };
    });

})();
