(function() {
  'use strict';
  angular
    .module('service')
    .controller('serviceCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicPopover, mySer, serviceSer, templateUrlPath, geoLocationSer, myServiceSer) {
      var vm = $scope.vm = {};
      vm.CityPickData2 = {
        areaData: ['按区域查找'],
        hardwareBackButtonClose: false
      };

      $scope.search = {};
      $scope.search.name = serviceSer.getSearchName();
      $scope.latitude = geoLocationSer.getLatitude();
      $scope.longitude = geoLocationSer.getLongitude();

      $scope.codelist = {};
      $scope.condition = {};
      $scope.codelist.ct_area_beijing = JSON.parse(localStorage.getItem('bj12351.ct_area_beijing'));
      $scope.condition.area_beijing = $scope.codelist.ct_area_beijing[0];

      $scope.services = serviceSer.getServices();

      var page = 1;
      var size = 10;
      $scope.hasMore = $scope.services.length >= size;

      $scope.category_options = JSON.parse(localStorage.getItem('bj12351.ct_project_category'));
      $scope.category_options.unshift({
        code: 0,
        name: '全部'
      });

      $scope.search_types = [{
        code: 0,
        name: '当前活动'
      }, {
        code: 1,
        name: '我能参与'
      }, {
        code: 2,
        name: '历史活动'
      }];

      $scope.search_is_need_reserve = [{
        code: 0,
        name: '全部'
      }, {
        code: 1,
        name: '需预定'
      }, {
        code: 2,
        name: '无需预定'
      }];

      $scope.search_gender = [{
        code: 0,
        name: '全部'
      }, {
        code: 1,
        name: '男'
      }, {
        code: 2,
        name: '女'
      }];

      $scope.search.search_type = $scope.search_types[0];
      $scope.search.category = $scope.category_options[0];
      $scope.search.is_reserve = $scope.search_is_need_reserve[0];
      $scope.search.gender = $scope.search_gender[0];
      $scope.search.begin_time = "";

      //重定位
      function reLocated() {
        geoLocationSer.reLocated();
        $scope.latitude = geoLocationSer.getLatitude();
        $scope.longitude = geoLocationSer.getLongitude();
      }
      reLocated();

      /**打开筛选模板**/
      $scope.openFilterModal = function() {
        $scope.openModal('filter_services');
      };

      /**取消筛选**/
      $scope.returnCancel = function() {
        $scope.closeModal('filter_services');
      };

      /**重置筛选**/
      $scope.reset = function() {
        angular.element(document.querySelectorAll(".redioarea label")).addClass("btn-weak");
        $scope.search.category = $scope.category_options[0];

        for (var i = 0; i < $scope.category_options.length; i++) {
          $scope.category_options[i].selected = 0;
        }

        $scope.search.is_reserve = $scope.search_is_need_reserve[0];

        for (i = 0; i < $scope.search_is_need_reserve.length; i++) {
          $scope.search_is_need_reserve[i].selected = 0;
        }

        $scope.search.gender = $scope.search_gender[0];

        for (i = 0; i < $scope.search_gender.length; i++) {
          $scope.search_gender[i].selected = 0;
        }

        $scope.search.begin_time = "";
      };


      /**按活动类别筛选**/
      $scope.changeCategory = function(index) {
        angular.element(document.querySelector("#rootli" + index)).prop("checked", "checked").parent().removeClass("btn-weak");
        for (var i = 0; i < $scope.category_options.length; i++) {
          $scope.category_options[i].selected = 0;
        }
        for (i = 0; i < $scope.category_options.length; i++) {
          if (i != index) {
            angular.element(document.querySelector("#rootli" + i)).parent().addClass("btn-weak");
          }
          $scope.category_options[index].selected = 1;
        }
        $scope.search.category = $scope.category_options[index];
      };

      /**按是否需要预定筛选**/
      $scope.changeReserve = function(index) {
        angular.element(document.querySelector("#reserveli" + index)).prop("checked", "checked").parent().removeClass("btn-weak");
        for (var i = 0; i < $scope.search_is_need_reserve.length; i++) {
          $scope.search_is_need_reserve[i].selected = 0;
        }
        for (i = 0; i < $scope.search_is_need_reserve.length; i++) {
          if (i != index) {
            angular.element(document.querySelector("#reserveli" + i)).parent().addClass("btn-weak");
          }
          $scope.search_is_need_reserve[index].selected = 1;
        }
        $scope.search.is_reserve = $scope.search_is_need_reserve[index];
      };

      /**按性别筛选**/
      $scope.changeGender = function(index) {
        angular.element(document.querySelector("#genderli" + index)).prop("checked", "checked").parent().removeClass("btn-weak");
        for (var i = 0; i < $scope.search_gender.length; i++) {
          $scope.search_gender[i].selected = 0;
        }
        for (i = 0; i < $scope.search_gender.length; i++) {
          if (i != index) {
            angular.element(document.querySelector("#genderli" + i)).parent().addClass("btn-weak");
          }
          $scope.search_gender[index].selected = 1;
        }
        $scope.search.gender = $scope.search_gender[index];
      };

      /**监听服务类别变化**/
      $scope.change = function() {
        if ($scope.search.search_type.code === 1 && !localStorage.getItem('bj12351.token')) {
          $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
              if (buttonIndex == 1) {
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            })
            .finally(function() { //解决未登录情况下 我能参与下拉刷新导致的刷新旋转动画不自动关闭问题
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $scope.refresh();
        }
      };

      /**刷新**/
      $scope.refresh = function() {
        $scope.user = JSON.parse(localStorage.getItem('bj12351.user')) || {};
        $scope.gender = 0;
        $scope.search.district = localStorage.getItem('bj12351.selected_district') || 0;
        $scope.district_type = localStorage.getItem('bj12351.selected_type') || 0;
        switch ($scope.user.gender) {
          case "男":
            $scope.gender = 1;
            break;
          case "女":
            $scope.gender = 2;
            break;
        }

        if ($scope.search.name === '' && $scope.search.search_type.code === 0 && ($scope.search.district == 'undefined' || $scope.search.district === 0) && ($scope.district_type == 'undefined' || $scope.district_type === 0) && $scope.search.category.code === 0 && $scope.search.begin_time === '' && $scope.search.is_reserve.code === 0 && $scope.search.gender.code === 0) {
          serviceSer.refreshServicesNoCon(1, size, $scope.longitude, $scope.latitude).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂未发布活动。',
                    duration: 1000
                  });
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.services = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '现在参与活动人数较多，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          serviceSer.refreshServices($scope.search.name, $scope.search.search_type.code, $scope.search.district, $scope.district_type, $scope.search.category.code, $scope.search.begin_time, $scope.search.is_reserve.code, $scope.search.gender.code, 1, size, $scope.longitude, $scope.latitude).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂未发布活动。',
                    duration: 1000
                  });
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.services = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '现在参与活动人数较多，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }


      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        reLocated();
        $scope.search.name = '';
        $scope.change();
      };

      /**更多**/
      $scope.more = function() {
        $scope.search.district = localStorage.getItem('bj12351.selected_district') || 0;
        if ($scope.search.name === '' && $scope.search.search_type.code === 0 && $scope.search.district == 'undefined' && $scope.district_type == 'undefined' && $scope.search.category.code === 0 && $scope.search.begin_time === '' && $scope.search.is_reserve.code === 0 && $scope.search.gender.code === 0) {
          serviceSer.moreServicesNoCon(page, size, $scope.longitude, $scope.latitude).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '没有更多服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                }
                page++;
                $scope.services = $scope.services.concat(data);
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '现在参与活动人数较多，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        } else {
          serviceSer.moreServices($scope.search.name, $scope.search.search_type.code, $scope.search.district, $scope.district_type, $scope.search.category.code, $scope.search.begin_time, $scope.search.is_reserve.code, $scope.search.gender.code, page, size, $scope.longitude, $scope.latitude).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '没有更多服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                }
                page++;
                $scope.services = $scope.services.concat(data);
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '现在参与活动人数较多，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

      };

      /*=================服务项目点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];

        if ($scope.service_likes.has_likes === true) { //取消点赞
          //$scope.show_likes = false;
        } else if ($scope.service_likes.has_likes === undefined || $scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else if (data.errcode == -1) {
                  $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
                    // $location.path('/login');
                    $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                    if ($scope.is_gesture === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '现在参与活动人数较多，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
              // $location.path('/login');
              $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
              if ($scope.is_gesture === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            });
          }

        }
      };
      /*=================服务项目点赞结束================*/

      /**监听进入界面**/
      $scope.$on('$ionicView.beforeEnter', function() {
        /**由首页进入搜索框进入时，判断是否需要刷新列表**/
        if ($stateParams.needRefresh == 1) {
          $scope.search.name = serviceSer.getSearchName();
          $scope.refresh();
        }
      });

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
