(function() {
  'use strict';
  angular
    .module('service')
    .factory('serviceSer', function($http, API, $q, $ionicLoading) {
      var searchName = '';
      var services = JSON.parse(localStorage.getItem('bj12351.services')) || [];
      var my_services = JSON.parse(localStorage.getItem('bj12351.my_services')) || [];

      return {
        setSearchName: function(keyword) {
          searchName = keyword;
        },

        getSearchName: function() {
          return searchName;
        },

        getServices: function() {
          return services;
        },

        getMyServices: function() {
          return my_services;
        },

        refreshServices: function(service_name, search_type, district, district_type, category, begin_time, is_reserve, gender, page, size, longitude, latitude) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&search_type=' + search_type + '&district=' + district + '&district_type=' + district_type + '&category=' + category + '&begin_time=' + begin_time + '&is_reserve=' + is_reserve + '&gender=' + gender + '&page=' + page + '&size=' + size + '&longitude=' + longitude + '&latitude=' + latitude, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                services = data;
                localStorage.setItem('bj12351.services', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        refreshServicesNoCon: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/list_no_con.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                services = data;
                localStorage.setItem('bj12351.services', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        refreshInCityPicker: function() {
          var cxy = document.getElementById('cityPicker');
          cxy.click();
        },

        moreServices: function(service_name, search_type, district, district_type, category, begin_time, is_reserve, gender, page, size, longitude, latitude) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&search_type=' + search_type + '&district=' + district + '&district_type=' + district_type + '&category=' + category + '&begin_time=' + begin_time + '&is_reserve=' + is_reserve + '&gender=' + gender + '&page=' + page + '&size=' + size + '&longitude=' + longitude + '&latitude=' + latitude, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreServicesNoCon: function(page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/list_no_con.jsp?token=' + localStorage.getItem('bj12351.token') + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
