(function() {
  'use strict';
  angular
    .module('serviceDetail')
    .controller('serviceDetailCtrl', function($scope, $state, $stateParams, $ionicLoading, $cordovaDialogs, $ionicHistory, $location, $ionicModal, $cordovaDatePicker, $timeout, serviceDetailSer, geoLocationSer, receiveSer, mySer, serviceMerchantSer, scanBarcodeSer, templateUrlPath, $sce, $cordovaInAppBrowser, API) {
      $scope.service = {};

      $scope.add = {};
      $scope.add.post_code = '';
      $scope.add.detail_address = '';

      $scope.stations = [];

      $scope.max_num = 0;
      $scope.min_num = 0;

      $scope.has_reserve = false;
      $scope.hideComment = true; //隐藏评价

      var latitude = geoLocationSer.getLatitude();
      var longitude = geoLocationSer.getLongitude();

      /*重定位 */
      function reLocated() {
        geoLocationSer.reLocated();
        latitude = geoLocationSer.getLatitude();
        longitude = geoLocationSer.getLongitude();
      }
      reLocated();

      //打开第三方链接
      $scope.open = function(url) {
        if (localStorage.getItem('bj12351.token')) {
          $cordovaInAppBrowser.open(url, '_blank');
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      //查看大图
      $scope.viewPic = function(modal_name, url) {
        $scope.largePic = url;
        $scope.openModal(modal_name);
      };

      $scope.select_areas = JSON.parse(localStorage.getItem('bj12351.ct_area_beijing'));
      $scope.select_areas.unshift({
        code: 0,
        name: '--请选择区域--'
      });
      $scope.add.select_area = $scope.select_areas[0];

      var commentPage = 1; //评论页数
      var commentSize = 10; //评论容量
      $scope.comments = []; //评论列表
      $scope.commentHasMore = false; //评论是否有更多

      /**刷新评论**/
      $scope.refreshComments = function() {
        serviceDetailSer.getComments($stateParams.serviceId, 1, commentSize).then(function(data) {
          if (data.errcode === undefined) {
            if (data.length < commentSize) {
              $scope.commentHasMore = false;
            } else {
              $scope.commentHasMore = true;
            }
            commentPage = 2;
            $scope.comments = data;
          } else {
            $scope.commentHasMore = false;
          }
        }, function(err) {
          $scope.commentHasMore = false;
        }).finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
      };

      /**更多评论**/
      $scope.moreComments = function() {
        serviceDetailSer.getComments($stateParams.serviceId, commentPage, commentSize).then(function(data) {
          if (data.errcode === undefined) {
            if (data.length < commentSize) {
              $scope.commentHasMore = false;
            }
            commentPage++;
            $scope.comments = $scope.comments.concat(data);
          } else {
            $scope.commentHasMore = false;
          }
        }, function(err) {
          $scope.commentHasMore = false;
        }).finally(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      };

      /**刷新服务详情**/
      $scope.refresh = function() {
        serviceDetailSer.detail($stateParams.serviceId).then(function(data) {
            if (data.errcode === undefined) {
              $scope.service = data;
              $scope.is_address_phone = data.is_address_phone;
              $scope.service.description = $sce.trustAsHtml(data.description);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
            $ionicHistory.goBack();
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });

        $scope.refreshComments();
      };
      $scope.refresh();

      $scope.user = {}; //用户信息
      $scope.reserve = {}; //预约
      $scope.reserve.name = ''; //预约服务名
      $scope.reserve.station = {}; //预约服务站

      $scope.reserve.select = {}; //预约时手动选择
      $scope.reserve.select.receive = {}; //预约时手动选择的收货地址

      /**预定验证**/
      $scope.verify = function() {
        if (localStorage.getItem('bj12351.token')) {
          $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
          $scope.user.default_receive = $scope.user.receives.filter(function(item) {
            return item.is_default;
          })[0];
          $scope.reserve.select.receive = $scope.user.default_receive || {};
          $scope.reserve.receive = $scope.user.default_receive || {};
          $scope.reserve.phone = $scope.user.phone;

          //判断是否有预定资格
          serviceDetailSer.verify($stateParams.serviceId).then(function(data) {
            if (data.errcode === 0) {
              $scope.max_num = data.max_num;
              $scope.min_num = data.min_num;
              $scope.batch_period = data.batch_period;
              $scope.is_reserve = data.is_reserve;
              $scope.is_square = data.is_square;
              if (data.is_square) {
                $scope.reserve.use_date = '';
              } else {
                $scope.reserve.use_date = new Date();
              }
              $scope.apply_address = data.apply_address;
              $scope.reserve.count = $scope.max_num > 0 ? $scope.max_num : $scope.min_num;
              $scope.begin_date = data.begin_date;
              $scope.begin_time = data.begin_time;
              $scope.end_time = data.end_time;
              if ($scope.is_reserve == 1) {
                $scope.begin_time = new Date($scope.begin_time);
                if (Date.parse($scope.reserve.use_date) - Date.parse($scope.begin_time) > 0 && Date.parse($scope.reserve.use_date) - Date.parse($scope.end_time) < 0) {
                  $scope.reserve.use_date = $scope.reserve.use_date;
                }
                if (Date.parse($scope.reserve.use_date) - Date.parse($scope.begin_time) < 0) {
                  $scope.reserve.use_date = $scope.begin_time;
                }
              }
              $scope.openModal('reserve/reserve');
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦。', '温馨提示：', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            } else if (data.errcode == 1) {
              $cordovaDialogs.alert('先对未评价的服务进行评价。', '温馨提示', '好的').then(function() {
                $location.path("/my-service/" + data.apply_id + "/my-service-detail");
              });
            } else if (data.errcode == 2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      var datePage = 1;
      var dateSize = 15;
      $scope.dateHasMore = false;

      /**获取时间表**/
      $scope.refreshTimeTable = function() {
        serviceDetailSer.getTimeTable($stateParams.serviceId, 1, dateSize).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂无预约时间。',
                  duration: 1000
                });
                $scope.dateHasMore = false;
              } else if (data.length < dateSize) {
                $scope.dateHasMore = false;
              } else {
                $scope.dateHasMore = true;
              }
              datePage = 2;
              $scope.reserve.dates = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              $scope.dateHasMore = false;
            }
          }, function(error) {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };

      /**更多预约时间**/
      $scope.moreTimeTable = function() {
        serviceDetailSer.getTimeTable($stateParams.serviceId, datePage, dateSize).then(function(data) {
            if (data.errcode === undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '无更多预约时间。',
                  duration: 1000
                });
                $scope.dateHasMore = false;
              } else if (data.length < dateSize) {
                $scope.dateHasMore = false;
              }
              datePage++;
              $scope.reserve.dates = $scope.reserve.dates.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              $scope.dateHasMore = false;
            }
          }, function(error) {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**添加收货地址**/
      $scope.doAdd = function() {
        if ($scope.add.select_area.code === 0) {
          $cordovaDialogs.alert('请选择区域', '温馨提示', '好的');
          return;
        }

        if ($scope.add.detail_address === '') {
          $cordovaDialogs.alert('请填写完整的详细地址', '温馨提示', '好的');
          return;
        }

        if ($scope.add.post_code === '') {
          $cordovaDialogs.alert('请填写邮政编码', '温馨提示', '好的');
          return;
        }

        $scope.add.address = '北京市' + $scope.add.select_area.name + $scope.add.detail_address;
        receiveSer.doAdd($scope.add.address, $scope.add.post_code).then(function(data) {
          if (data.errcode === 0) {
            mySer.info().then(function(data) {
              $scope.user = data;
            });
            $scope.add.post_code = '';
            $scope.add.detail_address = '';
            $scope.closeModal('add_receive');
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录已失效，请重新登录', '温馨提示', '好的');
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '现在参与活动人数较多，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**预定**/
      $scope.service_reserve = function() {
        if ($scope.is_submit === true) {
          $cordovaDialogs.alert('正在提交中，请耐心等待。', '温馨提示', '好的');
          return;
        }
        $scope.is_submit = true;
        if (localStorage.getItem('bj12351.token')) {
          if (($scope.is_reserve == 1 || $scope.is_square) && ($scope.reserve.use_date === undefined || $scope.reserve.use_date.length === 0)) {
            $cordovaDialogs.alert('请填写预约时间', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }

          if ($scope.max_num > 0) {
            if ($scope.reserve.count > $scope.max_num) {
              $cordovaDialogs.alert('本活动最大领取数量为' + $scope.max_num + '，请重新填写领取数量。', '温馨提示', '好的');
              $scope.is_submit = false;
              return;
            }
          }
          if ($scope.reserve.count < $scope.min_num) {
            $cordovaDialogs.alert('本活动最小领取数量为' + $scope.min_num + '，请重新填写领取数量。', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }

          if ($scope.is_address_phone == 1) {
            if (!/^1\d{10}$/.test($scope.reserve.phone)) {
              $cordovaDialogs.alert('请输入正确的联系人手机号', '温馨提示', '好的');
              $scope.is_submit = false;
              return;
            }
          } else if ($scope.is_address_phone === 0) {
            if ($scope.reserve.phone !== '' && (!/^1\d{10}$/.test($scope.reserve.phone))) {
              $cordovaDialogs.alert('请输入正确的联系人手机号', '温馨提示', '好的');
              $scope.is_submit = false;
              return;
            }
          }
          if ($scope.is_address_phone == 1) {
            // console.log($scope.reserve.receive.length);
            if ($scope.reserve.receive.address === undefined || $scope.reserve.receive.address.length === 0) {
              $cordovaDialogs.alert('请选择收件地址', '温馨提示', '好的');
              $scope.is_submit = false;
              return;
            }
          }

          if ($scope.apply_address && ($scope.reserve.station.name === undefined || $scope.reserve.station.name.length === 0)) {
            $cordovaDialogs.alert('请选择领物地址', '温馨提示', '好的');
            $scope.is_submit = false;
            return;
          }

          serviceDetailSer.reserve($stateParams.serviceId, $scope.reserve.receive.id, $scope.reserve.use_date, $scope.reserve.station.id, $scope.reserve.count, $scope.reserve.phone).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功预订该服务,可以在我的服务中随时查看', '温馨提示', '好的').then(function() {
                $scope.has_reserve = true;
                $scope.is_submit = false;
                $scope.closeModal('reserve/reserve');
              });
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                $scope.closeModal('reserve/reserve');
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
              $scope.is_submit = false;
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              $scope.is_submit = false;
            }
          }, function() {
            $scope.is_submit = false;
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            $scope.closeModal('reserve/reserve');
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
          $scope.is_submit = false;
        }
      };

      var stationPage = 1; //服务站页数
      var stationSize = 20; //服务站容量
      $scope.stationsHasMore = $scope.stations.length >= stationSize;

      /**刷新服务单位**/
      $scope.refreshStations = function() {
        reLocated();
        serviceMerchantSer.getMerchants(longitude, latitude, $stateParams.serviceId, 1, stationSize, $scope.reserve.name)
          .then(function(data) {
            if (data.errcode === undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂无服务单位。',
                  duration: 1000
                });
                $scope.stationsHasMore = false;
              } else if (data.length < stationSize) {
                $scope.stationsHasMore = false;
              } else {
                $scope.stationsHasMore = true;
              }
              stationPage = 2;
              $scope.stations = data;
              $scope.reserve.station = data[0];
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };

      /**更多服务单位**/
      $scope.moreStations = function() {
        serviceMerchantSer.getMerchants(longitude, latitude, $stateParams.serviceId, stationPage, stationSize, $scope.reserve.name)
          .then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '无更多服务单位。',
                  duration: 1000
                });
                $scope.stationsHasMore = false;
              } else if (data.length < stationSize) {
                $scope.stationsHasMore = false;
              }
              stationPage++;
              $scope.stations = $scope.stations.concat(data);
            } else {
              $scope.stationsHasMore = false;
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**利用闭包实现延迟触发change搜索**/
      $scope.doSearch = (function() {
        var timeoutHandle;
        return function() {
          $timeout.cancel(timeoutHandle);
          timeoutHandle = $timeout($scope.refreshStations, 1000);
        };
      })();

      /**扫一扫**/
      $scope.scanBarcode = function() {
        if (localStorage.getItem('bj12351.token')) {
          //判断是否可以打开摄像头
          serviceDetailSer.scan_verify($stateParams.serviceId).then(function(data) {
            if (data.errcode === 0 || data.errcode === undefined) {
              scanBarcodeSer.scan();
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦。', '温馨提示：', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '现在参与活动人数较多，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }

      };

      $scope.setUseDate = function() {
        var options = {
          date: new Date(),
          mode: 'date', // or 'time'
          minDate: $scope.begin_time,
          maxDate: $scope.end_time,
          allowOldDates: true,
          allowFutureDates: false,
          doneButtonLabel: '完成',
          doneButtonColor: '#F2F3F4',
          cancelButtonLabel: '取消',
          cancelButtonColor: '#000000'
        };
        $cordovaDatePicker.show(options).then(function(date) {
          $scope.reserve.use_date = data;
        });
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'comment/comments') {
          options.animation = 'slide-in-right';
        }

        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          if (modal_name === 'reserve/select_date') {
            $scope.refreshTimeTable();
          } else if (modal_name === 'add_receive') {
            $scope.add.select_area = $scope.select_areas[0];
            $scope.add.detail_address = '';
            $scope.add.post_code = '';
          } else if (modal_name === 'reserve/select_station') {
            $scope.refreshStations();
          }
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        if (modal_name === 'reserve/select_receives') {
          $scope.reserve.select.receive = $scope.reserve.receive;
        }
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        if (modal_name === 'reserve/select_receives') {
          $scope.reserve.receive = $scope.reserve.select.receive;
        }
        $scope.modal[modal_name].remove();
      };

      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });

      /**分享选择页面**/
      $scope.shareSelect = function(modal_name) {
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      /**分享至微信好友**/
      $scope.shareToWX = function() {
        Wechat.share({
          message: {
            title: $scope.service.name,
            description: '',
            thumb: $scope.service.img || 'https://cordova.apache.org/static/img/cordova_bot.png',
            mediaTagName: "TEST-TAG-001",
            messageExt: "这是第三方带的测试字段",
            messageAction: "<action>dotalist</action>",
            media: {
              type: Wechat.Type.WEBPAGE,
              webpageUrl: API.getHost() + '/system/judge-model.jsp'
            }
          },
          scene: Wechat.Scene.SESSION // share to SESSION
        }, function() {
          // alert("Success");
          console.log("Success");
        }, function(reason) {
          // alert("Failed: " + reason);
          console.log("Failed: " + reason);
        });
      };

      /**分享至QQ**/
      $scope.shareToQQ = function() {
        var args = {};
        args.client = QQSDK.ClientType.QQ; //QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        args.scene = QQSDK.Scene.QQ; //QQSDK.Scene.QQZone,QQSDK.Scene.Favorite
        args.url = API.getHost() + '/system/judge-model.jsp';
        args.title = $scope.service.name;
        args.description = '';
        args.image = $scope.service.img || 'https://cordova.apache.org/static/img/cordova_bot.png';
        QQSDK.shareNews(function() {
          // alert('shareNews success');
          console.log("shareNews success");
        }, function(failReason) {
          // alert(failReason);
          console.log(failReason);
        }, args);
      };

      /**分享至微信朋友圈**/
      $scope.shareToWXTimeline = function() {
        Wechat.share({
          message: {
            title: $scope.service.name,
            description: '',
            thumb: $scope.service.img || 'https://cordova.apache.org/static/img/cordova_bot.png',
            mediaTagName: "TEST-TAG-001",
            messageExt: "这是第三方带的测试字段",
            messageAction: "<action>dotalist</action>",
            media: {
              type: Wechat.Type.WEBPAGE,
              webpageUrl: API.getHost() + '/system/judge-model.jsp'
            }
          },
          scene: Wechat.Scene.TIMELINE // share to TIMELINE
        }, function() {
          // alert("Success");
          console.log("Success");
        }, function(reason) {
          // alert("Failed: " + reason);
          console.log("Failed: " + reason);
        });
      };

    });
})();
