(function() {
  'use strict';
  angular
    .module('serviceDetail')
    .factory('serviceDetailSer', function($http, $q, API, $ionicLoading) {
      return {
        detail: function(id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/service/info.jsp?service_id=' + id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        getComments: function(service_id, page, size) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/service/comment-list.jsp?service_id=' + service_id + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //判断用户是否参加了此服务
        isTaked: function(service_id) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/is-taked.jsp?service_id=' + service_id + '&token=' + localStorage.getItem('bj12351.token'))
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        //判断用户是否有预定资格
        scan_verify: function(service_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.get(API.getHost() + '/service/scan-verify.jsp?service_id=' + service_id + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //判断用户是否有预定资格
        verify: function(service_id) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.get(API.getHdHost() + '/service/verify.jsp?service_id=' + service_id + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 30000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //获取时间表
        getTimeTable: function(service_id, pageno, size) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var q = $q.defer();
          $http.get(API.getHost() + '/service/time-table.jsp?service_id=' + service_id + '&page=' + pageno + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //预订服务
        reserve: function(service_id, receive_id, use_date, firm_id, reserve_count, phone) {
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          var _this = this;
          var q = $q.defer();
          use_date = use_date || new Date();
          var date = '';
          if (typeof(use_date) === 'string') {
            date = use_date;
          } else {
            date = [use_date.getFullYear(), (use_date.getMonth() + 1) > 9 ? (use_date.getMonth() + 1) : '0' + (use_date.getMonth() + 1), use_date.getDate() > 9 ? use_date.getDate() : '0' + use_date.getDate()].join('-');
          }
          receive_id = receive_id || 0;
          firm_id = firm_id || 0;
          $http.post(API.getHdHost() + '/service/reserve.jsp', {
              service_id: service_id,
              token: localStorage.getItem('bj12351.token'),
              receive_id: receive_id,
              use_date: date,
              firm_id: firm_id,
              reserve_count: reserve_count,
              phone: phone
            }, {
              timeout: 30000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
