(function() {
  'use strict';
  angular
    .module('serviceMerchant')
    .controller('serviceMerchantCtrl', function($scope, $state, $ionicLoading, $stateParams, $cordovaDialogs, geoLocationSer, serviceMerchantSer, merchantSer) {
      $scope.title = '服务单位';
      $scope.merchants = [];

      var page = 1;
      var size = 10;
      $scope.hasMore = false;

      /**刷新**/
      $scope.refresh = function() {
        geoLocationSer.reLocated();
        serviceMerchantSer.getMerchants(geoLocationSer.getLongitude(), geoLocationSer.getLatitude(), $stateParams.serviceId, 1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂无服务单位。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.merchants = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      /**更多**/
      $scope.more = function() {
        serviceMerchantSer.getMerchants(geoLocationSer.getLongitude(), geoLocationSer.getLatitude(), $stateParams.serviceId, page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '无更多服务单位。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.merchants = $scope.merchants.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                $ionicHistory.goBack();
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });
      /*=================服务单位点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.merchant_likes = $scope.merchants[index];
        if ($scope.merchant_likes.has_likes === true) { //取消点赞
          //$scope.show_likes = false;
        } else if ($scope.merchant_likes.has_likes === undefined || $scope.merchant_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            merchantSer.postMerchantLikes(token, $scope.merchant_likes.id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.merchant_likes.has_likes;
                    $scope.merchant_likes.has_likes = heart;
                    $scope.merchants[index].likes_count = $scope.merchant_likes.likes_count + 1;
                    $scope.merchants[index].has_likes = true;
                  });
                } else if (data.errcode == -1) {
                  $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
                    // $location.path('/login');
                    $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                    if ($scope.is_gesture === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
              // $location.path('/login');
              $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
              if ($scope.is_gesture === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            });
          }

        }
      };
      /*=================服务单位点赞结束================*/


    });
})();
