(function() {
  'use strict';
  angular
    .module('set_gestpw')
    .controller('SetGesturePwdCtrl', function($scope, $location, $ionicModal, $ionicLoading, $interval, $ionicHistory, $cordovaDialogs, md5Ser, mySer, loginSer) {
      $("#setgesturepwd").GesturePasswd({
        backgroundColor: "#fff", //背景色
        color: "#ccc", //主要的控件颜色
        roundRadii: 30, //大圆点的半径
        pointRadii: 6, //大圆点被选中时显示的圆心的半径
        space: 30, //大圆点之间的间隙
        width: 270, //整个组件的宽度
        height: 270, //整个组件的高度
        lineColor: "#33cc33", //用户划出线条的颜色
        zindex: 100 //整个组件的css z-index属性
      });

      $("#setgesturepwd").on("hasPasswd", function(e, passwd) {
        if (passwd === null || passwd === '') {
          return;
        }
        if (passwd !== null && passwd.length < 5) {
          $("#setgesturepwd").trigger("passwdWrong");
          setTimeout(function() {
            $cordovaDialogs.alert('手势密码至少连接5个点。', '温馨提示', '好的');
          }, 500); //延迟半秒以照顾视觉效果
          //密码验证错误后的其他操作。。。
          return;
        }
        $scope.set_gestpwd(passwd);
      });
      $scope.user = mySer.getUserInfo();
      $scope.set_gestpwd = function(passwd) {
        loginSer.setGesturePassword(localStorage.getItem('bj12351.token'), md5Ser.md5(passwd), 1).then(function(data) {
          if (data.errcode === 0) {
            $scope.user.is_gesture_pwd = true;
            localStorage.setItem('bj12351.is_gesture_pwd', $scope.user.is_gesture_pwd);
            localStorage.setItem('bj12351.user', JSON.stringify($scope.user));
            localStorage.removeItem('bj12351.gesture_pwd_new', undefined);
            $("#setgesturepwd").trigger("clearPasswd");
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            $ionicHistory.goBack();
          } else if (data.errcode == -1) {
            $cordovaDialogs.confirm('登录已失效，再登录一次吧', '温馨提示', ['现在登录', '稍后登录'])
              .then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  // $location.path('/login');
                  $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                  if ($scope.is_gesture === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function() {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });

      };

    });
})();
