(function() {
  'use strict';
  angular
    .module('station')
    .factory('stationSer', function($http, $q, API, $ionicLoading) {
      var stations = JSON.parse(localStorage.getItem('bj12351.stations')) || [];

      return {
        getStations: function() {
          return stations;
        },

        refresh: function(longitude, latitude, station_name, page, size, org_id) {
          var q = $q.defer();
          $http.get(API.getHost() + '/station/list.jsp?longitude=' + longitude + '&latitude=' + latitude + '&page=' + page + '&size=' + size + '&station_name=' + station_name + '&org_id=' + org_id + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                stations = data;
                localStorage.setItem('bj12351.stations', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        more: function(longitude, latitude, station_name, page, size, org_id) {
          var q = $q.defer();
          $http.get(API.getHost() + '/station/list.jsp?longitude=' + longitude + '&latitude=' + latitude + '&page=' + page + '&size=' + size + '&station_name=' + station_name + '&org_id=' + org_id + '&token=' + localStorage.getItem('bj12351.token'), {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
