(function () {
  'use strict';
  angular
    .module('stationDetail')
    .controller('stationDetailCtrl', function ($scope, $stateParams, $ionicModal, $ionicLoading, $ionicHistory, $cordovaDialogs, stationDetailSer, templateUrlPath, geoLocationSer, $cordovaLaunchNavigator, $cordovaInAppBrowser, $cordovaDevice) {
      $scope.station = {};
      $scope.latitude = geoLocationSer.getLatitude();
      $scope.longitude = geoLocationSer.getLongitude();

      $scope.refresh = function () {
        console.log(666666);
        stationDetailSer.info($stateParams.stationId).then(function(data) {
          if (data.errcode == undefined) {
            $scope.station = data;
            console.log("data",data);
            //加载地理编码插件
            AMap.plugin(["AMap.Geocoder"], function() {
              var myGeo = new AMap.Geocoder({
                city: "北京"
              });
              myGeo.getLocation($scope.station.address, function(status, result) {
                if (status === 'complete' && result.info === 'OK') {
                  console.log(result.geocodes[0].location);
                  $scope.desLat = result.geocodes[0].location.lat;
                  $scope.desLng = result.geocodes[0].location.lng;
                }
              });
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
              $ionicHistory.goBack();
            });
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
      };
      $scope.refresh();

      /**启动地理定位 iOS**/
      $scope.launchNavigatorForIos = function () {
        $cordovaLaunchNavigator.navigate($scope.station.address).then(function () {
          // console.log("Navigator launched");
        }, function (err) {
          console.error(err);
        });
      };

      /**启动地理定位**/
      $scope.launchNavigator = function () {
        if ($cordovaDevice.getPlatform() === 'iOS') {
          $scope.launchNavigatorForIos();
        } else if ($cordovaDevice.getPlatform() === 'Android') {
          console.log(222);
          appAvailability.check('com.baidu.BaiduMap',
            function () { // Success start Bmap
              var targetSrc = 'http://api.map.baidu.com/direction?origin=latlng:' + geoLocationSer.getLatitude() + ',' + geoLocationSer.getLongitude() + '|name:您所在位置&destination=' + $scope.station.address + '&mode=driving&region=北京&output=html&src=测试北京12351app';
              $cordovaInAppBrowser.open(targetSrc, '_system', {
                clearcache: 'yes',
                clearsessioncache: 'yes',
                keyboardDisplayRequiresUserAction: 'no'
              });
            },
            function () { // Fail start Amap
              console.log("$scope.desLng",$scope.desLng);
              console.log("$scope.desLat",$scope.desLat);
              var targetSrc = 'http://uri.amap.com/navigation?from=&to=' + $scope.desLng + ',' + $scope.desLat + ',' + $scope.station.address + '&mode=car&policy=1&src=mypage&coordinate=gaode&callnative=1';
              $cordovaInAppBrowser.open(targetSrc, '_system', {
                clearcache: 'yes',
                clearsessioncache: 'yes',
                keyboardDisplayRequiresUserAction: 'no'
              });
            });
        }
      };

      /**显示图片**/
      $scope.showImg = function (index) {
        $scope.station.showpics = [$scope.station.pics[index]];
        $scope.openModal('show_img');
      };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function (modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', {
          scope: $scope,
          animation: 'slide-in-right'
        }).then(function (modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function (modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
