(function() {
  'use strict';
  angular
    .module('stationDetail')
    .factory('stationDetailSer', function($http, $q, API, $ionicLoading) {
      return {
        info: function(station_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/station/info.jsp?station_id=' + station_id, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };

    });
})();
