(function() {
  'use strict';
  angular
    .module('third_service')
    .controller('thirdServiceCtrl', function($scope, $state, $filter, $stateParams, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicPopover, mySer, templateUrlPath, geoLocationSer, myServiceSer, thirdServiceSer) {
      $scope.search = {};
      $scope.search.name = '';

      $scope.services = thirdServiceSer.getServices();

      var page = 1;
      var size = 10;

      /**强制显示返回按钮**/
      $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
        viewData.enableBack = true;
      });

      /**刷新**/
      $scope.refresh = function() {
        thirdServiceSer.refreshThirdServices($scope.search.name, 1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂未发布活动。',
                  duration: 1000
                });
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.services = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      /**更多**/
      $scope.more = function() {
        thirdServiceSer.moreThirdServices($scope.search.name, page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '没有更多服务。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.services = $scope.services.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      /*=================服务项目点赞开始================*/
      $scope.changeLikes = function(index, event) {
        event.preventDefault();
        $scope.service_likes = $scope.services[index];

        if ($scope.service_likes.has_likes === true) { //取消点赞
          //$scope.show_likes = false;
        } else if ($scope.service_likes.has_likes === undefined || $scope.service_likes.has_likes === false) { //点赞
          var token = localStorage.getItem('bj12351.token');
          if (token) {
            myServiceSer.postServiceLikes(token, $scope.service_likes.id).then(function(data) {
                if (data.errcode === 0 || data.errcode === undefined) {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的').then(function() {
                    var heart = !$scope.service_likes.has_likes;
                    $scope.service_likes.has_likes = heart;
                    $scope.services[index].likes_count = $scope.service_likes.likes_count + 1;
                    $scope.services[index].has_likes = true;
                  });
                } else if (data.errcode == -1) {
                  $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
                    // $location.path('/login');
                    $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
                    if ($scope.is_gesture === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  });
                } else {
                  $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                }
              },
              function(error) {
                $ionicLoading.show({
                  template: '网络繁忙，请稍后重试。',
                  duration: 1000
                });
              });
          } else {
            $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
              // $location.path('/login');
              $scope.is_gesture = localStorage.getItem('bj12351.is_gesture_pwd');
              if ($scope.is_gesture === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            });
          }

        }
      };
      /*=================服务项目点赞结束================*/

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
