(function() {
  'use strict';
  angular
    .module('third_service')
    .factory('thirdServiceSer', function($http, API, $q, $ionicLoading) {
      var third_services = JSON.parse(localStorage.getItem('bj12351.third_services')) || [];

      return {
        getServices: function() {
          return third_services;
        },
        refreshThirdServices: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/third_list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                third_services = data;
                localStorage.setItem('bj12351.third_services', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        moreThirdServices: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/third_list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }

      };
    });
})();
