(function() {
  'use strict';

  angular
    .module('activity_verify')
    .controller('activityVerifyCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, templateUrlPath, activityVerifySer) {
      /**扫一扫**/
      $scope.user_services = activityVerifySer.getUserServices();
      var u_token = '';

      $scope.scan_verify = function() {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifySer.scan().then(function(data) {
            console.log('data', data);
            if (data.errcode === undefined) {
              if (data.length === 0) {
                $ionicLoading.show({
                  template: '暂没有需要验证的服务。',
                  duration: 1000
                });
                return;
              } else {
                //$state.go('tab.activity_services');
                u_token = activityVerifySer.getUToken();
                $scope.user_services = data;
                $scope.openModal('activity_services');
              }

            }
          });
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };


      /**刷新**/
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifySer.worker_verify(localStorage.getItem('bj12351.token'), u_token).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂没有需要验证的服务。',
                    duration: 1000
                  });
                }
                $scope.user_services = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }

      };


      $scope.doRefresh = function() {
        $scope.refresh();
      };

      $scope.service_verify = function(id) {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifySer.service_verify(id).then(function(data) {
            if (data.errcode === 0) {
              $cordovaDialogs.alert('您已经成功验证该服务', '温馨提示', '好的').then(function() {
                // $scope.user_services = activityVerifySer.getUserServices();
                $scope.doRefresh();
              });
            } else if (data.errcode == -1) {
              $cordovaDialogs.confirm('您尚未登录哦', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                if (buttonIndex == 1) {
                  if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                    $state.go('tab.login');
                  } else {
                    $state.go('tab.login-other');
                  }
                }
              });
            } else if (data.errcode == -2) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function() {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $cordovaDialogs.alert('请先登录', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
