(function() {
  'use strict';
  angular
    .module('activity_verify')
    .factory('activityVerifySer', function($rootScope, $ionicPlatform, $q, $http, API, $ionicLoading, $ionicPopup, $cordovaDialogs, $cordovaBarcodeScanner, $state, $location) {
      var user_services = JSON.parse(localStorage.getItem('bj12351.user_services')) || [];
      var u_token = '';
      var result = '';

      //JSON校验
      function isJSON(str) {
        if (typeof(str) == 'string') {
          try {
            var obj = JSON.parse(str);
            if (typeof(obj) == 'object' && obj) {
              return true;
            } else {
              return false;
            }
          } catch (e) {
            console.log('error：' + str + '!!!' + e);
            return false;
          }
        }
      }

      function convertAward(award_apply_id, award_id, member_id, award_type, send_type) {
        var q = $q.defer();
        $ionicLoading.show({
          template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
        });
        $http.get(API.getHost() + '/credits/convert.jsp?token=' + localStorage.getItem('bj12351.token') + '&award_apply_id=' + award_apply_id + '&award_id=' + award_id + '&member_id = ' + member_id + '&award_type=' + award_type + '&send_type=' + send_type, {
            timeout: 10000
          })
          .success(function(data) {
            q.resolve(data);
          })
          .error(function(error) {
            q.reject(error);
          })
          .finally(function() {
            $ionicLoading.hide();
          });
        return q.promise;
      }

      return {
        getUserServices: function() {
          return user_services;
        },
        getUToken: function() {
          return u_token;
        },
        //扫码
        worker_verify: function(token, u_token) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/service/user-service-list.jsp', {
              token: token,
              u_token: u_token
            }, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                user_services = data;
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        scan: function() {
          var self = this;
          var q = $q.defer();
          if ($rootScope.is_scan) {
            q.reject({
              "errcode": -1,
              "errmsg": ""
            });
            return;
          }
          $rootScope.is_scan = true;
          $cordovaBarcodeScanner.scan().then(function(imageData) {
              if (!imageData.cancelled) {
                switch (imageData.format) {
                  case 'QR_CODE':
                    if (imageData.text !== undefined || imageData.text !== null || imageData.text !== '') {
                      if (!isJSON(imageData.text)) {
                        self.worker_verify(localStorage.getItem('bj12351.token'), imageData.text).then(function(data) {
                          if (data.errcode === undefined) {
                            u_token = imageData.text;
                            user_services = data;
                          }
                          q.resolve(data);
                        }, function(err) {
                          q.reject();
                        });
                      } else {
                        result = JSON.parse(imageData.text);
                        convertAward(result.award_apply_id, result.award_id, result.member_id, 2, 2).then(function(data) {
                          $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
                          q.resolve(data);
                        }, function(err) {
                          q.reject();
                        });
                      }
                    }
                    break;
                }
              } else {
                q.reject();
              }
            }, function(error) {
              if (error == 'Illegal access') {
                $cordovaDialogs.alert('访问摄像头的权限已被禁用，请前往设置开启', '温馨提示', '好的');
              } else {
                $cordovaDialogs.alert(error, '温馨提示', '好的');
              }
              q.reject();
            })
            .finally(function() {
              $rootScope.is_scan = false;
            });
          return q.promise;
        },
        //验证服务
        service_verify: function(apply_id) {
          // var _this = this;
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });

          $http.post(API.getHost() + '/service/verify-service.jsp', {
              apply_id: apply_id,
              token: localStorage.getItem('bj12351.token')
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
