(function() {
  'use strict';

  angular
    .module('activity_verify_live')
    .controller('activityVerifyLiveCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicHistory, $state, templateUrlPath, activityVerifyLiveSer) {
      $scope.search = {};
      $scope.search.name = '';

      $scope.services = {};

      var page = 1;
      var size = 10;

      // /**强制显示返回按钮**/
      // $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
      //   viewData.enableBack = true;
      // });

      /**刷新**/
      $scope.refresh = function() {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifyLiveSer.refreshServices($scope.search.name, 1, size).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '暂未发布活动。',
                    duration: 1000
                  });
                } else if (data.length < size) {
                  $scope.hasMore = false;
                } else {
                  $scope.hasMore = true;
                }
                page = 2;
                $scope.services = data;
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };
      $scope.refresh();

      //手动刷新
      $scope.doRefresh = function() {
        $scope.search.name = '';
        $scope.refresh();
      };

      /**更多**/
      $scope.more = function() {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifyLiveSer.moreServices($scope.search.name, page, size).then(function(data) {
              if (data.errcode == undefined) {
                if (data.length == 0) {
                  $ionicLoading.show({
                    template: '没有更多服务。',
                    duration: 1000
                  });
                  $scope.hasMore = false;
                } else if (data.length < size) {
                  $scope.hasMore = false;
                }
                page++;
                $scope.services = $scope.services.concat(data);
              } else if (data.errcode == -1) {
                $scope.hasMore = false;
                $cordovaDialogs.confirm('您的登录已失效，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
                  if (buttonIndex == 1) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                });
              } else {
                $scope.hasMore = false;
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        } else {
          $cordovaDialogs.confirm('您还没有登录，是否现在登录。', '温馨提示', ['现在登录', '稍后登录']).then(function(buttonIndex) {
            if (buttonIndex == 1) {
              if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                $state.go('tab.login');
              } else {
                $state.go('tab.login-other');
              }
            } else {
              $ionicHistory.goBack();
            }
          });
        }
      };

      $scope.live_scan_verify = function(service_id) {
        if (localStorage.getItem('bj12351.token')) {
          activityVerifyLiveSer.scan(service_id);
        } else {
          $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
            if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
              $state.go('tab.login');
            } else {
              $state.go('tab.login-other');
            }
          });
        }
      };
      // $scope.live_scan_verify = function(batch_id) {
      //   if (localStorage.getItem('bj12351.token')) {
      //     activityVerifyLiveSer.scan(batch_id).then(function(data) {
      //       console.log('data', data);
      //       if (data.errcode === undefined) {
      //         if (data.length === 0) {
      //           $ionicLoading.show({
      //             template: '暂没有需要验证的服务。',
      //             duration: 1000
      //           });
      //           return;
      //         } else {
      //           //$state.go('tab.activity_services');
      //           u_token = activityVerifyLiveSer.getUToken();
      //           $scope.user_services = data;
      //           $scope.openModal('activity_scan_live');
      //         }
      //
      //       }
      //     });
      //   } else {
      //     $cordovaDialogs.alert('请先登录。', '温馨提示', '好的').then(function() {
      //       if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
      //         $state.go('tab.login');
      //       } else {
      //         $state.go('tab.login-other');
      //       }
      //     });
      //   }
      // };

      /***模板方法*/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'search_service') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

      $scope.submitModal = function(modal_name) {
        $scope.refresh();
        $scope.modal[modal_name].remove();
      };

    });
})();
