(function() {
  'use strict';
  angular
    .module('activity_verify_live')
    .factory('activityVerifyLiveSer', function($rootScope, $q, $ionicLoading, API, $http, $cordovaBarcodeScanner, $ionicPopup, $state) {

      //现场领取
      function scan_live(token, u_token, service_id) {
        service_id = service_id || 0;
        var q = $q.defer();
        $ionicLoading.show({
          template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
        });
        $http.post(API.getHdHost() + '/check/worker-live-verify.jsp', {
            token: token,
            u_token: u_token,
            service_id: service_id
          }, {
            timeout: 10000
          })
          .success(function(data) {
            q.resolve(data);
          })
          .error(function(error) {
            q.reject(error);
          })
          .finally(function() {
            $ionicLoading.hide();
          });
        return q.promise;
      }

      //验证
      function doCheck(u_token, service_id) {
        if (localStorage.getItem('bj12351.token')) {
          scan_live(localStorage.getItem('bj12351.token'), u_token, service_id).then(function(data) {
            if (data.errcode === 0) {
              $ionicPopup.alert({
                title: '温馨提示',
                template: '恭喜！该会员是第' + data.number + '位参加此活动的会员',
                buttons: [{
                  text: '好的',
                  type: 'button-positive'
                }]
              });
            } else if (data.errcode == -1) {
              $ionicPopup.confirm({
                title: '温馨提示',
                template: '您尚未登录哦。',
                buttons: [{
                  text: '稍后登录'
                }, {
                  text: '现在登录',
                  type: 'button-positive',
                  onTap: function(e) {
                    if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                      $state.go('tab.login');
                    } else {
                      $state.go('tab.login-other');
                    }
                  }
                }]
              });
            } else if (data.errcode == -2) {
              $ionicPopup.alert({
                title: '温馨提示',
                template: data.errmsg,
                buttons: [{
                  text: '好的',
                  type: 'button-positive'
                }]
              });
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else {
          $ionicPopup.confirm({
            title: '温馨提示',
            template: '您尚未登录哦。',
            buttons: [{
              text: '稍后登录'
            }, {
              text: '现在登录',
              type: 'button-positive',
              onTap: function(e) {
                // $location.path('/tab/login');
                if (localStorage.getItem('bj12351.is_gesture_pwd') === "true") {
                  $state.go('tab.login');
                } else {
                  $state.go('tab.login-other');
                }
              }
            }]
          });
        }
      }


      return {
        refreshServices: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/worker-live-service-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },

        moreServices: function(service_name, page, size) {
          var q = $q.defer();
          $http.get(API.getHost() + '/service/worker-live-service-list.jsp?token=' + localStorage.getItem('bj12351.token') + '&service_name=' + service_name + '&page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        scan: function(service_id) {
          if ($rootScope.is_scan) {
            return;
          }
          $rootScope.is_scan = true;
          $cordovaBarcodeScanner.scan().then(function(imageData) {
              if (!imageData.cancelled) {
                switch (imageData.format) {
                  case 'QR_CODE':
                    localStorage.setItem('bj12351.scan_result_type', '二维码');
                    doCheck(imageData.text, service_id);
                    break;
                  case 'EAN_13':
                    localStorage.setItem('bj12351.scan_result', imageData.text);
                    localStorage.setItem('bj12351.scan_result_type', '条形码');
                    $state.go('tab.scanResult');
                    break;
                }
              }
            }, function(error) {
              if (error == 'Illegal access') {
                $cordovaDialogs.alert('访问摄像头的权限已被禁用，请前往设置开启', '温馨提示', '好的');
              } else {
                $cordovaDialogs.alert(error, '温馨提示', '好的');
              }
            })
            .finally(function() {
              $rootScope.is_scan = false;
            });
        }
      };
    });
})();
