(function() {
  'use strict';
  angular
    .module('workerInfoColl')
    .controller('workerInfoCollCtrl', function($scope, $state, $ionicHistory, $cordovaDialogs, $ionicModal, tools, $ionicLoading, manageOrgSer, workerInfoCollSer, templateUrlPath, mySer, worker_inquiry_detailSer) {
      var user = mySer.getUserInfo();

      /**初始化默认值**/
      function initAryDefault(ary) {
        ary = ary.unshift({
          "code": "0",
          "name": '必选项'
        });
        return ary;
      }

      /*性别*/
      $scope.gender = [{
        "code": '1',
        "name": "男"
      }, {
        "code": '2',
        "name": "女"
      }];
      initAryDefault($scope.gender);

      /*居民类型*/
      $scope.resident = JSON.parse(localStorage.getItem('bj12351.ct_resident_type'));
      initAryDefault($scope.resident);

      /*现居住地*/
      $scope.address = JSON.parse(localStorage.getItem('bj12351.ct_area_beijing'));
      initAryDefault($scope.address);

      /*就业状态*/
      $scope.work_status = JSON.parse(localStorage.getItem('bj12351.ct_work_status'));
      initAryDefault($scope.work_status);

      /*学历*/
      $scope.education = JSON.parse(localStorage.getItem('bj12351.ct_education'));
      initAryDefault($scope.education);

      /*技能等级*/
      $scope.skill = JSON.parse(localStorage.getItem('bj12351.ct_skill'));
      initAryDefault($scope.skill);

      /*是否外来务工人员*/
      $scope.migrant = JSON.parse(localStorage.getItem('bj12351.ct_migrant'));
      initAryDefault($scope.migrant);

      $scope.worker = {};
      $scope.worker.gender = $scope.gender[0];
      $scope.worker.cer_type = "身份证";
      $scope.worker.country = "中华人民共和国";
      $scope.worker.resident = $scope.resident[0];
      $scope.worker.address = $scope.address[0];
      $scope.worker.work_status = $scope.work_status[0];
      $scope.worker.education = $scope.education[0];
      $scope.worker.skill = $scope.skill[0];
      $scope.worker.migrant = $scope.migrant[0];
      $scope.worker.phone = "";
      $scope.worker.contact = "";

      $scope.search = {};
      $scope.select = {};
      $scope.orgList = [];
      $scope.entList = [];
      /**搜索工会**/
      $scope.searchOrg = function() {
        if ($scope.search.name == '' || $scope.search.name == undefined) {
          $cordovaDialogs.alert('请您输入工会名称进行搜索', '温馨提示', '好的');
          return;
        }
        worker_inquiry_detailSer.searchUnionSubOrg($scope.search.name, user.module1.org_id).then(function(data) {
          if (data.errcode == undefined) {
            $scope.orgList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**选择工会**/
      $scope.selectOrg = function(entList, targetOrg) {
        $scope.entList = entList;
        $scope.select.org = targetOrg;
        $scope.select.ent = "";
        $scope.openModal('select_ent');
      };

      /**无覆盖单位**/
      $scope.selectOrgNone = function() {
        $cordovaDialogs.alert('该工会下没有覆盖单位，暂时无法转入。', '温馨提示', '好的');
      };

      /**选择单位**/
      $scope.selectEnt = function() {
        if (!$scope.select.ent) {
          $cordovaDialogs.alert("请选择单位", '温馨提示', '好的');
          return;
        }
        $scope.worker.org = $scope.select.org;
        $scope.worker.company = $scope.select.ent;
        $scope.closeModal('select_ent');
        $scope.closeModal('select_org');
      };

      /**提交**/
      $scope.doSubmit = function() {
        if (!$scope.worker.org) {
          $cordovaDialogs.alert('请选择所属工会', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.company) {
          $cordovaDialogs.alert('请重新选择所属工会', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.name) {
          $cordovaDialogs.alert('请填写姓名', '温馨提示', '好的');
          return;
        } else if ($scope.worker.gender.code == 0) {
          $cordovaDialogs.alert('请选择性别', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.cer_num || tools.verCertNum($scope.worker.cer_num) < 0) {
          $cordovaDialogs.alert('请填写正确证件号', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.cer_time_begin || tools.verDate($scope.worker.cer_time_begin) < 0) {
          $cordovaDialogs.alert('请正确填写证件有效起始日期，如：1990-01-01', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.cer_time_end || tools.verDate($scope.worker.cer_time_end) < 0) {
          $cordovaDialogs.alert('请正确填写证件有效截止日期，如：1990-01-01', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.birth || tools.verDate($scope.worker.birth) < 0) {
          $cordovaDialogs.alert('请正确填写出生日期，如：1990-01-01', '温馨提示', '好的');
          return;
        } else if ($scope.worker.resident.code == 0) {
          $cordovaDialogs.alert('请选择居民类型', '温馨提示', '好的');
          return;
        } else if ($scope.worker.address.code == 0) {
          $cordovaDialogs.alert('请选择现居住地', '温馨提示', '好的');
          return;
        } else if ($scope.worker.member_time && tools.verDate($scope.worker.member_time) < 0) {
          $cordovaDialogs.alert('请正确填写入会时间，如：1990-01-01', '温馨提示', '好的');
          return;
        } else if ($scope.worker.work_status.code == 0) {
          $cordovaDialogs.alert('请选择就业状态', '温馨提示', '好的');
          return;
        } else if ($scope.worker.education.code == 0) {
          $cordovaDialogs.alert('请选择学历', '温馨提示', '好的');
          return;
        } else if ($scope.worker.skill.code == 0) {
          $cordovaDialogs.alert('请选择技能等级', '温馨提示', '好的');
          return;
        } else if (!$scope.worker.phone && !$scope.worker.contact) {
          $cordovaDialogs.alert('手机号码和其他联系方式必填其一', '温馨提示', '好的');
          return;
        } else if ($scope.worker.phone && tools.verMobile($scope.worker.phone) < 0) {
          $cordovaDialogs.alert('请正确填写手机号码', '温馨提示', '好的');
          return;
        } else if ($scope.worker.migrant.code == 0) {
          $cordovaDialogs.alert('请选择是否外来务工人员', '温馨提示', '好的');
          return;
        }
        workerInfoCollSer.doSubmit($scope.worker.org.orgName, $scope.worker.company.enterName, $scope.worker.name, $scope.worker.gender.code, $scope.worker.cer_num, $scope.worker.cer_time_begin, $scope.worker.cer_time_end, $scope.worker.birth, $scope.worker.resident.code, $scope.worker.address.code, $scope.worker.member_time, $scope.worker.work_status.code, $scope.worker.education.code, $scope.worker.skill.code, $scope.worker.phone, $scope.worker.contact, $scope.worker.migrant.code).then(function(data) {
          if (data.errcode == 0) {
            $cordovaDialogs.alert('信息采集成功', '温馨提示', '好的');
            $ionicHistory.goBack(-1);
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert("登录失效，请重新登录", '温馨提示', '好的');
            return;
          } else {
            if (data.status <= -20) {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            } else {
              $cordovaDialogs.alert("网络异常，请稍后重试", '温馨提示', '好的');
            }
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'select_org') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
