(function() {
  'use strict';
  angular
    .module('worker_inquiry_detail')
    .controller('worker_inquiry_detailCtrl', function($scope, $state, $stateParams, $ionicHistory, $ionicModal, $ionicLoading, $location, $cordovaDialogs, templateUrlPath, worker_inquiry_detailSer, manageOrgSer) {
      var user = JSON.parse(localStorage.getItem('bj12351.user'));
      var orgId = 0;
      $scope.orgName = "";

      $scope.inquiry = {};
      $scope.inquirySearchId = $stateParams.inquirySearchId;

      if ($scope.inquirySearchId == 1) {
        $scope.title = "会员信息详细数据";
        $scope.orgName = user.module1.org_name;
        orgId = user.module1.org_id;
      } else if ($scope.inquirySearchId == 2) {
        $scope.title = "服务项目详细数据";
        $scope.orgName =  user.module2.org_name;
        orgId = user.module2.org_id;
      } else if ($scope.inquirySearchId == 3) {
        $scope.title = "派单信息详细数据";
        $scope.orgName =  user.module4.org_name;
        orgId = user.module4.org_id;
      } else if ($scope.inquirySearchId == 4) {//功能隐藏
        $scope.title = "暖·互助信息详细数据";
      } else if ($scope.inquirySearchId == 5) {//功能隐藏
        $scope.title = "技能助推详细数据";
      } else if ($scope.inquirySearchId == 6) {
        $scope.title = "专职信息详细数据";
        $scope.orgName =  user.module5.org_name;
        orgId = user.module5.org_id;
      }

      var today = new Date();
      today.setTime(today.getTime() - 24 * 60 * 60 * 1000);
      $scope.yesterday = today.getFullYear() + "-" + (today.getMonth() + 1) + "-" + today.getDate();

      /**选择工会**/
      $scope.search = {};
      $scope.select = {};
      $scope.select.orgId = orgId;
      $scope.orgList = [];

      /**搜索工会**/
      $scope.searchOrg = function() {
        if ($scope.search.name == '' || $scope.search.name == undefined) {
          $cordovaDialogs.alert('请您输入工会名称进行搜索', '温馨提示', '好的');
          return;
        }

        if ($scope.inquirySearchId == 1) { //会员管理
          worker_inquiry_detailSer.searchUnionSubOrg($scope.search.name, orgId).then(function(data) {
            if (data.errcode == undefined) {
              $scope.orgList = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        } else { //会员服务
          worker_inquiry_detailSer.searchMemSerSubOrg($scope.search.name, orgId).then(function(data) {
            if (data.errcode == undefined) {
              $scope.orgList = data;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          });
        }
      };

      /**选择工会**/
      $scope.selectOrg = function(entList, targetOrg) {
        $scope.closeModal('select_org');
        $scope.orgName = targetOrg.orgName;
        $scope.select.orgId = targetOrg.orgId;
        $scope.statistics($scope.select.orgId);
      };

      /**无覆盖单位**/
      $scope.selectOrgNone = function(targetOrg) {
        $scope.selectOrg('', targetOrg);
      };

      /**统计**/
      $scope.unionist = {}; //会员信息采集
      $scope.memService = {}; //工会会员服务
      $scope.hotline = {}; //12351职工服务热线平台
      $scope.mutual = {}; //暖互助
      $scope.jnzt = {}; //技能助推
      $scope.social = {}; //专职社会工作者

      $scope.statistics = function(orgId) {
        if ($scope.inquirySearchId == 1) { //会员信息采集
          worker_inquiry_detailSer.statisInfoColl(orgId).then(function(data) {
              if (data.errcode == 0) {
                $scope.unionist = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else if ($scope.inquirySearchId == 2) { //工会会员服务
          worker_inquiry_detailSer.statisMemService(orgId).then(function(data) {
              if (data.errcode == undefined) {
                $scope.memService = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else if ($scope.inquirySearchId == 3) { //12351职工服务热线平台
          worker_inquiry_detailSer.statisHotline().then(function(data) {
              if (data.errcode == 0) {
                $scope.hotline = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else if ($scope.inquirySearchId == 4) { //暖互助
        } else if ($scope.inquirySearchId == 5) { //技能助推 已关闭功能
          worker_inquiry_detailSer.statisJnzt().then(function(data) {
              if (data.errcode == undefined) {
                $scope.jnzt = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        } else if ($scope.inquirySearchId == 6) { //专职社会工作者
          worker_inquiry_detailSer.statisSocial().then(function(data) {
              if (data.errcode == 0) {
                $scope.social = data;
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            })
            .finally(function() {
              $scope.$broadcast('scroll.refreshComplete');
            });
        }
      };
      $scope.statistics(orgId);

      /**刷新**/
      $scope.refresh = function() {
        $scope.statistics($scope.select.orgId);
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-right'
        };
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
