(function() {
  'use strict';
  angular
    .module('worker_inquiry_detail')
    .factory('worker_inquiry_detailSer', function($http, API, $q, $ionicLoading) {

      return {
        //统计会员信息采集请况
        statisInfoColl: function(orgId) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/statistics_member.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&org_id=' + orgId, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //统计工会会员服务情况
        statisMemService: function(orgId) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/statistics_member_services.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&org_id=' + orgId, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //统计12351职工服务热线平台运行情况
        statisHotline: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/statistics_rxpd.jsp' +
              '?token=' + localStorage.getItem('bj12351.token'), {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //统计暖·互助信息
        statisMutual: function() {},

        //统计技能助推
        statisJnzt: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/statistics_jnzt.jsp' +
              '?token=' + localStorage.getItem('bj12351.token'), {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //统计专职工会社会工作者情况
        statisSocial: function() {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/statistics_worker_info.jsp' +
              '?token=' + localStorage.getItem('bj12351.token'), {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //搜索会员服务下级工会
        searchMemSerSubOrg: function(name, orgId) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/memservice_search_org.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&name=' + name +
              '&org_id=' + orgId, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        //搜索会员管理下级工会
        searchUnionSubOrg: function(name, orgId) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.get(API.getHost() + '/statistics/unionist_search_org.jsp' +
              '?token=' + localStorage.getItem('bj12351.token') +
              '&name=' + name +
              '&org_id=' + orgId, {
                timeout: 10000
              })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }

      };
    });
})();
