(function() {
  'use strict';

  angular
    .module('workerMemOperate')
    .factory('workerMemOperateSer', function($http, $q, API, $ionicLoading) {
      var store = {};
      return {
        getStore: function() {
          return store;
        },

        clearStore: function() {
          store = {};
        },

        refreshMemInfo: function(type, card_id) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/query_member.jsp', {
              token: localStorage.getItem('bj12351.token'),
              type: type,
              card_id: card_id
            }, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode == 0) {
                store = data;
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        },

        doSubmit: function(orgName, entName, name, certNo, type, postingTime, foundation, reason) {
          var q = $q.defer();
          $ionicLoading.show({
            template: '<ion-spinner icon="android" class="spinner-light"></ion-spinner>'
          });
          $http.post(API.getHost() + '/user/add_member_ship.jsp', {
              token: localStorage.getItem('bj12351.token'),
              org_name: orgName,
              ent_name: entName,
              name: name,
              cert_no: certNo,
              type: type,
              posting_time: postingTime,
              foundation: foundation,
              reason: reason
            }, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            })
            .finally(function() {
              $ionicLoading.hide();
            });
          return q.promise;
        }
      };
    });
})();
