(function() {
  'use strict';
  angular
    .module('workerMemOperateDetail')
    .controller('workerMemOperateDetailCtrl', function($scope, $location, $stateParams, $ionicLoading, $ionicHistory, $cordovaDialogs, $ionicModal, manageOrgSer, templateUrlPath, workerMemOperateSer, tools, worker_inquiry_detailSer) {
      var user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.operateType = $stateParams.type;

      //转入原因
      var enroll = [{
        "value": "2",
        "name": "工作变更"
      }, {
        "value": "3",
        "name": "原单位破产、安置到本单位再就业"
      }, {
        "value": "4",
        "name": "原单位破产、再就业单位无工会组织"
      }, {
        "value": "5",
        "name": "再就业新单位无工会组织"
      }];

      //保留原因
      var keep = [{
        "value": "6",
        "name": "会员失业"
      }, {
        "value": "7",
        "name": "正式退休"
      }];

      //转出原因
      var outroll = [{
        "value": "8",
        "name": "工作变更"
      }, {
        "value": "9",
        "name": "单位破产"
      }];

      //除名原因
      var remove = [{
        "value": "10",
        "name": "开除会籍"
      }];

      //退会原因
      var quit = [{
        "value": "11",
        "name": "自动退会"
      }, {
        "value": "12",
        "name": "会员死亡"
      }];

      $scope.title = "";
      $scope.placeholder = "与服务卡号必填其一";
      $scope.reason = "";
      $scope.selects = [];
      switch ($scope.operateType) {
        case "1":
          $scope.title = "会籍转入";
          $scope.placeholder = "必填项";
          $scope.reason = "转入关系的原因";
          $scope.selects = enroll;
          break;
        case "2":
          $scope.title = "会籍保留";
          $scope.reason = "保留会籍的原因";
          $scope.selects = keep;
          break;
        case "3":
          $scope.title = "会籍转出";
          $scope.reason = "转出关系的原因";
          $scope.selects = outroll;
          break;
        case "4":
          $scope.title = "会籍除名";
          $scope.reason = "开除会籍的原因";
          $scope.selects = remove;
          break;
        case "5":
          $scope.title = "会籍退会";
          $scope.reason = "退会的原因";
          $scope.selects = quit;
          break;
        default:
          break;
      }
      $scope.btnName = $scope.title.substr(2, 4);

      $scope.operate = {};
      $scope.operate.enrollOrgName = "";
      $scope.operate.enrollEnterName = "";
      $scope.operate.reason = $scope.selects[0];
      var store = workerMemOperateSer.getStore();

      if (store) {
        $scope.operate.name = store.name;
        $scope.operate.certNum = store.cert_no;
        if (store.org_name) {
          var orgListArr = store.org_name.split(',');
          orgListArr.pop();
          orgListArr.reverse();
          $scope.operate.crtOrg = orgListArr.toString().replace(/,/g, '>');
        }
        $scope.operate.crtEnter = store.company || '暂无';
      }

      //创建图片验证码
      $scope.operate.verCodeShow = tools.createVerCode();
      $scope.reVerCode = function() {
        $scope.operate.verCodeShow = tools.createVerCode();
      };

      //校验验证码
      $scope.checkCode = function() {
        return tools.verifyVerCode($scope.operate.verCodeShow, $scope.operate.verCodeInput);
      };

      /**搜索 查询会员身份**/
      $scope.operateSearch = function() {
        var certType = 2;
        var certNum = '';
        if ($scope.operate.searchCertNum) {
          certType = 1;
          certNum = $scope.operate.searchCertNum;
          if (tools.verCertNum($scope.operate.searchCertNum) < 0) {
            $cordovaDialogs.alert('请输入正确身份证', '温馨提示', '好的');
            return;
          }
        } else {
          certNum = $scope.operate.searchCardNum;
        }

        if($scope.operateType == 1){//转入时certType固定传3
          certType = 3;
        }

        workerMemOperateSer.refreshMemInfo(certType, certNum).then(function(data) {
          if (data.errcode == 0) {
            $scope.operate.name = data.name;
            $scope.operate.certNum = data.cert_no;
            $scope.operate.crtOrg = data.org_name;
            $scope.operate.crtEnter = data.company;
            $location.path('/tab/worker/member-operate/' + $scope.operateType + '/detail');
          } else if (data.errcode == -1) {
            $cordovaDialogs.alert('登录失效，请重新登录', '温馨提示', '好的');
            return;
          } else if (data.errcode == -2) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            return;
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      $scope.search = {};
      $scope.select = {};
      $scope.orgList = [];
      $scope.entList = [];

      /**搜索工会**/
      $scope.searchOrg = function() {
        if ($scope.search.name == '' || $scope.search.name == undefined) {
          $cordovaDialogs.alert('请您输入工会名称进行搜索', '温馨提示', '好的');
          return;
        }

        worker_inquiry_detailSer.searchUnionSubOrg($scope.search.name, user.module1.org_id).then(function(data) {
          if (data.errcode == undefined) {
            $scope.orgList = data;
          } else {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
          }
        }, function(error) {
          $ionicLoading.show({
            template: '网络繁忙，请稍后重试。',
            duration: 1000
          });
        });
      };

      /**选择工会**/
      $scope.selectOrg = function(entList, targetOrg) {
        $scope.entList = entList;
        $scope.select.org = targetOrg;
        $scope.select.ent = "";
        $scope.openModal('select_ent');
      };

      /**无覆盖单位**/
      $scope.selectOrgNone = function() {
        $cordovaDialogs.alert('该工会下没有覆盖单位，暂时无法转入。', '温馨提示', '好的');
      };

      /**选择单位**/
      $scope.selectEnt = function() {
        if (!$scope.select.ent) {
          $cordovaDialogs.alert("请选择单位", '温馨提示', '好的');
          return;
        }
        $scope.operate.enrollOrgName = $scope.select.org.orgName;
        $scope.operate.enrollEnterName = $scope.select.ent.enterName;
        $scope.closeModal('select_ent');
        $scope.closeModal('select_org');
      };

      /**提交操作**/
      $scope.doSubmit = function() {
        if ($scope.operateType == 1) {
          if (!$scope.operate.enrollOrgName || !$scope.operate.enrollEnterName) {
            $cordovaDialogs.alert("请重新选择工会", '温馨提示', '好的');
            return;
          }
        }
        if (!$scope.operate.date || tools.verDate($scope.operate.date) < 0) {
          $cordovaDialogs.alert('请正确填写变迁时间，如：2016-01-01', '温馨提示', '好的');
          return;
        }

        $cordovaDialogs.confirm('您确定提交操作吗？', '温馨提示：', ['确定', '取消']).then(function(buttonIndex) {
          if (buttonIndex == 1) {
            workerMemOperateSer.doSubmit($scope.operate.enrollOrgName, $scope.operate.enrollEnterName, $scope.operate.name, $scope.operate.certNum, $scope.operateType, $scope.operate.date, $scope.operate.reason.value, $scope.operate.remark).then(function(data) {
              if (data.errcode == 0) {
                $cordovaDialogs.alert("会籍操作成功", '温馨提示', '好的');
                $ionicHistory.goBack();
              } else if (data.errcode == -1) {
                $cordovaDialogs.alert("登录失效，请重新登录", '温馨提示', '好的');
              } else {
                $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
              }
            }, function(error) {
              $ionicLoading.show({
                template: '网络繁忙，请稍后重试。',
                duration: 1000
              });
            });
          }
        });
      };

      /**模板方法**/
      $scope.modal = {};
      $scope.openModal = function(modal_name) {
        if (!!$scope.modal[modal_name] && $scope.modal[modal_name]._isShown) {
          return;
        }
        var options = {
          scope: $scope,
          animation: 'slide-in-up'
        };
        if (modal_name == 'select_org') {
          options.animation = 'slide-in-right';
        }
        $ionicModal.fromTemplateUrl(templateUrlPath + 'modules/modals/' + modal_name + '.html', options).then(function(modal) {
          $scope.modal[modal_name] = modal;
          $scope.modal[modal_name].show();
        });
      };

      $scope.closeModal = function(modal_name) {
        $scope.modal[modal_name].remove();
      };

    });
})();
