(function() {
  'use strict';

  angular
    .module('charge_insurance')
    .controller('chargeInsuranceCtrl', function($scope, $ionicLoading, $cordovaDialogs, $ionicHistory, $stateParams, templateUrlPath, chargeInsuranceSer) {
      var chargeInsFirst = true;//首次加载
      var chargeclaimFirst = true;
      var secClaimFirst = true;
      $scope.current_tab = 1;

      $scope.user = JSON.parse(localStorage.getItem('bj12351.user'));
      $scope.entName = $scope.user.company;
      $scope.orgName = "";
      $scope.fullOrgCode = "";

      $scope.chargeInsList = [];
      $scope.chargeClaimList = [];
      $scope.secClaimList = [];

      /**刷新全部**/
      $scope.refresh = function(type) {
        var staticType = "all";
        if (type == 1) {
          staticType = "charge_insurance";
        } else if (type == 2) {
          staticType = "charge_claim";
        } else if (type == 3) {
          staticType = "sec_claim";
        }

        chargeInsuranceSer.refresh(staticType, $scope.user.phone).then(function(data) {
            if (data.errcode == undefined) {
              $scope.orgName = data.org_name;
              $scope.fullOrgCode = data.full_org_code;

              if (data.charge_ins.length != 0) {
                $scope.chargeInsList = data.charge_ins;
              }
              if (data.charge_claim.length != 0) {
                $scope.chargeClaimList = data.charge_claim;
              }
              if (data.sec_claim.length != 0) {
                $scope.secClaimList = data.sec_claim;
              }
            } else if (data.errcode == -1) {
              $cordovaDialogs.alert("登录失效，请重新登录", '温馨提示', '好的');
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };

      $scope.checkChargeIns = function(){
        if(chargeInsFirst){
          $scope.refresh(1);
          chargeInsFirst = false;
        }
      };
      $scope.checkChargeIns();

      $scope.checkChargeClaim = function(){
        if(chargeclaimFirst){
          $scope.refresh(2);
          chargeclaimFirst = false;
        }
      };

      $scope.checkSecIns = function(){
        if(secClaimFirst){
          $scope.refresh(3);
          secClaimFirst = false;
        }
      };
      // $scope.checkSecIns();

    });
})();
