(function() {
  'use strict';

  angular
    .module('tax_check')
    .controller('taxCheckCtrl', function($scope, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicActionSheet, $ionicHistory, $state, $cordovaCamera, $cordovaFileTransfer, templateUrlPath, API) {
      $scope.check = {};

      /**修改头像**/
      $scope.changeHeadImg = function() {
        $ionicActionSheet.show({
          cancelOnStateChange: true,
          cssClass: 'action_s',
          titleText: "请选择头像获取方式",
          buttons: [{
            text: '相机'
          }, {
            text: '图库'
          }],
          cancelText: '取消',
          cancel: function() {
            return true;
          },
          buttonClicked: function(index) {
            switch (index) {
              case 0:
                //$scope.takePhoto();
                break;
              case 1:
                //  $scope.pickImage();
                break;
              default:
                break;
            }
            return true;
          }
        });
      };

      /**拍照**/
      $scope.takePhoto = function() {
        var options = {
          quality: 100, //图片质量 1-100
          destinationType: Camera.DestinationType.FILE_URI, //返回值格式
          sourceType: Camera.PictureSourceType.CAMERA,
          saveToPhotoAlbum: true
        };

        $cordovaCamera.getPicture(options).then(function(imageURI) { //Success
          $scope.imageSrc = imageURI;
          $scope.uploadPhoto();
        }, function(err) { // Error
        });
      };

      /**选择照片**/
      $scope.pickImage = function() {
        var options = {
          quality: 100,
          destinationType: Camera.DestinationType.FILE_URI, //Choose the format of the return value.
          sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM
        };

        $cordovaCamera.getPicture(options).then(function(imageURI) { //Success
          $scope.imageSrc = imageURI;
          alert('imageURI:' + imageURI);
          $scope.uploadPhoto();
        }, function(err) { // Error
        });
      };

      /**上传图片**/
      $scope.uploadPhoto = function() {
        var server = encodeURI(API.getHost() + '/upload_pic.jsp?token=' + localStorage.getItem('bj12351app.token'));
        var fileURL = $scope.imageSrc;
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.chunkedMode = false;
        options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";

        var fileTrans = $cordovaFileTransfer.upload(server, fileURL, options).then(function(result) {
          $ionicLoading.hide();
          var data = JSON.parse(result.response);
          if (data.errcode === 0) {
            $cordovaDialogs.alert('图片上传成功', '上传图片', '确定').then(function() {

            });
          } else if (data.errcode === -1) {
            $cordovaDialogs.alert(data.errmsg, '温馨提示', '确定').then(function() {
              $state.go('tab.homeLogin');
            });
          } else {
            $cordovaDialogs.alert(data.errmsg, '更换图片', '确定');
          }
        }, function(err) {
          $ionicLoading.hide();
          alert("err:" + JSON.stringify(err));
          $cordovaDialogs.alert('系统错误', '添加图片', '确定');
        }, function(progress) {
          var loaded = Math.floor(parseInt((progress.loaded / progress.total) * 100));
          $ionicLoading.show({
            template: '正在上传：' + loaded + '%'
          });
        });
      };

      function verify_union_time(union_time) {
        var regex = /^(\d{4})-(\d{2})-(\d{2})$/;
        console.log(regex.test(union_time));
        return regex.test(union_time);
      }

      $scope.check_info = function() {
        if ($scope.check.company === '' || $scope.check.company === undefined) {
          $cordovaDialogs.alert('请填写公司名称', '温馨提示', '好的');
          return;
        }
        if ($scope.check.com_address === '' || $scope.check.com_address === undefined) {
          $cordovaDialogs.alert('请填写经营地址', '温馨提示', '好的');
          return;
        }
        if ($scope.check.contacts === '' || $scope.check.contacts === undefined) {
          $cordovaDialogs.alert('请填写联系人', '温馨提示', '好的');
          return;
        }
        if ($scope.check.contact_no === '' || $scope.check.contact_no === undefined) {
          $cordovaDialogs.alert('请填写联系电话', '温馨提示', '好的');
          return;
        }
        if ($scope.check.union_status === '' || $scope.check.union_status === undefined) {
          $cordovaDialogs.alert('请填写建会状态', '温馨提示', '好的');
          return;
        }
        if ($scope.check.union_time === '' || $scope.check.union_time === undefined) {
          $cordovaDialogs.alert('请填写建会时间', '温馨提示', '好的');
          return;
        }
        if ($scope.check.union_time !== '' && !verifyMember_time($scope.check.union_time)) {
          $cordovaDialogs.alert('请正确填写建会时间，如：2018-02-07', '温馨提示', '好的');
          return;
        }
        $cordovaDialogs.alert('已核准！', '温馨提示', '好的');
      };
    });
})();
