(function() {
  'use strict';

  angular
    .module('training')
    .controller('workerTrainingCtrl', function($scope, $state, $stateParams, $ionicModal, $ionicLoading, $cordovaDialogs, $ionicPopover, templateUrlPath, trainingSer) {
      $scope.courseList = trainingSer.getTrainingList();
      $scope.search = {};
      $scope.search.name = '';

      /**刷新**/
      var page = 1;
      var size = 10;
      $scope.hasMore = $scope.courseList.length >= size;
      $scope.refresh = function() {

        trainingSer.refreshTrainingList(1, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '暂无培训。',
                  duration: 1000
                });
              } else if (data.length < size) {
                $scope.hasMore = false;
              } else {
                $scope.hasMore = true;
              }
              page = 2;
              $scope.courseList = data;
              $scope.list_length = $scope.courseList.length;
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
          });
      };
      $scope.refresh();

      /**更多**/
      $scope.more = function() {
        trainingSer.moreTrainingList(page, size).then(function(data) {
            if (data.errcode == undefined) {
              if (data.length == 0) {
                $ionicLoading.show({
                  template: '无更多培训。',
                  duration: 1000
                });
                $scope.hasMore = false;
              } else if (data.length < size) {
                $scope.hasMore = false;
              }
              page++;
              $scope.courseList = $scope.courseList.concat(data);
            } else {
              $cordovaDialogs.alert(data.errmsg, '温馨提示', '好的');
            }
          }, function(error) {
            $ionicLoading.show({
              template: '网络繁忙，请稍后重试。',
              duration: 1000
            });
          })
          .finally(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          });
      };

      function stopDefault(e) {
        if (e && e.preventDefault)
          e.preventDefault();
        else
          window.event.returnValue = false;
      }

      /**切换详情显示状态**/
      $scope.hideCourse = function(index, e) {
        stopDefault(e);
        $scope.courseList[index].hideDetail = !$scope.courseList[index].hideDetail;
      };

    });
})();
