(function() {
  'use strict';
  angular
    .module('training')
    .factory('trainingSer', function($q, $http, API, $ionicLoading) {
      var trainingList = JSON.parse(localStorage.getItem('bj12351.trainingList')) || [];
      return {
        getTrainingList: function() {
          return trainingList;
        },
        refreshTrainingList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getPortalBjzghHost() + '/training/list.jsp?page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              if (data.errcode === undefined) {
                trainingList = data;
                localStorage.setItem('bj12351.trainingList', JSON.stringify(data));
              }
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        },
        moreTrainingList: function(page, size) {
          var q = $q.defer();
          $http.get(API.getPortalBjzghHost() + '/training/list.jsp?page=' + page + '&size=' + size, {
              timeout: 10000
            })
            .success(function(data) {
              q.resolve(data);
            })
            .error(function(error) {
              q.reject(error);
            });
          return q.promise;
        }
      };
    });
})();
